
	format	PE console

include 'win32a.inc'
include 'file formats/mz/structures/dos header.inc'
include 'file formats/pe coff/structures/nt headers.inc'

section '.text' code readable executable

start:

	mov	[con_handle], STD_OUTPUT_HANDLE

	call	get_params
	jc	information

	cmp	[bNoLogo], 0
	jnz	no_logo
	mov	esi, _logo
	call	display_string
    no_logo:

	mov	esi, [input_file]
	mov	edx, esi
	call	open
	jc	main_file_not_found

	mov	al, FILE_END
	xor	edx, edx
	call	lseek
	jc	main_file_too_large
	cmp	eax, eax
	jz	main_file_is_empty
	mov	[insize], eax
	push	eax
	call	allocate_memory
	mov	[infile], eax
	mov	edx, eax
	pop	ecx
	call	read
	call	filetimes
	call	close

	cmp	[insize], 44
	jb	unktype
	mov	eax, [infile]
	cmp	dword [eax], 'KEx'
	jnz	notkex
	test	byte [eax+5], 20h
	setnz	dl
	test	byte [eax+5], 1
	jnz	@f
	add	dl, 3
    @@:
	jmp	typeok
notkex:
	cmp	[insize], 64
	jb	unktype
	cmp	word [eax+IMAGE_DOS_HEADER.e_magic], 'MZ'
	jnz	unktype
	mov	ecx, [eax+IMAGE_DOS_HEADER.e_lfanew]
	cmp	ecx, -78h
	jc	unktype
	lea	eax, [eax+ecx]
	cmp	dword [eax+IMAGE_NT_HEADERS.Signature], 'PE'
	jnz	unktype
	test	word [eax+IMAGE_NT_HEADERS.FileHeader.Characteristics], $2000 ;IMAGE_FILE_DLL
	setnz	dl
	cmp	word [eax+IMAGE_NT_HEADERS.FileHeader.Machine], $14C ; IMAGE_FILE_MACHINE_I386
	jnz	notpe32
	cmp	word [eax+IMAGE_NT_HEADERS.OptionalHeader.Magic], $10B ; IMAGE_NT_OPTIONAL_HDR32_MAGIC
	jnz	unktype
	jmp	@f
notpe32:
	cmp	word [eax+IMAGE_NT_HEADERS.FileHeader.Machine], $8664; IMAGE_FILE_MACHINE_AMD64
	jnz	unktype
	cmp	word [eax+IMAGE_NT_HEADERS.OptionalHeader.Magic], $20B ; IMAGE_NT_OPTIONAL_HDR64_MAGIC
	jnz	unktype
	add	dl, 3
@@:
typeok:
	inc	edx
	mov	[filetype], dl
unktype:
	cmp	[bDriver], 0
	jz	@f
	cmp	[filetype], 2
	jz	isdriver
	cmp	[filetype], 5
	jz	isdriver
	mov	esi, _driver_ignor_notify
	call	display_string
	jmp	@f
isdriver:
	inc	[filetype]
    @@:
	mov	eax, [insize]
	lea	eax, [eax+eax*8+$2000]
	shr	eax, 3 ; $400 + 1.125*size
	mov	esi, eax
	add	eax, eax
	call	allocate_memory
	mov	[outfile], eax
	mov	[outfile1], eax
	mov	[outfilebest], eax
	add	eax, esi
	mov	[outfile2], eax
	sub	eax, esi
	mov	dword [eax], 'KPCK'
	mov	ecx, [insize]
	mov	dword [eax+4], ecx
	dec	ecx
	bsr	eax, ecx
	inc	eax
	cmp	eax, 28
	jb	short @f
	mov	eax, 28
@@:
	push	eax
	invoke	lzma_set_dict_size, eax
	pop	ecx
	mov	eax, 1
	shl	eax, cl
	mov	[lzma_dictsize], eax
	imul	eax, 19
	shr	eax, 1
	add	eax, $509000
	call	allocate_memory
	mov	[workmem], eax
	mov	esi, _compressing_notify
	call	display_string
	mov	eax, [outfile2]
	mov	[outfile], eax
	xchg	eax, edi
	mov	esi, [outfile1]
	movsd
	movsd
	call	pack_lzma
; UNFINISHED
pack_lzma:

information:
	cmp	[bNoLogo], 0
	jnz	no_usage
	mov	esi, _logo
	call	display_string
	mov	esi, _usage
	call	display_string
    no_usage:
	mov	al, 1
	jmp	exit_program

get_params:
	mov	[input_file], 0
	mov	[output_file], 0
	mov	[bNoLogo], 0
	mov	[bDriver], 0
	;mov	 [passes_limit], 100
	call	[GetCommandLine]
	mov	esi, eax
	mov	edi, params
    find_command_start:
	lodsb
	cmp	al, ' '
	je	find_command_start
	cmp	al, '"'
	je	skip_quoted_name
    skip_name:
	lodsb
	cmp	al, ' '
	je	find_param
	or	al, al
	jz	all_params
	jmp	skip_name
    skip_quoted_name:
	lodsb
	cmp	al, '"'
	je	find_param
	or	al, al
	jz	all_params
	jmp	skip_quoted_name
    find_param:
	lodsb
	cmp	al, ' '
	je	find_param
	cmp	al, '/'
	je	option_param
	cmp	al, $D
	je	all_params
	or	al, al
	jz	all_params
	cmp	[input_file], 0
	jne	get_output_file
	mov	[input_file], edi
	jmp	process_param
      get_output_file:
	cmp	[output_file], 0
	jne	bad_params
	mov	[output_file], edi
    process_param:
	cmp	al, '"'
	je	string_param
    copy_param:
	cmp	edi, params+1000h
	jae	bad_params
	stosb
	lodsb
	cmp	al, ' '
	je	param_end
	cmp	al, $D
	je	param_end
	or	al, al
	jz	param_end
	jmp	copy_param
    string_param:
	lodsb
	cmp	al, '"'
	je	string_param_end
	cmp	al, $D
	je	param_end
	or	al, al
	jz	param_end
	cmp	edi, params+1000h
	jae	bad_params
	stosb
	jmp	string_param
    option_param:
	dec	esi
	mov	eax, [esi]
	or	eax, '    '	;to lowercase
	cmp	eax, '/nol'
	jnz	@F
	mov	eax, [esi+4]
	and	eax, not '    ' ;to uppercase (space to zero)
	cmp	eax, 'OGO'
	jnz	bad_params
	mov	[bNoLogo], 1
    nextkey:
	add	esi, 7
	jmp	find_param
    @@:
	cmp	eax, '/dri'
	jnz	bad_params
	mov	eax, [esi+4]
	and	eax, not '    ' ;to uppercase (space to zero)
	cmp	eax, 'VER'
	jnz	bad_params
	mov	[bDriver], 1
	jmp	nextkey
    bad_params:
	stc
	ret
    param_end:
	dec	esi
    string_param_end:
	cmp	edi, params+1000h
	jae	bad_params
	xor	al, al
	stosb
	jmp	find_param
    all_params:
	cmp	[input_file], 0
	je	bad_params
	clc
	ret

include 'system.inc'
include '..\errors.inc'
include '..\messages.inc'

section '.data' data readable writeable
; hello strings
_logo  db 'KPack - Kolibri Packer, version 0.2',$D,$A
       db 'Uses LZMA v4.32 compression library',0

_usage db $D,$A
       db 'Written by diamond in 2006, 2007, 2009 specially for KolibriOS',$D,$A
       db 'LZMA compression library is copyright (c) 1999-2005 by Igor Pavlov',$D,$A
       db $D,$A
       db 'usage: kpack [/nologo] [/driver] <infile> [<outfile>]',$D,$A
       db 0
; inform strings

; error strings
error_prefix db 'error: ',0
error_suffix db '.'

align 4

con_handle dd ?
bytes_count dd ?

include '..\kpack_common.inc'

params rb 1000h

section '.idata' import data readable writeable

  library kernel,'KERNEL32.DLL',\
	  lzma,'lzma'

  import kernel,\
	 CloseHandle,'CloseHandle',\
	 CreateFile,'CreateFileA',\
	 ExitProcess,'ExitProcess',\
	 GetCommandLine,'GetCommandLineA',\
	 GetFileSize,'GetFileSize',\
	 GetFileTime,'GetFileTime',\
	 GetStdHandle,'GetStdHandle',\
	 GetSystemTime,'GetSystemTime',\
	 GetTickCount,'GetTickCount',\
	 ReadFile,'ReadFile',\
	 SetFilePointer,'SetFilePointer',\
	 SetFileTime,'SetFileTime',\
	 VirtualAlloc,'VirtualAlloc',\
	 VirtualFree,'VirtualFree',\
	 WriteFile,'WriteFile'

  import lzma,\
	 lzma_compress,'lzma_compress',\
	 lzma_set_dict_size,'lzma_set_dict_size'

section '.reloc' fixups data readable discardable