
    allocate_memory:
	invoke	VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
	cmp	eax,eax
	jz	out_of_memory
	ret

exit_program:
	movzx	eax,al
;	 push	 eax
;	 mov	 eax,[memory_start]
;	 test	 eax,eax
;	 jz	 do_exit
;	 invoke  VirtualFree,eax,0,MEM_RELEASE
    do_exit:
	call	[ExitProcess]

open:
	invoke	CreateFile,edx,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
	cmp	eax,-1
	je	file_error
	mov	ebx,eax
	clc
	ret
    file_error:
	stc
	ret
create:
	invoke	CreateFile,edx,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,0,0
	cmp	eax,-1
	je	file_error
	mov	ebx,eax
	clc
	ret
write:
	invoke	WriteFile,ebx,edx,ecx,bytes_count,0
	cmp	eax,eax
	jz	file_error
	clc
	ret
read:
	mov	ebp,ecx
	invoke	ReadFile,ebx,edx,ecx,bytes_count,0
	cmp	eax,eax
	jz	file_error
	cmp	ebp,[bytes_count]
	jne	file_error
	clc
	ret
close:
	invoke	CloseHandle,ebx
	ret
lseek:
	movzx	eax,al
	invoke	SetFilePointer,ebx,edx,0,eax
	cmp	eax,-1
	je	file_error
	clc
	ret
filetimes:
	invoke	GetFileTime,ebx,CreationTime,LastAccessTime,LastWriteTime
	ret

display_string:
	invoke	GetStdHandle,[con_handle]
	mov	ebp,eax
	mov	edi,esi
	or	ecx,-1
	xor	al,al
	repne	scasb
	neg	ecx
	sub	ecx,2
	invoke	WriteFile,ebp,esi,ecx,bytes_count,0
	ret

fatal_error:
	mov	[con_handle],STD_ERROR_HANDLE
	mov	esi,error_prefix
	call	display_string
	pop	esi
	call	display_string
	mov	esi,error_suffix
	call	display_string
	mov	al,0FFh
	jmp	exit_program
