
; Component Object Model usage demonstration

format PE GUI 4.0 dll
entry DllEntryPoint

include 'win32a.inc'

include '../common blocks/required stuff.inc'

section '.text' code readable executable

DllEntryPoint: procedure(hinstDLL,fdwReason,lpvReserved)
	mov	eax, [fdwReason+espFixer]
	cmp	eax, 1
	jne	.retTRUE
	mov	eax, [hinstDLL+espFixer]
	mov	[hInstance],eax
	invoke	DisableThreadLibraryCalls, eax
	invoke	HeapCreate,HEAP_NO_SERIALIZE,$1000,0
	mov	[pHeap],eax
      .retTRUE:
	xor	eax, eax
	inc	eax
	ret
endp

DllGetClassObject: procedure(rclsid,riid,ppv) ; returned requested ClassFactory!!! not COMobject itself
	push	ebx
	mov	ebx, [ppv+espFixer]
	test	ebx, ebx
	jz	.ret_E_POINTER
	xor	eax, eax
	mov	[ebx], eax

	precmpGUID			      ; search ClassFactory corresponded to rclsid
	cld
	cmpGUID [rclsid+espFixer],lpCLSID_QuickRegister
	postcmpGUID

	jnz	.ret_CLASS_E_CLASSNOTAVAILABLE
	comcall QRClassFactory_COMobject,IUnknown,QueryInterface,[riid+espFixer],ebx
	jmp	.locret
      .ret_E_POINTER:
	mov	eax, E_POINTER
	jmp	.locret
      .ret_CLASS_E_CLASSNOTAVAILABLE:
	mov	eax, CLASS_E_CLASSNOTAVAILABLE
      .locret:
	pop	ebx
	ret
endp

DllCanUnloadNow: procedure()
	xor	eax,eax
	cmp	eax,[ServerLockCount]
	jz	.locret
	inc	eax
      .locret:
	ret
endp

__RegCreateKeyWithValue: procedure(lpSubKey,lpValueName,lpData)

	; calc length of Pchar(edi) to ecx
	cld
	mov	edi, [lpData+espFixer]
	mov	ecx, -1
	xor	eax, eax
	repne	scasb
	not	ecx
	sub	edi, ecx

	prepare RegSetValueEx, eax, [lpValueName+espFixer], eax, REG_SZ, edi, ecx
	;invoke  RegCreateKey, [RootKey], [lpSubKey+espFixer], esp ; working on XP and below version used instead of next two lines; need testing for win10
	mov	edi, esp
	invoke	RegCreateKeyEx, [RootKey], [lpSubKey+espFixer], eax, eax, REG_OPTION_NON_VOLATILE, KEY_READ or KEY_WRITE, eax, edi, eax
	test	eax, eax
	jnz	.unstack
	invoke	RegSetValueEx; stack prepared with prepare
	if espFixer
		espFixer=espFixer-$18
	end if
	mov	edi, eax
	sub	esp, 24       ; again stack is ready
	invoke	RegCloseKey
	mov	eax,edi
	add	esp, 20
	jmp	.locret
      .unstack:
	unstack RegSetValueEx,hKey,lpValueName,Reserved,dwType,lpData,cbData
      .locret:
	ret
endp

DllRegisterServer: procedure()
	push	edi
	mov	[RootKey], HKEY_CLASSES_ROOT
	stdcall __RegCreateKeyWithValue, CLSIDStr, NullStr, CLSIDDescription
	test	eax, eax
	jnz	.unregister
	invoke	GetModuleFileName, [hInstance], REGFileName, 261
	test	eax, eax
	jz	.unregister
	stdcall __RegCreateKeyWithValue, CLSIDInprocServer, NullStr, REGFileName
	test	eax, eax
	jnz	.unregister
	stdcall __RegCreateKeyWithValue, CLSIDInprocServer, ThreadingModelStr, ApartmentStr
	test	eax, eax
	jnz	.unregister
	stdcall __RegCreateKeyWithValue, dllfile_shellex_Str, NullStr, NullStr
	test	eax, eax
	jnz	.unregister
	stdcall __RegCreateKeyWithValue, dllfile_shellex_CMH_Str, NullStr, NullStr
	test	eax, eax
	jnz	.unregister
	stdcall __RegCreateKeyWithValue, dllfile_shellex_CMH_QR_Str, NullStr, CLSIDString_QuickRegister
	test	eax, eax
	jnz	.unregister
	mov	[RootKey], HKEY_LOCAL_MACHINE
	stdcall __RegCreateKeyWithValue, cur_vers_shellex_Str, NullStr, NullStr
	test	eax, eax
	jnz	.ret_S_FALSE
	stdcall __RegCreateKeyWithValue, cur_vers_shellex_approv_Str, CLSIDString_QuickRegister, CLSIDDescription
	jmp	.locret
      .ret_S_FALSE:
	xor	eax, eax
	inc	eax
	jmp	.locret
      .unregister:
	stdcall DllUnregisterServer
	invoke	MessageBox, 0, ErrUpdRegistry, REGFileName, MB_ICONERROR or MB_OK
	mov	eax, SELFREG_E_CLASS
      .locret:
	pop	edi
	ret
endp

DllUnregisterServer: procedure()
	mov	[RootKey], HKEY_CLASSES_ROOT
	invoke	RegDeleteKey, [RootKey], dllfile_shellex_CMH_QR_Str
	invoke	RegDeleteKey, [RootKey], dllfile_shellex_CMH_Str
	invoke	RegDeleteKey, [RootKey], dllfile_shellex_Str
	invoke	RegDeleteKey, [RootKey], CLSIDInprocServer
	invoke	RegDeleteKey, [RootKey], CLSIDStr
	ret
endp

QRClassFactory@QueryInterface: procedure(Self,riid,ppvObject)
	push	ebx
	mov	ebx, [ppvObject+espFixer]
	test	ebx, ebx
	jz	.ret_E_POINTER
	xor	eax, eax
	mov	[ebx], eax

	precmpGUID
	cld
	cmpGUID [riid+espFixer],lpIID_IUnknown
	je	.cmp_done
	cmpGUID [riid+espFixer],lpIID_IClassFactory
      .cmp_done:
	postcmpGUID

	jnz	.ret_E_NOINTERFACE
	mov	eax, [Self+espFixer]
	mov	[ebx], eax
	comcall eax, IClassFactory, AddRef
	xor	eax, eax
	jmp	.locret
      .ret_E_POINTER:
	mov	eax, E_POINTER
	jmp	.locret
      .ret_E_NOINTERFACE:
	mov	eax, E_NOINTERFACE
      .locret:
	pop	ebx
	ret
endp

QRClassFactory@AddRef: procedure(Self)
	invoke	InterlockedIncrement, ServerLockCount
	mov	eax, 2
	ret
endp

QRClassFactory@Release: procedure(Self)
	invoke	InterlockedDecrement, ServerLockCount
	xor	eax, eax
	inc	eax
	ret
endp

QRClassFactory@CreateInstance: procedure(Self,pUnkOuter,riid,ppvObject)
	push	ebx
	mov	ebx, [ppvObject+espFixer]
	test	ebx, ebx
	jz	.ret_E_POINTER
	xor	eax, eax
	mov	[ebx], eax

	cmp	eax, [pUnkOuter+espFixer]
	jnz	.ret_CLASS_E_NOAGGREGATION

	invoke	HeapAlloc,[pHeap], 0, sizeof.current_COMobject
	test	eax, eax
	jz	.ret_E_OUTOFMEMORY
	push	eax
	invoke	HeapAlloc, [pHeap], 0, 261
	test	eax, eax
	jz	.free_ret_E_OUTOFMEMORY
	pop	edx
	mov	dword[eax], 0
	xchg	esp, edx
	add	esp, sizeof.current_COMobject
	push	eax
	push	0
	push	ShellExtInit
	push	ContextMenu
	xchg	esp, edx

	push	edx
	push	eax

	comcall edx,IUnknown,QueryInterface,[riid+espFixer],ebx
	cmp	eax, 0
	jl	.ret_E_FAIL

	pop	ebx
	pop	ebx

	invoke	InterlockedIncrement, ServerLockCount
	jmp	.locret

      .free:
	pop	ebx
	push	0
	push	[pHeap]
	push	ebx
	jmp	[HeapFree]

      .ret_E_POINTER:
	mov	eax, E_POINTER
	jmp	.locret

      .ret_CLASS_E_NOAGGREGATION:
	mov	eax, CLASS_E_NOAGGREGATION
	jmp	.locret

      .free_ret_E_OUTOFMEMORY:
	call	.free
      .ret_E_OUTOFMEMORY:
	mov	eax, E_OUTOFMEMORY
	jmp	.locret

      .ret_E_FAIL:
	call	.free
	call	.free
	mov	eax, E_FAIL

      .locret:
	pop	ebx
	ret
endp

QRClassFactory@LockServer: procedure(Self,fLock)
	mov	eax,[fLock+espFixer]
	lea	eax,[.interlocked+eax*4]
	invoke	eax, ServerLockCount
	xor	eax, eax
	ret
	dd	InterlockedIncrement ; on case of -1 bool
      .interlocked:
	dd	InterlockedDecrement
	dd	InterlockedIncrement
endp

ContextMenu@QueryInterface: procedure(Self,riid,ppvObject)
	push	ebx
	mov	ebx, [ppvObject+espFixer]
	test	ebx, ebx
	jz	.ret_E_POINTER
	xor	eax, eax
	mov	[ebx], eax
	mov	eax, [Self+espFixer]
	precmpGUID
	cld
	cmpGUID [riid+espFixer],lpIID_IUnknown
	je	.cmp_done
	cmpGUID [riid+espFixer],lpIID_IContextMenu
	je	.cmp_done
	cmpGUID [riid+espFixer],lpIID_IShellExtInit
	jne	.cmp_done
	lea	eax, [eax+4]
      .cmp_done:
	postcmpGUID

	jnz	.ret_E_NOINTERFACE
	mov	[ebx], eax
	comcall eax, IUnknown, AddRef
	xor	eax, eax
	jmp	.locret
      .ret_E_POINTER:
	mov	eax, E_POINTER
	jmp	.locret
      .ret_E_NOINTERFACE:
	mov	eax, E_NOINTERFACE
      .locret:
	pop	ebx
	ret
endp

ContextMenu@AddRef: procedure(Self)
	mov	eax, [Self+espFixer]
	add	eax, current_COMobject.RefCount
	invoke	InterlockedIncrement, eax
	ret
endp

ContextMenu@Release: procedure(Self) ;verified
	mov	eax, [Self+espFixer]
	add	eax, current_COMobject.RefCount
	invoke	InterlockedDecrement, eax
	test	eax, eax
	jnz	.locret
	push	ebx
	mov	eax, [Self+espFixer]
	push	eax
	push	[eax+current_COMobject.lpFileName]
	call	QRClassFactory@CreateInstance.free
	call	QRClassFactory@CreateInstance.free
	pop	ebx
	invoke	InterlockedDecrement, ServerLockCount
      .locret:
	ret
endp

ContextMenu@QueryContextMenu: procedure(Self,Menu,indexMenu,idCmdFirst,idCmdLast,uFlags) ;verified
	mov	eax, [uFlags+espFixer]
	and	eax, $F
	jz	.handle
	test	eax, CMF_EXPLORE
	jnz	.ret_S_OK
      .handle:
	push	ebx
	push	esi
	push	edi
	mov	ebx, [Menu+espFixer]
	mov	esi, [indexMenu+espFixer]
	mov	edi, [idCmdFirst+espFixer]
	invoke	InsertMenu, ebx, esi, MF_SEPARATOR or MF_BYPOSITION, 0, 0
	inc	esi
	invoke	InsertMenu, ebx, esi, MF_STRING or MF_BYPOSITION, edi, lpRegMenu
	inc	esi
	inc	edi
	invoke	InsertMenu, ebx, esi, MF_STRING or MF_BYPOSITION, edi, lpUnregMenu
	inc	esi
	invoke	InsertMenu, ebx, esi, MF_SEPARATOR or MF_BYPOSITION, 0, 0
	mov	eax, 2
	pop	edi
	pop	esi
	pop	ebx
	jmp	.locret
      .ret_S_OK:
	xor	eax, eax
      .locret:
	ret
endp

RegisterCOMServer: procedure(dll_proc,hwnd,dll_file)
	invoke	LoadLibrary, [dll_file+espFixer]
	test	eax, eax
	jz	.ret_S_FALSE
	push	eax
	invoke	GetProcAddress, eax, [dll_proc+espFixer]
	test	eax, eax
	jnz	.call
      .ret_S_FALSE_n_FREE:
	invoke	FreeLibrary
	xor	eax, eax
	jmp	.ret_S_FALSE
      .call:
	call	eax
	cmp	eax, 0
	jl	.ret_S_FALSE_n_FREE
	invoke	FreeLibrary
	xor	eax, eax
	jmp	.locret
      .ret_S_FALSE:
	inc	eax
      .locret:
	ret 0
endp

MessagingInvokeCommand: procedure(fmt,fError,ProcName,hwnd,Filename)
	cinvoke wsprintf, Buffer, [fmt+espFixer], [ProcName+espFixer], [Filename+espFixer]
	mov	eax, [fError+espFixer]
	invoke	MessageBox,[hwnd+espFixer],Buffer,[QRCases+eax*4],[MBCases+eax*4]
	mov	eax, [fError+espFixer]
	ret
endp

ContextMenu@InvokeCommand: procedure(Self,lpici)
	mov	eax, [Self+espFixer]
	push	[eax+current_COMobject.lpFileName]

	mov	eax, [lpici+espFixer]
	push	[eax+CMINVOKECOMMANDINFO.hwnd]
	mov	eax, [eax+CMINVOKECOMMANDINFO.lpVerb]
	cmp	eax, 1
	ja	.ret_E_INVALIDARG
	push	[ProcNames+eax*4]
	call	RegisterCOMServer
	push	eax
	push	[FmtCases+eax*4]

	call	MessagingInvokeCommand
	test	eax, eax
	jz	.locret
	mov	eax, E_FAIL
	jmp	.locret
      .ret_E_INVALIDARG:
	pop	eax
	pop	eax
	mov	eax, E_INVALIDARG
      .locret:
	ret
endp

ContextMenu@GetCommandString: procedure(Self,idCmd,uType,pwReserved,pszName,cchMax)
	mov	eax, [uType+espFixer]
	cmp	eax, GCS_HELPTEXT
	jne	.ret_S_OK
	mov	eax, [idCmd+espFixer]
	cmp	eax, 1
	ja	.ret_E_INVALIDARG

	;stdcall StrCopy, [pszName], [HintCases+eax*4]
	push	esi
	push	edi
	cld
	mov	edi, [HintCases+eax*4]
	mov	ecx, -1
	xor	eax, eax
	repne	scasb
	not	ecx
	sub	edi, ecx
	mov	esi, edi
	mov	edi, [pszName+espFixer]
	mov	eax, ecx
	shr	ecx, 2
	rep	movsd
	mov	ecx, eax
	and	ecx, 3
	rep	movsb
	pop	edi
	pop	esi

      .ret_S_OK:
	xor	eax, eax
	jmp	.locret
      .ret_E_INVALIDARG:
	mov	eax, E_INVALIDARG
      .locret:
	ret
endp

ShellExtInit@QueryInterface: procedure(Self,riid,ppvObject)
	mov	eax, [Self+espFixer]
	sub	eax, current_COMobject.SE
	comcall eax, IUnknown, QueryInterface, [riid+espFixer], [ppvObject+espFixer]
	ret
endp

ShellExtInit@AddRef: procedure(Self)
	mov	eax, [Self+espFixer]
	sub	eax, current_COMobject.SE
	comcall eax, IUnknown, AddRef
	ret
endp

ShellExtInit@Release: procedure(Self)
	mov	eax, [Self+espFixer]
	sub	eax, current_COMobject.SE
	comcall eax, IUnknown, Release
	ret
endp

ShellExtInit@Initialize: procedure(Self, pidlFolder, lpdobj, hKeyProgID)
	mov	eax, [lpdobj+espFixer]
	test	eax, eax
	jz	.ret_E_INVALIDARG
	comcall eax, IDataObject, GetData, FormatETC, StgMedium
	cmp	eax, 0
	jl	.ret_E_FAIL
	;xor	 eax, eax
	;mov	 [FileName_COMfield], al
	invoke	DragQueryFile, [StgMedium.hGlobal], -1, 0, 0
	cmp	eax, 1
	jne	.ret_E_FAIL
	mov	eax, [Self+espFixer]
	invoke	DragQueryFile, [StgMedium.hGlobal], 0, [eax+current_COMobject.lpFileName-current_COMobject.SE], 261
	invoke	ReleaseStgMedium, StgMedium
	xor	eax, eax
	jmp	.locret

      .ret_E_INVALIDARG:
	mov	eax, E_INVALIDARG
	jmp	.locret

      .ret_E_FAIL:
	mov	eax, E_FAIL

      .locret:
	ret
endp

section '.data' data readable writeable

include '../common blocks/IIDs, Vtables and etc.inc'

 StgMedium			STGMEDIUM

 ProcNames			dd lpRegProc, lpUnregProc
 FmtCases			dd fmtSuccessed, fmtFailed
 MBCases			dd MB_ICONINFORMATION or MB_OK,MB_ICONERROR or MB_OK
 QRCases			dd cptSuccessed,cptFailed
 HintCases			dd lpRegHint,lpUnregHint
 RootKey			dd ?
 pHeap				dd ?
 hInstance			dd ?

include '../common blocks/DllRegisterStrings.inc'

include '../common blocks/COMlogicStrings.inc'

 fmtInt 			db '%08X',0
 REGFileName db 261 dup ?
 FileName_COMfield db 261 dup ?
 Buffer db 300 dup ?

section '.idata' import data readable

  library kernel32,'KERNEL32.DLL',\
	  user32,'USER32.DLL',\
	  shell32,'SHELL32.DLL',\
	  advapi32,'ADVAPI32.DLL',\
	  ole32,'OLE32.DLL'

  import kernel32,\
	 DisableThreadLibraryCalls,'DisableThreadLibraryCalls',\
	 FreeLibrary,'FreeLibrary',\
	 GetModuleFileName,'GetModuleFileNameA',\
	 GetProcAddress,'GetProcAddress',\
	 InterlockedDecrement,'InterlockedDecrement',\
	 InterlockedIncrement,'InterlockedIncrement',\
	 HeapAlloc,'HeapAlloc',\
	 HeapCreate,'HeapCreate',\
	 HeapFree,'HeapFree',\
	 LoadLibrary,'LoadLibraryA'

  import user32,\
	 InsertMenu,'InsertMenuA',\
	 MessageBox,'MessageBoxA',\
	 wsprintf,'wsprintfA'

  import shell32,\
	 DragQueryFile,'DragQueryFileA'

  import advapi32,\
	 RegCloseKey,'RegCloseKey',\
	 RegCreateKey,'RegCreateKeyA',\
	 RegCreateKeyEx,'RegCreateKeyExA',\
	 RegDeleteKey,'RegDeleteKeyA',\
	 RegSetValueEx,'RegSetValueExA'

  import ole32,\
	 ReleaseStgMedium,'ReleaseStgMedium'

section '.edata' export data readable

  export 'COMSERVEXAMPLE.DLL',\
	 DllGetClassObject,'DllGetClassObject',\
	 DllCanUnloadNow,'DllCanUnloadNow',\
	 DllRegisterServer,'DllRegisterServer',\
	 DllUnregisterServer,'DllUnregisterServer'

section '.reloc' fixups data readable discardable
