
format PE GUI 4.0
entry start

;IPPROTO_TCP		= 6
;IPPROTO_DEFAULT	= 0

;AF_INET		= 2

;INVALID_SOCKET 	= -1

;SOCKET_ERROR		= -1

;SHTDWN_SEND		= 1

IP"127.0.0.1" = 127 + 0 shl 8 + 0 shl 16 + 1 shl 24

major equ +
minor equ +256*

include 'win32w.inc'

section '.text' code readable executable

  start:

	invoke	WSAStartup, major(2) minor(2), wsaData
	test	eax, eax
	jz	WSAStartupOK
	cinvoke wsprintf, _error, fmt_WSAError, eax
	jmp	error
  WSAStartupOK:

	mov	ax, [wsaData.wVersion]
	cmp	ax, major(2) minor(2)
	jz	WSAVersionOK
	xor	ecx, ecx
	mov	cl, ah
	movzx	eax, al
	cinvoke wsprintf, _error, fmt_WSAVersion, eax, ecx
	jmp	error
  WSAVersionOK:

	invoke	socket, AF_INET, SOCK_STREAM, IPPROTO_TCP
	cmp	eax, INVALID_SOCKET
	jnz	validSOCKET
	cinvoke wsprintf, _error, fmt_INVALID_SOCKET
  validSOCKET:
	mov	[hSocket], eax

	invoke	connect, eax, hClientService, sizeof.sockaddr
	cmp	eax, SOCKET_ERROR
	jnz	successCONN
	cinvoke wsprintf, _error, fmt_CONN_FAILED
	invoke	closesocket, [hSocket]
	jmp	error
  successCONN:

  processSENDbuffer:
	; some action
	cinvoke wsprintf, _sendbuf, _sendbufdata
	cinvoke wsprintf, _sendbufdata, _null

  loopSEND:
	invoke	send, eax, _sendbuf, _sendbuf.sz, 0
	cmp	eax, 0;LAST_LOOP
	jg	processSENDbuffer
	je	successSEND
	cinvoke wsprintf, _error, fmt_SEND_FAILED
	invoke	closesocket, [hSocket]
	jmp	error
  successSEND:
	;eax has number of sent bytes

	invoke	shutdown, [hSocket], SHTDWN_SEND
	cmp	eax, SOCKET_ERROR
	jnz	successSHUT
	cinvoke wsprintf, _error, fmt_SHUT_FAILED
	invoke	closesocket, [hSocket]
	jmp	error
  successSHUT:
	jmp	loopRECV

  processRECVbuffer:
	; do something

  loopRECV:
	invoke	recv, [hSocket], _recvbuf, _recvbuf.sz, 0
	cmp	eax,0;LAST_LOOP
	jg	processRECVbuffer
	je	successSEND
	cinvoke wsprintf, _error, fmt_RECV_FAILED
	jmp	error
  successRECV:


	invoke	closesocket, [hSocket]
	cmp	eax, SOCKET_ERROR
	jnz	go_exit
	cinvoke wsprintf, _error, fmt_CLOSE_FAILED
  error:
	invoke	MessageBox,NULL,_error,NULL,MB_ICONERROR+MB_OK

  go_exit:
	invoke	WSACleanup
	invoke	ExitProcess,0

section '.data' data readable writeable

  _class TCHAR 'FASMWIN32',0
  _title TCHAR 'Win32 program template',0
  fmt_WSAError TCHAR 'error: WSAStartup failed: %d\n',0
  fmt_WSAVersion TCHAR 'error: WSAStartup version: %d_%d\n',0
  fmt_INVALID_SOCKET TCHAR 'error: can`t open socket',0
  fmt_CONN_FAILED TCHAR 'error: connection failed',0
  fmt_SEND_FAILED TCHAR 'error: sending failed',0
  fmt_SHUT_FAILED TCHAR 'error: shutdown failed',0
  fmt_RECV_FAILED TCHAR 'error: sending failed',0
  fmt_CLOSE_FAILED TCHAR 'error: close failed',0
  _error TCHAR $100 dup (?)
  _sendbufdata ACHAR 'Client: sending data test',0;,0 - is trailing zero needed or not?
  _null ACHAR 0

align 4

  wsaData WSADATA
  hClientService sockaddr_in AF_INET, IPPROTO_DEFAULT, IP"127.0.0.1"

  hSocket dd ?
  _sendbuf db $1000 dup (?)
  _sendbuf.sz =$-_recvbuf
  _recvbuf db $1000 dup (?)
  _recvbuf.sz =$-_recvbuf

section '.idata' import data readable writeable

  library kernel32,'KERNEL32.DLL',\
	  user32,'USER32.DLL',\
	  wsock32,'WSOCK32.DLL'

  include 'os specific/windows/api/x86/kernel32.inc'
  include 'os specific/windows/api/x86/user32.inc'
  include 'os specific/windows/api/x86/wsock32.inc'
