
; Component Object Model usage demonstration

format PE64 GUI 5.0
entry start

include 'win64a.inc'

ID_EXIT = IDCANCEL
ID_SHOW = 100
ID_HIDE = 101

IDD_COMDEMO = 1

section '.text' code readable executable

 start:
	sub	rsp,8		; Make stack dqword aligned

	invoke	CoInitialize,NULL
	invoke	CoCreateInstance,lpCLSID_TaskbarList,NULL,CLSCTX_INPROC_SERVER,lpIID_ITaskbarList,ShellTaskbar

	invoke	GetModuleHandle,0
	invoke	DialogBoxParam,rax,IDD_COMDEMO,HWND_DESKTOP,COMDemo,0

	cominvk ShellTaskbar,Release

	invoke	ExitProcess,0

proc COMDemo uses rbx, hwnd,msg,wparam,lparam
	mov	[hwnd],rcx
	cmp	edx,WM_INITDIALOG
	je	.wminitdialog
	cmp	edx,WM_COMMAND
	je	.wmcommand
	cmp	edx,WM_CLOSE
	je	.wmclose
	xor	eax,eax
	jmp	.finish
  .wminitdialog:
	jmp	.processed
  .wmcommand:
	cmp	r8,BN_CLICKED shl 16 + ID_EXIT
	je	.wmclose
	cmp	r8,BN_CLICKED shl 16 + ID_SHOW
	je	.show
	cmp	r8,BN_CLICKED shl 16 + ID_HIDE
	jne	.processed
  .hide:
	cominvk ShellTaskbar,HrInit
	cominvk ShellTaskbar,DeleteTab,[hwnd]
	jmp	.processed
  .show:
	mov	rbx,[ShellTaskbar]
	comcall rbx,ITaskbarList,HrInit
	comcall rbx,ITaskbarList,AddTab,[hwnd]
	comcall rbx,ITaskbarList,ActivateTab,[hwnd]
	jmp	.processed
  .wmclose:
	invoke	EndDialog,[hwnd],0
  .processed:
	mov	eax,1
  .finish:
	ret
endp

section '.data' data readable writeable

 lpCLSID_TaskbarList GUID CLSID_TaskbarList
 lpIID_ITaskbarList GUID IID_ITaskbarList

 ShellTaskbar ITaskbarList

section '.idata' import data readable

  library kernel,'KERNEL32.DLL',\
	  user,'USER32.DLL',\
	  ole,'OLE32.DLL'

  import kernel,\
	 GetModuleHandle,'GetModuleHandleA',\
	 ExitProcess,'ExitProcess'

  import user,\
	 DialogBoxParam,'DialogBoxParamA',\
	 EndDialog,'EndDialog'

  import ole,\
	 CoInitialize,'CoInitialize',\
	 CoCreateInstance,'CoCreateInstance'

section '.rsrc' resource data readable

  directory RT_DIALOG,dialogs

  resource dialogs,\
	   IDD_COMDEMO,LANG_ENGLISH+SUBLANG_DEFAULT,comdemo

  dialog comdemo,'Taskbar item control',70,70,170,24,WS_CAPTION+WS_POPUP+WS_SYSMENU+DS_MODALFRAME
    dialogitem 'BUTTON','Show',ID_SHOW,4,4,45,15,WS_VISIBLE+WS_TABSTOP
    dialogitem 'BUTTON','Hide',ID_HIDE,54,4,45,15,WS_VISIBLE+WS_TABSTOP
    dialogitem 'BUTTON','Exit',ID_EXIT,120,4,45,15,WS_VISIBLE+WS_TABSTOP
  enddialog
