
; Kolibri programming headers (ASCII)

datadef@directives equ db,db.kol,dw,du,dd,dp,dq,dt
datarsv@directives equ rb,rw,rd,rp,rq,rt
algnmnt@directives equ
def.rb equ db
def.rw equ dw
def.rd equ dd
def.rp equ dp
def.rq equ dq
def.rt equ dt
db.align = 1
dw.align = 2
du.align = 2
dd.align = 4
dq.align = 8

sizeof.PTR =4
struc PTR [value:?] { common . dd value }
macro PTR [value:?] { common dd value }

;====== fundamental macros ======================
include 'generic/macro/struct.inc'
include 'generic/macro/interface.inc'
include 'generic/macro/guid.inc'
;====== OS specific macros ======================
include 'os specific/kolibri/macro/proc.inc'
include 'os specific/kolibri/macro/syscall.inc'
;====== file format specific macros =============
include 'file formats/kex/macro/import.inc'
include 'file formats/kex/macro/export.inc'

struc TCHAR [val:?] { common . du val }
sizeof.TCHAR = 2
struc ACHAR [val:?] { common . db val }
sizeof.ACHAR = 1
struc WCHAR [val:?] { common . du val }
sizeof.WCHAR = 2

;====== fundamental equates =====================
include 'generic/equates/fundamental.inc'
;====== OS specific equates =====================
include 'os specific/kolibri/equates/syscalls.inc'
include 'os specific/kolibri/equates/kernel.inc'
include 'os specific/kolibri/equates/box_lib.inc'
include 'os specific/kolibri/equates/proc_lib.inc'
;====== Internet technology equates =============
include 'technologies/internet/equates/socket.inc'
include 'technologies/internet/equates/ipproto.inc'
;====== COM technology equates ==================

force@alignment equ
;====== fundamental structures ==================
include 'generic/structures/coordinates.inc'
;====== OS specific structures ==================
include 'os specific/kolibri/structures/kernel.inc'
include 'os specific/kolibri/structures/box_lib.inc'
include 'os specific/kolibri/structures/proc_lib.inc'
;====== COM technology structures ===============

;====== COM technology interfaces ===============
include 'os specific/windows/interfaces/iunknwn.inc'
