
; Win64 programming headers (ASCII)

datadef@directives equ db,dw,du,dd,dp,dq,dt
datarsv@directives equ rb,rw,rd,rp,rq,rt
algnmnt@directives equ
def.rb equ db
def.rw equ dw
def.rd equ dd
def.rp equ dp
def.rq equ dq
def.rt equ dt
db.align = 1
dw.align = 2
du.align = 2
dd.align = 4
dq.align = 8

sizeof.PTR =8
struc PTR [value:?] { common . dq value }
macro PTR [value:?] { common dq value }

;====== fundamental macros ======================
include 'generic/macro/struct.inc'
include 'generic/macro/interface.inc'
include 'generic/macro/guid.inc'
;====== OS specific macros ======================
include 'os specific/windows/macro/x86/proc64.inc'
include 'os specific/windows/macro/x86/com64.inc'
;====== file format specific macros =============
include 'file formats/pe coff/macro/import64.inc'
include 'file formats/pe coff/macro/export.inc'
include 'file formats/pe coff/macro/resource.inc'
include 'file formats/pe coff/equates/resource.inc'

struc TCHAR [val:?] { common . db val }
sizeof.TCHAR = 1
struc ACHAR [val:?] { common . db val }
sizeof.ACHAR = 1
struc WCHAR [val:?] { common . du val }
sizeof.WCHAR = 2

;====== fundamental equates =====================
include 'generic/equates/fundamental.inc'
;====== OS specific equates =====================
;====== Internet technology equates =============
include 'technologies/internet/equates/socket.inc'
include 'technologies/internet/equates/ipproto.inc'
;====== COM technology equates ==================
include 'os specific/windows/equates/com.inc'
include 'os specific/windows/equates/shobjidl_core.inc'

;====== fundamental structures ==================
include 'generic/structures/coordinates.inc'
;====== OS specific structures ==================
;====== COM technology structures ===============

;====== COM technology interfaces ===============
include 'os specific/windows/interfaces/iunknwn.inc'

