define _OBJIDL_H

interface IMarshal extends IUnknown
  GUID				00000003-0000-0000-C000-000000000046
  GetUnmarshalClass		stdmethod(IMarshal *THIS, REFIID riid, void *pv, DWORD dwDestContext, void *pvDestContext, DWORD mshlflags, CLSID *pCid):HRESULT
  GetMarshalSizeMax		stdmethod(IMarshal *THIS, REFIID riid, void *pv, DWORD dwDestContext, void *pvDestContext, DWORD mshlflags, DWORD *pSize):HRESULT
  MarshalInterface		stdmethod(IMarshal *THIS, IStream *pStm, REFIID riid, void *pv, DWORD dwDestContext, void *pvDestContext, DWORD mshlflags):HRESULT
  UnmarshalInterface		stdmethod(IMarshal *THIS, IStream *pStm, REFIID riid, void **ppv):HRESULT
  ReleaseMarshalData		stdmethod(IMarshal *THIS, IStream *pStm):HRESULT
  DisconnectObject		stdmethod(IMarshal *THIS, DWORD dwReserved):HRESULT
endi

interface INoMarshal extends IUnknown
  GUID				ECC8691B-C1DB-4DC0-855E-65F6C551AF49
endi

interface IAgileObject extends IUnknown
  GUID				94EA2B94-E9CC-49E0-C0FF-EE64CA8F5B90
endi

interface IActivationFilter extends IUnknown
  GUID				00000017-0000-0000-C000-000000000046
  HandleActivation		stdmethod(IActivationFilter *THIS, DWORD dwActivationType, REFCLSID rclsid, CLSID *pReplacementClsId):HRESULT
endi

interface IMarshal2 extends IMarshal
  GUID				000001CF-0000-0000-C000-000000000046
endi

interface IMalloc extends IUnknown
  GUID				00000002-0000-0000-C000-000000000046
  Alloc 			stdmethod(IMalloc *THIS, SIZE_T cb):HRESULT
  Realloc			stdmethod(IMalloc *THIS, void *pv, SIZE_T cb):HRESULT
  Free				stdmethod(IMalloc *THIS, void *pv):HRESULT
  GetSize			stdmethod(IMalloc *THIS, void *pv):HRESULT
  DidAlloc			stdmethod(IMalloc *THIS, void *pv):HRESULT
  HeapMinimize			stdmethod(IMalloc *THIS):HRESULT
endi

interface IStdMarshalInfo extends IUnknown
  GUID				00000018-0000-0000-C000-000000000046
  GetClassForHandler		stdmethod(IStdMarshalInfo *THIS, DWORD dwDestContext, void *pvDestContext, CLSID *pClsid):HRESULT
endi

interface IExternalConnection extends IUnknown
  GUID				00000019-0000-0000-C000-000000000046
  AddConnection 		stdmethod(IExternalConnection *THIS, DWORD extconn, DWORD reserved):HRESULT
  ReleaseConnection		stdmethod(IExternalConnection *THIS, DWORD extconn, DWORD reserved, BOOL fLastReleaseCloses):HRESULT
endi

interface IMultiQI extends IUnknown
  GUID				00000020-0000-0000-C000-000000000046
  QueryMultipleInterfaces	stdmethod(IMultiQI *THIS, ULONG cMQIs, MULTI_QI *pMQIs):HRESULT
endi

interface AsyncIMultiQI extends IUnknown
  GUID				000E0020-0000-0000-C000-000000000046
  Begin_QueryMultipleInterfaces stdmethod(AsyncIMultiQI *THIS, ULONG cMQIs, MULTI_QI *pMQIs):HRESULT
  Finish_QueryMultipleInterfaces stdmethod(AsyncIMultiQI *THIS, MULTI_QI *pMQIs):HRESULT
endi

interface IInternalUnknown extends IUnknown
  GUID				00000021-0000-0000-C000-000000000046
  QueryInternalInterface	stdmethod(IInternalUnknown *THIS, REFIID riid, void **ppv):HRESULT
endi

interface IEnumUnknown extends IUnknown
  GUID				00000100-0000-0000-C000-000000000046
  Next				stdmethod(IEnumUnknown *THIS, ULONG celt, IUnknown **rgelt, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumUnknown *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumUnknown *THIS):HRESULT
  Clone 			stdmethod(IEnumUnknown *THIS, IEnumUnknown **ppenum):HRESULT
endi

interface IEnumString extends IUnknown
  GUID				00000101-0000-0000-C000-000000000046
  Next				stdmethod(IEnumString *THIS, ULONG celt, LPOLESTR *rgelt, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumString *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumString *THIS):HRESULT
  Clone 			stdmethod(IEnumString *THIS, IEnumString **ppenum):HRESULT
endi

interface ISequentialStream extends IUnknown
  GUID				0C733A30-2A1C-11CE-ADE5-00AA0044773D
  Read				stdmethod(ISequentialStream *THIS, void *pv, ULONG cb, ULONG *pcbRead):HRESULT
  Write 			stdmethod(ISequentialStream *THIS, const void *pv, ULONG cb, ULONG *pcbWritten):HRESULT
endi

interface IStream extends ISequentialStream
  GUID				0000000C-0000-0000-C000-000000000046
  Seek				stdmethod(IStream *THIS, LARGE_INTEGER dlibMove, DWORD dwOrigin, ULARGE_INTEGER *plibNewPosition):HRESULT
  SetSize			stdmethod(IStream *THIS, ULARGE_INTEGER libNewSize):HRESULT
  CopyTo			stdmethod(IStream *THIS, IStream *pstm, ULARGE_INTEGER cb, ULARGE_INTEGER *pcbRead, ULARGE_INTEGER *pcbWritten):HRESULT
  Commit			stdmethod(IStream *THIS, DWORD grfCommitFlags):HRESULT
  Revert			stdmethod(IStream *THIS):HRESULT
  LockRegion			stdmethod(IStream *THIS, ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType):HRESULT
  UnlockRegion			stdmethod(IStream *THIS, ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType):HRESULT
  Stat				stdmethod(IStream *THIS, STATSTG *pstatstg, DWORD grfStatFlag):HRESULT
  Clone 			stdmethod(IStream *THIS, IStream **ppstm):HRESULT
endi

interface IRpcChannelBuffer extends IUnknown
  GUID				D5F56B60-593B-101A-B569-08002B2DBF7A
  GetBuffer			stdmethod(IRpcChannelBuffer *THIS, RPCOLEMESSAGE *pMessage, REFIID riid):HRESULT
  SendReceive			stdmethod(IRpcChannelBuffer *THIS, RPCOLEMESSAGE *pMessage, ULONG *pStatus):HRESULT
  FreeBuffer			stdmethod(IRpcChannelBuffer *THIS, RPCOLEMESSAGE *pMessage):HRESULT
  GetDestCtx			stdmethod(IRpcChannelBuffer *THIS, DWORD *pdwDestContext, void **ppvDestContext):HRESULT
  IsConnected			stdmethod(IRpcChannelBuffer *THIS):HRESULT
endi

interface IRpcChannelBuffer2 extends IRpcChannelBuffer
  GUID				594F31D0-7F19-11D0-B194-00A0C90DC8BF
  GetProtocolVersion		stdmethod(IRpcChannelBuffer2 *THIS, DWORD *pdwVersion):HRESULT
endi

interface IAsyncRpcChannelBuffer extends IRpcChannelBuffer2
  GUID				A5029FB6-3C34-11D1-9C99-00C04FB998AA
  Send				stdmethod(IAsyncRpcChannelBuffer *THIS, RPCOLEMESSAGE *pMsg, ISynchronize *pSync, ULONG *pulStatus):HRESULT
  Receive			stdmethod(IAsyncRpcChannelBuffer *THIS, RPCOLEMESSAGE *pMsg, ULONG *pulStatus):HRESULT
  GetDestCtxEx			stdmethod(IAsyncRpcChannelBuffer *THIS, RPCOLEMESSAGE *pMsg, DWORD *pdwDestContext, void **ppvDestContext):HRESULT
endi

interface IRpcChannelBuffer3 extends IRpcChannelBuffer2
  GUID				25B15600-0115-11D0-BF0D-00AA00B8DFD2
  Send				stdmethod(IRpcChannelBuffer3 *THIS, RPCOLEMESSAGE *pMsg, ULONG *pulStatus):HRESULT
  Receive			stdmethod(IRpcChannelBuffer3 *THIS, RPCOLEMESSAGE *pMsg, ULONG ulSize, ULONG *pulStatus):HRESULT
  Cancel			stdmethod(IRpcChannelBuffer3 *THIS, RPCOLEMESSAGE *pMsg):HRESULT
  GetCallContext		stdmethod(IRpcChannelBuffer3 *THIS, RPCOLEMESSAGE *pMsg, REFIID riid, void **pInterface):HRESULT
  GetDestCtxEx			stdmethod(IRpcChannelBuffer3 *THIS, RPCOLEMESSAGE *pMsg, DWORD *pdwDestContext, void **ppvDestContext):HRESULT
  GetState			stdmethod(IRpcChannelBuffer3 *THIS, RPCOLEMESSAGE *pMsg, DWORD *pState):HRESULT
  RegisterAsync 		stdmethod(IRpcChannelBuffer3 *THIS, RPCOLEMESSAGE *pMsg, IAsyncManager *pAsyncMgr):HRESULT
endi

interface IRpcSyntaxNegotiate extends IUnknown
  GUID				58A08519-24C8-4935-B482-3FD823333A4F
  NegotiateSyntax		stdmethod(IRpcSyntaxNegotiate *THIS, RPCOLEMESSAGE *pMsg):HRESULT
endi

interface IRpcProxyBuffer extends IUnknown
  GUID				D5F56A34-593B-101A-B569-08002B2DBF7A
  Connect			stdmethod(IRpcProxyBuffer *THIS, IRpcChannelBuffer *pRpcChannelBuffer):HRESULT
  Disconnect			stdmethod(IRpcProxyBuffer *THIS):HRESULT
endi

interface IRpcStubBuffer extends IUnknown
  GUID				D5F56AFC-593B-101A-B569-08002B2DBF7A
  Connect			stdmethod(IRpcStubBuffer *THIS, IUnknown *pUnkServer):HRESULT
  Disconnect			stdmethod(IRpcStubBuffer *THIS):HRESULT
  Invoke			stdmethod(IRpcStubBuffer *THIS, RPCOLEMESSAGE *_prpcmsg, IRpcChannelBuffer *_pRpcChannelBuffer):HRESULT
  IsIIDSupported		stdmethod(IRpcStubBuffer *THIS, REFIID riid):HRESULT
  CountRefs			stdmethod(IRpcStubBuffer *THIS):HRESULT
  DebugServerQueryInterface	stdmethod(IRpcStubBuffer *THIS, void **ppv):HRESULT
  DebugServerRelease		stdmethod(IRpcStubBuffer *THIS, void *pv):HRESULT
endi

interface IPSFactoryBuffer extends IUnknown
  GUID				D5F569D0-593B-101A-B569-08002B2DBF7A
  CreateProxy			stdmethod(IPSFactoryBuffer *THIS, IUnknown *pUnkOuter, REFIID riid, IRpcProxyBuffer **ppProxy, void **ppv):HRESULT
  CreateStub			stdmethod(IPSFactoryBuffer *THIS, REFIID riid, IUnknown *pUnkServer, IRpcStubBuffer **ppStub):HRESULT
endi

interface IChannelHook extends IUnknown
  GUID				1008C4A0-7613-11CF-9AF1-0020AF6E72F4
  ClientGetSize 		stdmethod(IChannelHook *THIS, REFGUID uExtent, REFIID riid, ULONG *pDataSize):HRESULT
  ClientFillBuffer		stdmethod(IChannelHook *THIS, REFGUID uExtent, REFIID riid, ULONG *pDataSize, void *pDataBuffer):HRESULT
  ClientNotify			stdmethod(IChannelHook *THIS, REFGUID uExtent, REFIID riid, ULONG cbDataSize, void *pDataBuffer, DWORD lDataRep, HRESULT hrFault):HRESULT
  ServerNotify			stdmethod(IChannelHook *THIS, REFGUID uExtent, REFIID riid, ULONG cbDataSize, void *pDataBuffer, DWORD lDataRep):HRESULT
  ServerGetSize 		stdmethod(IChannelHook *THIS, REFGUID uExtent, REFIID riid, HRESULT hrFault, ULONG *pDataSize):HRESULT
  ServerFillBuffer		stdmethod(IChannelHook *THIS, REFGUID uExtent, REFIID riid, ULONG *pDataSize, void *pDataBuffer, HRESULT hrFault):HRESULT
endi

interface IClientSecurity extends IUnknown
  GUID				0000013D-0000-0000-C000-000000000046
  QueryBlanket			stdmethod(IClientSecurity *THIS, IUnknown *pProxy, DWORD *pAuthnSvc, DWORD *pAuthzSvc, OLECHAR **pServerPrincName, DWORD *pAuthnLevel, DWORD *pImpLevel, void **pAuthInfo, DWORD *pCapabilites):HRESULT
  SetBlanket			stdmethod(IClientSecurity *THIS, IUnknown *pProxy, DWORD dwAuthnSvc, DWORD dwAuthzSvc, OLECHAR *pServerPrincName, DWORD dwAuthnLevel, DWORD dwImpLevel, void *pAuthInfo, DWORD dwCapabilities):HRESULT
  CopyProxy			stdmethod(IClientSecurity *THIS, IUnknown *pProxy, IUnknown **ppCopy):HRESULT
endi

interface IServerSecurity extends IUnknown
  GUID				0000013E-0000-0000-C000-000000000046
  QueryBlanket			stdmethod(IServerSecurity *THIS, DWORD *pAuthnSvc, DWORD *pAuthzSvc, OLECHAR **pServerPrincName, DWORD *pAuthnLevel, DWORD *pImpLevel, void **pPrivs, DWORD *pCapabilities):HRESULT
  ImpersonateClient		stdmethod(IServerSecurity *THIS):HRESULT
  RevertToSelf			stdmethod(IServerSecurity *THIS):HRESULT
  IsImpersonating		stdmethod(IServerSecurity *THIS):HRESULT
endi

interface IRpcOptions extends IUnknown
  GUID				00000144-0000-0000-C000-000000000046
  Set				stdmethod(IRpcOptions *THIS, IUnknown *pPrx, RPCOPT_PROPERTIES dwProperty, ULONG_PTR dwValue):HRESULT
  Query 			stdmethod(IRpcOptions *THIS, IUnknown *pPrx, RPCOPT_PROPERTIES dwProperty, ULONG_PTR *pdwValue):HRESULT
endi

interface IGlobalOptions extends IUnknown
  GUID				0000015B-0000-0000-C000-000000000046
  Set				stdmethod(IGlobalOptions *THIS, GLOBALOPT_PROPERTIES dwProperty, ULONG_PTR dwValue):HRESULT
  Query 			stdmethod(IGlobalOptions *THIS, GLOBALOPT_PROPERTIES dwProperty, ULONG_PTR *pdwValue):HRESULT
endi

interface ISurrogate extends IUnknown
  GUID				00000022-0000-0000-C000-000000000046
  LoadDllServer 		stdmethod(ISurrogate *THIS, REFCLSID Clsid):HRESULT
  FreeSurrogate 		stdmethod(ISurrogate *THIS):HRESULT
endi

interface IGlobalInterfaceTable extends IUnknown
  GUID				00000146-0000-0000-C000-000000000046
  RegisterInterfaceInGlobal	stdmethod(IGlobalInterfaceTable *THIS, IUnknown *pUnk, REFIID riid, DWORD *pdwCookie):HRESULT
  RevokeInterfaceFromGlobal	stdmethod(IGlobalInterfaceTable *THIS, DWORD dwCookie):HRESULT
  GetInterfaceFromGlobal	stdmethod(IGlobalInterfaceTable *THIS, DWORD dwCookie, REFIID riid, void **ppv):HRESULT
endi

interface ISynchronize extends IUnknown
  GUID				00000030-0000-0000-C000-000000000046
  Wait				stdmethod(ISynchronize *THIS, DWORD dwFlags, DWORD dwMilliseconds):HRESULT
  Signal			stdmethod(ISynchronize *THIS):HRESULT
  Reset 			stdmethod(ISynchronize *THIS):HRESULT
endi

interface ISynchronizeHandle extends IUnknown
  GUID				00000031-0000-0000-C000-000000000046
  GetHandle			stdmethod(ISynchronizeHandle *THIS, HANDLE *ph):HRESULT
endi

interface ISynchronizeEvent extends ISynchronizeHandle
  GUID				00000032-0000-0000-C000-000000000046
  SetEventHandle		stdmethod(ISynchronizeEvent *THIS, HANDLE *ph):HRESULT
endi

interface ISynchronizeContainer extends IUnknown
  GUID				00000033-0000-0000-C000-000000000046
  AddSynchronize		stdmethod(ISynchronizeContainer *THIS, ISynchronize *pSync):HRESULT
  WaitMultiple			stdmethod(ISynchronizeContainer *THIS, DWORD dwFlags, DWORD dwTimeOut, ISynchronize **ppSync):HRESULT
endi

interface ISynchronizeMutex extends ISynchronize
  GUID				00000025-0000-0000-C000-000000000046
  ReleaseMutex			stdmethod(ISynchronizeMutex *THIS):HRESULT
endi

interface ICancelMethodCalls extends IUnknown
  GUID				00000029-0000-0000-C000-000000000046
  Cancel			stdmethod(ICancelMethodCalls *THIS, ULONG ulSeconds):HRESULT
  TestCancel			stdmethod(ICancelMethodCalls *THIS):HRESULT
endi

interface IAsyncManager extends IUnknown
  GUID				0000002A-0000-0000-C000-000000000046
  CompleteCall			stdmethod(IAsyncManager *THIS, HRESULT Result):HRESULT
  GetCallContext		stdmethod(IAsyncManager *THIS, REFIID riid, void **pInterface):HRESULT
  GetState			stdmethod(IAsyncManager *THIS, ULONG *pulStateFlags):HRESULT
endi

interface ICallFactory extends IUnknown
  GUID				1C733A30-2A1C-11CE-ADE5-00AA0044773D
  CreateCall			stdmethod(IShellItemImageFactory *THIS, REFIID riid, IUnknown *pCtrlUnk, REFIID riid2, IUnknown **ppv):HRESULT
endi

interface IRpcHelper extends IUnknown
  GUID				00000149-0000-0000-C000-000000000046
  GetDCOMProtocolVersion	stdmethod(IRpcHelper *THIS, DWORD *pComVersion):HRESULT
  GetIIDFromOBJREF		stdmethod(IRpcHelper *THIS, void *pObjRef, IID **piid):HRESULT
endi

interface IReleaseMarshalBuffers extends IUnknown
  GUID				EB0CB9E8-7996-11D2-872E-0000F8080859
  ReleaseMarshalBuffer		stdmethod(IReleaseMarshalBuffers *THIS, RPCOLEMESSAGE *pMsg, DWORD dwFlags, IUnknown *pChnl):HRESULT
endi

interface IWaitMultiple extends IUnknown
  GUID				0000002B-0000-0000-C000-000000000046
  WaitMultiple			stdmethod(IWaitMultiple *THIS, DWORD timeout, ISynchronize **pSync):HRESULT
  AddSynchronize		stdmethod(IWaitMultiple *THIS, ISynchronize *pSync):HRESULT
endi

interface IAddrTrackingControl extends IUnknown
  GUID				00000147-0000-0000-C000-000000000046
  EnableCOMDynamicAddrTracking	stdmethod(IAddrTrackingControl *THIS):HRESULT
  DisableCOMDynamicAddrTracking stdmethod(IAddrTrackingControl *THIS):HRESULT
endi

interface IAddrExclusionControl extends IUnknown
  GUID				00000148-0000-0000-C000-000000000046
  GetCurrentAddrExclusionList	stdmethod(IAddrExclusionControl *THIS, REFIID riid, void **ppEnumerator):HRESULT
  UpdateAddrExclusionList	stdmethod(IAddrExclusionControl *THIS, IUnknown *pEnumerator):HRESULT
endi

interface IPipeByte extends IUnknown
  GUID				DB2F3ACA-2F86-11D1-8E04-00C04FB9989A
  Pull				stdmethod(IPipeByte *THIS, BYTE *buf, ULONG cRequest, ULONG *pcReturned):HRESULT
  Push				stdmethod(IPipeByte *THIS, BYTE *buf, ULONG cSent):HRESULT
endi

interface AsyncIPipeByte extends IUnknown
  GUID				DB2F3ACB-2F86-11D1-8E04-00C04FB9989A
  Begin_Pull			stdmethod(AsyncIPipeByte *THIS, ULONG cRequest):HRESULT
  Finish_Pull			stdmethod(AsyncIPipeByte *THIS, BYTE *buf, ULONG *pcReturned):HRESULT
  Begin_Push			stdmethod(AsyncIPipeByte *THIS, BYTE *buf, ULONG cSent):HRESULT
  Finish_Push			stdmethod(AsyncIPipeByte *THIS):HRESULT
endi

interface IPipeLong extends IUnknown
  GUID				DB2F3ACC-2F86-11D1-8E04-00C04FB9989A
  Pull				stdmethod(IPipeLong *THIS, LONG *buf, ULONG cRequest, ULONG *pcReturned):HRESULT
  Push				stdmethod(IPipeLong *THIS, LONG *buf, ULONG cSent):HRESULT
endi

interface AsyncIPipeLong extends IUnknown
  GUID				DB2F3ACD-2F86-11D1-8E04-00C04FB9989A
  Begin_Pull			stdmethod(AsyncIPipeLong *THIS, ULONG cRequest):HRESULT
  Finish_Pull			stdmethod(AsyncIPipeLong *THIS, LONG *buf, ULONG *pcReturned):HRESULT
  Begin_Push			stdmethod(AsyncIPipeLong *THIS, LONG *buf, ULONG cSent):HRESULT
  Finish_Push			stdmethod(AsyncIPipeLong *THIS):HRESULT
endi

interface IPipeDouble extends IUnknown
  GUID				DB2F3ACE-2F86-11D1-8E04-00C04FB9989A
  Pull				stdmethod(IPipeDouble *THIS, DOUBLE *buf, ULONG cRequest, ULONG *pcReturned):HRESULT
  Push				stdmethod(IPipeDouble *THIS, DOUBLE *buf, ULONG cSent):HRESULT
endi

interface AsyncIPipeDouble extends IUnknown
  GUID				DB2F3ACF-2F86-11D1-8E04-00C04FB9989A
  Begin_Pull			stdmethod(AsyncIPipeDouble *THIS, ULONG cRequest):HRESULT
  Finish_Pull			stdmethod(AsyncIPipeDouble *THIS, DOUBLE *buf, ULONG *pcReturned):HRESULT
  Begin_Push			stdmethod(AsyncIPipeDouble *THIS, DOUBLE *buf, ULONG cSent):HRESULT
  Finish_Push			stdmethod(AsyncIPipeDouble *THIS):HRESULT
endi

interface IEnumContextProps extends IUnknown
  GUID				000001C1-0000-0000-C000-000000000046
  Next				stdmethod(IEnumContextProps *THIS, ULONG celt, ContextProperty *pContextProperties, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumContextProps *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumContextProps *THIS):HRESULT
  Clone 			stdmethod(IEnumContextProps *THIS, IEnumContextProps **ppEnumContextProps):HRESULT
  Count 			stdmethod(IEnumContextProps *THIS, ULONG *pcelt):HRESULT
endi

interface IContext extends IUnknown
  GUID				000001C0-0000-0000-C000-000000000046
  SetProperty			stdmethod(IContext *THIS, REFGUID rpolicyId, CPFLAGS flags, IUnknown *pUnk):HRESULT
  RemoveProperty		stdmethod(IContext *THIS, REFGUID rPolicyId):HRESULT
  GetProperty			stdmethod(IContext *THIS, REFGUID rGuid, CPFLAGS *pFlags, IUnknown **ppUnk):HRESULT
  EnumContextProps		stdmethod(IContext *THIS, IEnumContextProps **ppEnumContextProps):HRESULT
endi

interface IObjContext extends IContext
  GUID				000001C6-0000-0000-C000-000000000046
  Reserved1			stdmethod(IObjContext *THIS):HRESULT
  Reserved2			stdmethod(IObjContext *THIS):HRESULT
  Reserved3			stdmethod(IObjContext *THIS):HRESULT
  Reserved4			stdmethod(IObjContext *THIS):HRESULT
  Reserved5			stdmethod(IObjContext *THIS):HRESULT
  Reserved6			stdmethod(IObjContext *THIS):HRESULT
  Reserved7			stdmethod(IObjContext *THIS):HRESULT
endi

interface IComThreadingInfo extends IUnknown
  GUID				000001CE-0000-0000-C000-000000000046
  GetCurrentApartmentType	stdmethod(IComThreadingInfo *THIS, APTTYPE *pAptType):HRESULT
  GetCurrentThreadType		stdmethod(IComThreadingInfo *THIS, THDTYPE *pThreadType):HRESULT
  GetCurrentLogicalThreadId	stdmethod(IComThreadingInfo *THIS, GUID *pguidLogicalThreadId):HRESULT
  SetCurrentLogicalThreadId	stdmethod(IComThreadingInfo *THIS, REFGUID rguid):HRESULT
endi

interface IProcessInitControl extends IUnknown
  GUID				72380D55-8D2B-43A3-8513-2B6EF31434E9
  ResetInitializerTimeout	stdmethod(IProcessInitControl *THIS, DWORD dwSecondsRemaining):HRESULT
endi

interface IFastRundown extends IUnknown
  GUID				00000040-0000-0000-C000-000000000046
endi

interface IMarshalingStream extends IStream
  GUID				D8F2F5E6-6102-4863-9F26-389A4676EFDE
  GetMarshalingContextAttribute stdmethod(IMarshalingStream *THIS, CO_MARSHALING_CONTEXT_ATTRIBUTES attribute, ULONG_PTR *pAttributeValue):HRESULT
endi

interface IAgileReference extends IUnknown
  GUID				C03F6A43-65A4-9818-987E-E0B810D2A6F2
  Resolve			stdmethod(IAgileReference *THIS, REFIID riid, void **ppvObjectReference):HRESULT
endi

interface IMallocSpy extends IUnknown
  GUID				0000001D-0000-0000-C000-000000000046
  PreAlloc			stdmethod(IMallocSpy *THIS, SIZE_T cbRequest):HRESULT
  PostAlloc			stdmethod(IMallocSpy *THIS, void *pActual):HRESULT
  PreFree			stdmethod(IMallocSpy *THIS, void *pRequest, BOOL fSpyed):HRESULT
  PostFree			stdmethod(IMallocSpy *THIS, BOOL fSpyed):HRESULT
  PreRealloc			stdmethod(IMallocSpy *THIS, void *pRequest, SIZE_T cbRequest, void **ppNewRequest, BOOL fSpyed):HRESULT
  PostRealloc			stdmethod(IMallocSpy *THIS, void *pActual, BOOL fSpyed):HRESULT
  PreGetSize			stdmethod(IMallocSpy *THIS, void *pRequest, BOOL fSpyed):HRESULT
  PostGetSize			stdmethod(IMallocSpy *THIS, SIZE_T cbActual, BOOL fSpyed):HRESULT
  PreDidAlloc			stdmethod(IMallocSpy *THIS, void *pRequest, BOOL fSpyed):HRESULT
  PostDidAlloc			stdmethod(IMallocSpy *THIS, void *pRequest, BOOL fSpyed, int fActual):HRESULT
  PreHeapMinimize		stdmethod(IMallocSpy *THIS):HRESULT
  PostHeapMinimize		stdmethod(IMallocSpy *THIS):HRESULT
endi

interface IBindCtx extends IUnknown
  GUID				0000000E-0000-0000-C000-000000000046
  RegisterObjectBound		stdmethod(IBindCtx *THIS, IUnknown *punk):HRESULT
  RevokeObjectBound		stdmethod(IBindCtx *THIS, IUnknown *punk):HRESULT
  ReleaseBoundObjects		stdmethod(IBindCtx *THIS):HRESULT
  SetBindOptions		stdmethod(IBindCtx *THIS, BIND_OPTS *pbindopts):HRESULT
  GetBindOptions		stdmethod(IBindCtx *THIS, BIND_OPTS *pbindopts):HRESULT
  GetRunningObjectTable 	stdmethod(IBindCtx *THIS, IRunningObjectTable **pprot):HRESULT
  RegisterObjectParam		stdmethod(IBindCtx *THIS, LPOLESTR pszKey, IUnknown *punk):HRESULT
  GetObjectParam		stdmethod(IBindCtx *THIS, LPOLESTR pszKey, IUnknown **ppunk):HRESULT
  EnumObjectParam		stdmethod(IBindCtx *THIS, IEnumString **ppenum):HRESULT
  RevokeObjectParam		stdmethod(IBindCtx *THIS, LPOLESTR pszKey):HRESULT
endi

interface IEnumMoniker extends IUnknown
  GUID				00000102-0000-0000-C000-000000000046
  Next				stdmethod(IEnumMoniker *THIS, ULONG celt, IMoniker **rgelt, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumMoniker *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumMoniker *THIS):HRESULT
  Clone 			stdmethod(IEnumMoniker *THIS, IEnumMoniker **ppenum):HRESULT
endi

interface IRunnableObject extends IUnknown
  GUID				00000126-0000-0000-C000-000000000046
  GetRunningClass		stdmethod(IRunnableObject *THIS, LPCLSID lpClsid):HRESULT
  Run				stdmethod(IRunnableObject *THIS, LPBINDCTX pbc):HRESULT
  IsRunning			stdmethod(IRunnableObject *THIS):BOOL
  LockRunning			stdmethod(IRunnableObject *THIS, BOOL fLock, BOOL fLastUnlockCloses):HRESULT
  SetContainedObject		stdmethod(IRunnableObject *THIS, BOOL fContained):HRESULT
endi

interface IRunningObjectTable extends IUnknown
  GUID				00000010-0000-0000-C000-000000000046
  Register			stdmethod(IRunningObjectTable *THIS, DWORD grfFlags, IUnknown *punkObject, IMoniker *pmkObjectName, DWORD *pdwRegister):HRESULT
  Revoke			stdmethod(IRunningObjectTable *THIS, DWORD dwRegister):HRESULT
  IsRunning			stdmethod(IRunningObjectTable *THIS, IMoniker *pmkObjectName):HRESULT
  GetObject			stdmethod(IRunningObjectTable *THIS, IMoniker *pmkObjectName, IUnknown **ppunkObject):HRESULT
  NoteChangeTime		stdmethod(IRunningObjectTable *THIS, DWORD dwRegister, FILETIME *pfiletime):HRESULT
  GetTimeOfLastChange		stdmethod(IRunningObjectTable *THIS, IMoniker *pmkObjectName, FILETIME *pfiletime):HRESULT
  EnumRunning			stdmethod(IRunningObjectTable *THIS, IEnumMoniker **ppenumMoniker):HRESULT
endi

interface IPersist extends IUnknown
  GUID				0000010C-0000-0000-C000-000000000046
  GetClassID			stdmethod(IPersist *THIS, CLSID *pClassID):HRESULT
endi

interface IPersistStream extends IPersist
  GUID				00000109-0000-0000-C000-000000000046
  IsDirty			stdmethod(IPersistStream *THIS):HRESULT
  Load				stdmethod(IPersistStream *THIS, IStream *pStm):HRESULT
  Save				stdmethod(IPersistStream *THIS, IStream *pStm, BOOL fClearDirty):HRESULT
  GetSizeMax			stdmethod(IPersistStream *THIS, ULARGE_INTEGER *pcbSize):HRESULT
endi

interface IMoniker extends IPersistStream
  GUID				0000000F-0000-0000-C000-000000000046
  BindToObject			stdmethod(IMoniker *THIS, IBindCtx *pbc, IMoniker *pmkToLeft, REFIID riidResult, void **ppvResult):HRESULT
  BindToStorage 		stdmethod(IMoniker *THIS, IBindCtx *pbc, IMoniker *pmkToLeft, REFIID riid, void **ppvObj):HRESULT
  Reduce			stdmethod(IMoniker *THIS, IBindCtx *pbc, DWORD dwReduceHowFar, IMoniker **ppmkToLeft, IMoniker **ppmkReduced):HRESULT
  ComposeWith			stdmethod(IMoniker *THIS, IMoniker *pmkRight, BOOL fOnlyIfNotGeneric, IMoniker **ppmkComposite):HRESULT
  Enum				stdmethod(IMoniker *THIS, BOOL fForward, IEnumMoniker **ppenumMoniker):HRESULT
  IsEqual			stdmethod(IMoniker *THIS, IMoniker *pmkOtherMoniker):HRESULT
  Hash				stdmethod(IMoniker *THIS, DWORD *pdwHash):HRESULT
  IsRunning			stdmethod(IMoniker *THIS, IBindCtx *pbc, IMoniker *pmkToLeft, IMoniker *pmkNewlyRunning):HRESULT
  GetTimeOfLastChange		stdmethod(IMoniker *THIS, IBindCtx *pbc, IMoniker *pmkToLeft, FILETIME *pFileTime):HRESULT
  Inverse			stdmethod(IMoniker *THIS, IMoniker **ppmk):HRESULT
  CommonPrefixWith		stdmethod(IMoniker *THIS, IMoniker *pmkOther, IMoniker **ppmkPrefix):HRESULT
  RelativePathTo		stdmethod(IMoniker *THIS, IMoniker *pmkOther, IMoniker **ppmkRelPath):HRESULT
  GetDisplayName		stdmethod(IMoniker *THIS, IBindCtx *pbc, IMoniker *pmkToLeft, LPOLESTR *ppszDisplayName):HRESULT
  ParseDisplayName		stdmethod(IMoniker *THIS, IBindCtx *pbc, IMoniker *pmkToLeft, LPOLESTR pszDisplayName, ULONG *pchEaten, IMoniker **ppmkOut):HRESULT
  IsSystemMoniker		stdmethod(IMoniker *THIS, DWORD *pdwMksys):HRESULT
endi

interface IROTData extends IUnknown
  GUID				F29F6BC0-5021-11CE-AA15-00006901293F
  GetComparisonData		stdmethod(IROTData *THIS, byte *pbData, ULONG cbMax, ULONG *pcbData):HRESULT
endi

interface IEnumSTATSTG extends IUnknown
  GUID				0000000D-0000-0000-C000-000000000046
  Next				stdmethod(IEnumSTATSTG *THIS, ULONG celt, STATSTG *rgelt, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumSTATSTG *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumSTATSTG *THIS):HRESULT
  Clone 			stdmethod(IEnumSTATSTG *THIS, IEnumSTATSTG **ppenum):HRESULT
endi

interface IStorage extends IUnknown
  GUID				0000000B-0000-0000-C000-000000000046
  CreateStream			stdmethod(IStorage *THIS, const OLECHAR *pwcsName, DWORD grfMode, DWORD reserved1, DWORD reserved1, IStream **ppstm):HRESULT
  OpenStream			stdmethod(IStorage *THIS, const OLECHAR *pwcsName, void *reserved1, DWORD grfMode, DWORD reserved2, IStream **ppstm):HRESULT
  CreateStorage 		stdmethod(IStorage *THIS, const OLECHAR *pwcsName, DWORD grfMode, DWORD reserved1, DWORD reserved2, IStorage **ppstg):HRESULT
  OpenStorage			stdmethod(IStorage *THIS, const OLECHAR *pwcsName, IStorage *pstgPriority, DWORD grfMode, SNB snbExclude, DWORD reserved, IStorage **ppstg):HRESULT
  CopyTo			stdmethod(IStorage *THIS, DWORD ciidExclude, const IID *rgiidExclude, SNB snbExclude, IStorage *pstgDest):HRESULT
  MoveElementTo 		stdmethod(IStorage *THIS, const OLECHAR *pwcsName, IStorage *pstgDest, const OLECHAR *pwcsNewName, DWORD grfFlags):HRESULT
  Commit			stdmethod(IStorage *THIS, DWORD grfCommitFlags):HRESULT
  Revert			stdmethod(IStorage *THIS):HRESULT
  EnumElements			stdmethod(IStorage *THIS, DWORD reserved1, void *reserved2, DWORD reserved3, IEnumSTATSTG **ppenum):HRESULT
  DestroyElement		stdmethod(IStorage *THIS, const OLECHAR *pwcsName):HRESULT
  RenameElement 		stdmethod(IStorage *THIS, const OLECHAR *pwcsOldName, const OLECHAR *pwcsNewName):HRESULT
  SetElementTimes		stdmethod(IStorage *THIS, const OLECHAR *pwcsName, const FILETIME *pctime, const FILETIME *patime, const FILETIME *pmtime):HRESULT
  SetClass			stdmethod(IStorage *THIS, REFCLSID clsid):HRESULT
  SetStateBits			stdmethod(IStorage *THIS, DWORD grfStateBits, DWORD grfMask):HRESULT
  Stat				stdmethod(IStorage *THIS, STATSTG *pstatstg, DWORD grfStatFlag):HRESULT
endi

interface IPersistFile extends IPersist
  GUID				0000010B-0000-0000-C000-000000000046
  IsDirty			stdmethod(IPersistFile *THIS):HRESULT
  Load				stdmethod(IPersistFile *THIS, LPCOLESTR pszFileName, DWORD dwMode):HRESULT
  Save				stdmethod(IPersistFile *THIS, LPCOLESTR pszFileName, BOOL fRemember):HRESULT
  SaveCompleted 		stdmethod(IPersistFile *THIS, LPCOLESTR pszFileName):HRESULT
  GetCurFile			stdmethod(IPersistFile *THIS, LPOLESTR *ppszFileName):HRESULT
endi

interface IPersistStorage extends IPersist
  GUID				0000010A-0000-0000-C000-000000000046
  IsDirty			stdmethod(IPersistStorage *THIS):HRESULT
  InitNew			stdmethod(IPersistStorage *THIS, IStorage *pStg):HRESULT
  Load				stdmethod(IPersistStorage *THIS, IStorage *pStg):HRESULT
  Save				stdmethod(IPersistStorage *THIS, IStorage *pStgSave, BOOL fSameAsLoad):HRESULT
  SaveCompleted 		stdmethod(IPersistStorage *THIS, IStorage *pStgNew):HRESULT
  HandsOffStorage		stdmethod(IPersistStorage *THIS):HRESULT
endi

interface ILockBytes extends IUnknown
  GUID				0000000A-0000-0000-C000-000000000046
  ReadAt			stdmethod(ILockBytes *THIS, ULARGE_INTEGER ulOffset, void *pv, ULONG cb, ULONG *pcbRead):HRESULT
  WriteAt			stdmethod(ILockBytes *THIS, ULARGE_INTEGER ulOffset, const void *pv, ULONG cb, ULONG *pcbWritten):HRESULT
  Flush 			stdmethod(ILockBytes *THIS):HRESULT
  SetSize			stdmethod(ILockBytes *THIS, ULARGE_INTEGER cb):HRESULT
  LockRegion			stdmethod(ILockBytes *THIS, ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType):HRESULT
  UnlockRegion			stdmethod(ILockBytes *THIS, ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType):HRESULT
  Stat				stdmethod(ILockBytes *THIS, STATSTG *pstatstg, DWORD grfStatFlag):HRESULT
endi

interface IEnumFORMATETC extends IUnknown
  GUID				00000103-0000-0000-C000-000000000046
  Next				stdmethod(IEnumFORMATETC *THIS, ULONG celt, FORMATETC *rgelt, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumFORMATETC *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumFORMATETC *THIS):HRESULT
  Clone 			stdmethod(IEnumFORMATETC *THIS, IEnumFORMATETC **ppenum):HRESULT
endi

interface IEnumSTATDATA extends IUnknown
  GUID				00000105-0000-0000-C000-000000000046
  Next				stdmethod(IEnumSTATDATA *THIS, ULONG celt, STATDATA *rgelt, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumSTATDATA *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumSTATDATA *THIS):HRESULT
  Clone 			stdmethod(IEnumSTATDATA *THIS, IEnumSTATDATA **ppenum):HRESULT
endi

interface IRootStorage extends IUnknown
  GUID				00000012-0000-0000-C000-000000000046
  SwitchToFile			stdmethod(IRootStorage *THIS, LPOLESTR pszFile):HRESULT
endi

interface IAdviseSink extends IUnknown
  GUID				0000010F-0000-0000-C000-000000000046
  OnDataChange			stdmethod(IAdviseSink *THIS, FORMATETC *pFormatetc, STGMEDIUM *pStgmed):HRESULT
  OnViewChange			stdmethod(IAdviseSink *THIS, DWORD dwAspect, LONG lindex):HRESULT
  OnRename			stdmethod(IAdviseSink *THIS, IMoniker *pmk):HRESULT
  OnSave			stdmethod(IAdviseSink *THIS):HRESULT
  OnClose			stdmethod(IAdviseSink *THIS):HRESULT
endi

interface AsyncIAdviseSink extends IUnknown
  GUID				00000150-0000-0000-C000-000000000046
  Begin_OnDataChange		stdmethod(AsyncIAdviseSink *THIS, FORMATETC *pFormatetc, STGMEDIUM *pStgmed):HRESULT
  Finish_OnDataChange		stdmethod(AsyncIAdviseSink *THIS):HRESULT
  Begin_OnViewChange		stdmethod(AsyncIAdviseSink *THIS, DWORD dwAspect, LONG lindex):HRESULT
  Finish_OnViewChange		stdmethod(AsyncIAdviseSink *THIS):HRESULT
  Begin_OnRename		stdmethod(AsyncIAdviseSink *THIS, IMoniker *pmk):HRESULT
  Finish_OnRename		stdmethod(AsyncIAdviseSink *THIS):HRESULT
  Begin_OnSave			stdmethod(AsyncIAdviseSink *THIS):HRESULT
  Finish_OnSave 		stdmethod(AsyncIAdviseSink *THIS):HRESULT
  Begin_OnClose 		stdmethod(AsyncIAdviseSink *THIS):HRESULT
  Finish_OnClose		stdmethod(AsyncIAdviseSink *THIS):HRESULT
endi

interface IAdviseSink2 extends IAdviseSink
  GUID				00000125-0000-0000-C000-000000000046
  OnLinkSrcChange		stdmethod(IAdviseSink2 *THIS, IMoniker *pmk):HRESULT
endi

interface AsyncIAdviseSink2 extends AsyncIAdviseSink
  GUID				00000151-0000-0000-C000-000000000046
  Begin_OnLinkSrcChange 	stdmethod(AsyncIAdviseSink2 *THIS, IMoniker *pmk):HRESULT
  Finish_OnLinkSrcChange	stdmethod(AsyncIAdviseSink2 *THIS):HRESULT
endi

interface IDataObject extends IUnknown
  GUID				0000010E-0000-0000-C000-000000000046
  GetData			stdmethod(IDataObject *THIS, FORMATETC *pformatetcIn, STGMEDIUM *pmedium):HRESULT
  GetDataHere			stdmethod(IDataObject *THIS, FORMATETC *pformatetc, STGMEDIUM *pmedium):HRESULT
  QueryGetData			stdmethod(IDataObject *THIS, FORMATETC *pformatetc):HRESULT
  GetCanonicalFormatEtc 	stdmethod(IDataObject *THIS, FORMATETC *pformatectIn, FORMATETC *pformatetcOut):HRESULT
  SetData			stdmethod(IDataObject *THIS, FORMATETC *pformatetc, STGMEDIUM *pmedium, BOOL fRelease):HRESULT
  EnumFormatEtc 		stdmethod(IDataObject *THIS, DWORD dwDirection, IEnumFORMATETC **ppenumFormatEtc):HRESULT
  DAdvise			stdmethod(IDataObject *THIS, FORMATETC *pformatetc, DWORD advf, IAdviseSink *pAdvSink, DWORD *pdwConnection):HRESULT
  DUnadvise			stdmethod(IDataObject *THIS, DWORD dwConnection):HRESULT
  EnumDAdvise			stdmethod(IDataObject *THIS, IEnumSTATDATA **ppenumAdvise):HRESULT
endi

interface IDataAdviseHolder extends IUnknown
  GUID				00000110-0000-0000-C000-000000000046
  Advise			stdmethod(IDataAdviseHolder *THIS, IDataObject *pDataObject, FORMATETC *pFetc, DWORD advf, IAdviseSink *pAdvise, DWORD *pdwConnection):HRESULT
  Unadvise			stdmethod(IDataAdviseHolder *THIS, DWORD dwConnection):HRESULT
  EnumAdvise			stdmethod(IDataAdviseHolder *THIS, IEnumSTATDATA **ppenumAdvise):HRESULT
  SendOnDataChange		stdmethod(IDataAdviseHolder *THIS, IDataObject *pDataObject, DWORD dwReserved, DWORD advf):HRESULT
endi

interface IMessageFilter extends IUnknown
  GUID				00000016-0000-0000-C000-000000000046
  HandleInComingCall		stdmethod(IMessageFilter *THIS, DWORD dwCallType, HTASK htaskCaller, DWORD dwTickCount, LPINTERFACEINFO lpInterfaceInfo):DWORD
  RetryRejectedCall		stdmethod(IMessageFilter *THIS, HTASK htaskCallee, DWORD dwTickCount, DWORD dwRejectType):DWORD
  MessagePending		stdmethod(IMessageFilter *THIS, HTASK htaskCallee, DWORD dwTickCount, DWORD dwPendingType):DWORD
endi

interface IClassActivator extends IUnknown
  GUID				00000140-0000-0000-C000-000000000046
  GetClassObject		stdmethod(IClassActivator *THIS, REFCLSID rclsid, DWORD dwClassContext, LCID locale, REFIID riid, void **ppv):HRESULT
endi

interface IFillLockBytes extends IUnknown
  GUID				99CAF010-415E-11CF-8814-00AA00B569F5
  FillAppend			stdmethod(IFillLockBytes *THIS, const void *pv, ULONG cb, ULONG *pcbWritten):HRESULT
  FillAt			stdmethod(IFillLockBytes *THIS, ULARGE_INTEGER ulOffset, const void *pv, ULONG cb, ULONG *pcbWritten):HRESULT
  SetFillSize			stdmethod(IFillLockBytes *THIS, ULARGE_INTEGER ulSize):HRESULT
  Terminate			stdmethod(IFillLockBytes *THIS, BOOL bCanceled):HRESULT
endi

interface IProgressNotify extends IUnknown
  GUID				A9D758A0-4617-11CF-95FC-00AA00680DB4
  OnProgress			stdmethod(IProgressNotify *THIS, DWORD dwProgressCurrent, DWORD dwProgressMaximum, BOOL fAccurate, BOOL fOwner):HRESULT
endi

interface ILayoutStorage extends IUnknown
  GUID				0E6D4D90-6738-11CF-9608-00AA00680DB4
  LayoutScript			stdmethod(ILayoutStorage *THIS, StorageLayout *pStorageLayout, DWORD nEntries, DWORD glfInterleavedFlag):HRESULT
  BeginMonitor			stdmethod(ILayoutStorage *THIS):HRESULT
  EndMonitor			stdmethod(ILayoutStorage *THIS):HRESULT
  ReLayoutDocfile		stdmethod(ILayoutStorage *THIS, OLECHAR *pwcsNewDfName):HRESULT
  ReLayoutDocfileOnILockBytes	stdmethod(ILayoutStorage *THIS, ILockBytes *pILockBytes):HRESULT
endi

interface IBlockingLock extends IUnknown
  GUID				30F3D47A-6447-11D1-8E3C-00C04FB9386D
  Lock				stdmethod(IBlockingLock *THIS, DWORD dwTimeout):HRESULT
  Unlock			stdmethod(IBlockingLock *THIS):HRESULT
endi

interface ITimeAndNoticeControl extends IUnknown
  GUID				BC0BF6AE-8878-11D1-83E9-00C04FC2C6D4
  SuppressChanges		stdmethod(ITimeAndNoticeControl *THIS, DWORD res1, DWORD res2):HRESULT
endi

interface IOplockStorage extends IUnknown
  GUID				8D19C834-8879-11D1-83E9-00C04FC2C6D4
  CreateStorageEx		stdmethod(IOplockStorage *THIS, LPCWSTR pwcsName, DWORD grfMode, DWORD stgfmt, DWORD grfAttrs, REFIID riid, void **ppstgOpen):HRESULT
  OpenStorageEx 		stdmethod(IOplockStorage *THIS, LPCWSTR pwcsName, DWORD grfMode, DWORD stgfmt, DWORD grfAttrs, REFIID riid, void **ppstgOpen):HRESULT
endi

interface IDirectWriterLock extends IUnknown
  GUID				0E6D4D92-6738-11CF-9608-00AA00680DB4
  WaitForWriteAccess		stdmethod(IDirectWriterLock *THIS, DWORD dwTimeout):HRESULT
  ReleaseWriteAccess		stdmethod(IDirectWriterLock *THIS):HRESULT
  HaveWriteAccess		stdmethod(IDirectWriterLock *THIS):HRESULT
endi

interface IUrlMon extends IUnknown
  GUID				00000026-0000-0000-C000-000000000046
  AsyncGetClassBits		stdmethod(IUrlMon *THIS, REFCLSID rclsid, LPCWSTR pszTYPE, LPCWSTR pszExt, DWORD dwFileVersionMS, DWORD dwFileVersionLS, LPCWSTR pszCodeBase, IBindCtx *pbc, DWORD dwClassContext, REFIID riid, DWORD flags):HRESULT
endi

interface IForegroundTransfer extends IUnknown
  GUID				00000145-0000-0000-C000-0000000000462
  AllowForegroundTransfer	stdmethod(IForegroundTransfer *THIS, void *lpvReserved):HRESULT
endi

interface IThumbnailExtractor extends IUnknown
  GUID				969DC708-5C76-11D1-8D86-0000F804B057
  ExtractThumbnail		stdmethod(IThumbnailExtractor *THIS, IStorage *pStg, ULONG ulLength, ULONG ulHeight, ULONG *pulOutputLength, ULONG *pulOutputHeight, HBITMAP *phOutputBitmap):HRESULT
  OnFileUpdated 		stdmethod(IThumbnailExtractor *THIS, IStorage *pStg):HRESULT
endi

interface IDummyHICONIncluder extends IUnknown
  GUID				947990DE-CC28-11D2-A0f7-00805F858FB1
  Dummy 			stdmethod(IDummyHICONIncluder *THIS, HICON h1, HDC h2):HRESULT
endi

interface IProcessLock extends IUnknown
  GUID				000001D5-0000-0000-C000-000000000046
  AddRefOnProcess		stdmethod(IProcessLock *THIS):HRESULT
  ReleaseRefOnProcess		stdmethod(IProcessLock *THIS):HRESULT
endi

interface ISurrogateService extends IUnknown
  GUID				000001D4-0000-0000-C000-000000000046
  Init				stdmethod(ISurrogateService *THIS, REFGUID rguidProcessID, IProcessLock *pProcessLock, BOOL *pfApplicationAware):HRESULT
  ApplicationLaunch		stdmethod(ISurrogateService *THIS, REFGUID rguidApplID, ApplicationType appType):HRESULT
  ApplicationFree		stdmethod(ISurrogateService *THIS, REFGUID rguidApplID):HRESULT
  CatalogRefresh		stdmethod(ISurrogateService *THIS, ULONG ulReserved):HRESULT
  ProcessShutdown		stdmethod(ISurrogateService *THIS, ShutdownType shutdownType):HRESULT
endi

interface IInitializeSpy  extends IUnknown
  GUID				00000034-0000-0000-C000-000000000046
  PreInitialize 		stdmethod(IInitializeSpy *THIS, DWORD dwCoInit, DWORD dwCurThreadAptRefs):HRESULT
  PostInitialize		stdmethod(IInitializeSpy *THIS, HRESULT hrCoInit, DWORD dwCoInit, DWORD dwNewThreadAptRefs):HRESULT
  PreUninitialize		stdmethod(IInitializeSpy *THIS, DWORD dwCurThreadAptRefs):HRESULT
  PostUninitialize		stdmethod(IInitializeSpy *THIS, DWORD dwNewThreadAptRefs):HRESULT
endi

interface IApartmentShutdown extends IUnknown
  GUID				A2F05A09-27A2-42B5-BC0E-AC163EF49D9B
  OnUninitialize		stdmethod(IApartmentShutdown *THIS, UINT64 ui64ApartmentIdentifier):HRESULT
endi