define _SHOBJIDL_CORE_H

interface IContextMenu extends IUnknown
  GUID				000214E4-0000-0000-C000-000000000046
  QueryContextMenu		stdmethod(IContextMenu *THIS, const IID *const riid, void **ppvObject):HRESULT
  InvokeCommand 		stdmethod(IContextMenu *THIS, CMINVOKECOMMANDINFO *lpici):HRESULT
  GetCommandString		stdmethod(IContextMenu *THIS, UINT_PTR idCmd, UINT uType, UINT *pReserved, CHAR *pszName, UINT cchMax):HRESULT
endi

interface IContextMenu2 extends IContextMenu
  GUID				000214F4-0000-0000-C000-000000000046
  HandleMenuMsg 		stdmethod(IContextMenu2 *THIS, UINT uMsg, WPARAM wParam, LPARAM lParam):HRESULT
endi

interface IContextMenu3 extends IContextMenu2
  GUID				BCFCE0A0-EC17-11D0-8D10-00A0C90F2719
  HandleMenuMsg2		stdmethod(IContextMenu3 *THIS, UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT *plResult):HRESULT
endi

interface IExecuteCommand extends IUnknown
  GUID				7F9185B0-CB92-43C5-80A9-92277A4F7B54
  SetKeyState			stdmethod(IExecuteCommand *THIS, DWORD grfKeyState):HRESULT
  SetParameters 		stdmethod(IExecuteCommand *THIS, LPCWSTR pszParameters):HRESULT
  SetPosition			stdmethod(IExecuteCommand *THIS, POINT pt):HRESULT
  SetShowWindow 		stdmethod(IExecuteCommand *THIS, int nShow):HRESULT
  SetNoShowUI			stdmethod(IExecuteCommand *THIS, BOOL fNoShowUI):HRESULT
  SetDirectory			stdmethod(IExecuteCommand *THIS, LPCWSTR pszDirectory):HRESULT
  Execute			stdmethod(IExecuteCommand *THIS):HRESULT
endi

interface IPersistFolder extends IPersist
  GUID				7F9185B0-CB92-43C5-80A9-92277A4F7B54
  Initialize			stdmethod(IPersistFolder *THIS, PCIDLIST_ABSOLUTE pidl):HRESULT
endi

interface IRunnableTask extends IUnknown
  GUID				85788D00-6807-11D0-B810-00C04FD706EC
  Run				stdmethod(IRunnableTask *THIS):HRESULT
  Kill				stdmethod(IRunnableTask *THIS, BOOL bWait):HRESULT
  Suspend			stdmethod(IRunnableTask *THIS):HRESULT
  Resume			stdmethod(IRunnableTask *THIS):HRESULT
  IsRunning			stdmethod(IRunnableTask *THIS):HRESULT
endi

interface IShellTaskScheduler extends IUnknown
  GUID				6CCB7BE0-6807-11D0-B810-00C04FD706EC
  AddTask			stdmethod(IShellTaskScheduler *THIS, IRunnableTask *prt, REFTASKOWNERID rtoid, DWORD_PTR lParam, DWORD dwPriority):HRESULT
  RemoveTasks			stdmethod(IShellTaskScheduler *THIS, REFTASKOWNERID rtoid, DWORD_PTR lParam, BOOL bWaitIfRunning):HRESULT
  CountTasks			stdmethod(IShellTaskScheduler *THIS, REFTASKOWNERID rtoid):HRESULT
  Status			stdmethod(IShellTaskScheduler *THIS, DWORD dwReleaseStatus, DWORD dwThreadTimeout):HRESULT
endi

interface IPersistFolder2 extends IPersistFolder
  GUID				7F9185B0-CB92-43C5-80A9-92277A4F7B54
  GetCurFolder			stdmethod(IPersistFolder2 *THIS, PIDLIST_ABSOLUTE *ppidl):HRESULT
endi

interface IPersistFolder3 extends IPersistFolder2
  GUID				CEF04FDF-FE72-11D2-87A5-00C04F6837CF
  InitializeEx			stdmethod(IPersistFolder3 *THIS, IBindCtx *pbc, PCIDLIST_ABSOLUTE pidlRoot, const PERSIST_FOLDER_TARGET_INFO *ppfti):HRESULT
  GetFolderTargetInfo		stdmethod(IPersistFolder3 *THIS, PERSIST_FOLDER_TARGET_INFO *ppfti):HRESULT
endi

interface IPersistIDList extends IPersist
  GUID				1079ACFC-29BD-11D3-8E0D-00C04F6837D5
  SetIDList			stdmethod(IPersistIDList *THIS, PCIDLIST_ABSOLUTE pidl):HRESULT
  GetIDList			stdmethod(IPersistIDList *THIS, PCIDLIST_ABSOLUTE *ppidl):HRESULT
endi

interface IEnumIDList extends IUnknown
  GUID				000214F2-0000-0000-C000-000000000046
  Next				stdmethod(IEnumIDList *THIS, ULONG celt, PITEMID_CHILD *rgelt, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumIDList *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumIDList *THIS):HRESULT
  Clone 			stdmethod(IEnumIDList *THIS, IEnumIDList **ppenum):HRESULT
endi

interface IEnumFullIDList extends IUnknown
  GUID				D0191542-7954-4908-BC06-B2360BBE45BA
  Next				stdmethod(IEnumFullIDList *THIS, ULONG celt, PITEMID_CHILD *rgelt, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumFullIDList *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumFullIDList *THIS):HRESULT
  Clone 			stdmethod(IEnumFullIDList *THIS, IEnumFullIDList **ppenum):HRESULT
endi

interface IFileSyncMergeHandler extends IUnknown
  GUID				D97B5AAC-C792-433C-975D-35C4EADC7A9D
  Merge 			stdmethod(IFileSyncMergeHandler *THIS, LPCWSTR localFilePath, LPCWSTR serverFilePath, MERGE_UPDATE_STATUS *updateStatus):HRESULT
  ShowResolveConflictUIAsync	stdmethod(IFileSyncMergeHandler *THIS, LPCWSTR localFilePath, HMONITOR monitorToDisplayOn):HRESULT
endi

interface IObjectWithFolderEnumMode extends IUnknown
  GUID				6A9D9026-0E6E-464C-B000-42ECC07DE673
  SetMode			stdmethod(IObjectWithFolderEnumMode *THIS, FOLDER_ENUM_MODE feMode):HRESULT
  GetMode			stdmethod(IObjectWithFolderEnumMode *THIS, FOLDER_ENUM_MODE *pfeMode):HRESULT
endi

interface IParseAndCreateItem extends IUnknown
  GUID				67EFED0E-E827-4408-B493-78F3982B685C
  SetItem			stdmethod(IParseAndCreateItem *THIS, IShellItem *psi):HRESULT
  GetItem			stdmethod(IParseAndCreateItem *THIS, const IID *const riid, void **ppv):HRESULT
endi

interface IShellFolder extends IUnknown
  GUID				000214E6-0000-0000-C000-000000000046
  ParseDisplayName		stdmethod(IShellFolder *THIS, HWND hwnd, IBindCtx *pbc, LPWSTR pszDisplayName, ULONG *pchEaten, PIDLIST_RELATIVE *ppidl, ULONG *pdwAttributes):HRESULT
  EnumObjects			stdmethod(IShellFolder *THIS, HWND hwnd, SHCONTF grfFlags, IEnumIDList **ppenumIDList):HRESULT
  BindToObject			stdmethod(IShellFolder *THIS, PCUIDLIST_RELATIVE pidl, IBindCtx *pbc, const IID *const riid, void **ppv):HRESULT
  BindToStorage 		stdmethod(IShellFolder *THIS, PCUIDLIST_RELATIVE pidl, IBindCtx *pbc, const IID *const riid, void **ppv):HRESULT
  CompareIDs			stdmethod(IShellFolder *THIS, LPARAM lParam, PCUIDLIST_RELATIVE pidl1, PCUIDLIST_RELATIVE pidl2):HRESULT
  CreateViewObject		stdmethod(IShellFolder *THIS, HWND hwndOwner, const IID *const riid, void **ppv):HRESULT
  GetAttributesOf		stdmethod(IShellFolder *THIS, UINT cidl, PCUITEMID_CHILD_ARRAY apidl, SFGAOF *rgfInOut):HRESULT
  GetUIObjectOf 		stdmethod(IShellFolder *THIS, HWND hwndOwner, UINT cidl, const IID *const riid, UINT *rgfReserved, void **ppv):HRESULT
  GetDisplayNameOf		stdmethod(IShellFolder *THIS, PCUITEMID_CHILD pidl, SHGDNF uFlags, STRRET *pName):HRESULT
  SetNameOf			stdmethod(IShellFolder *THIS, HWND hwnd, PCUITEMID_CHILD pidl, LPCWSTR pszName, SHGDNF uFlags, PITEMID_CHILD *ppidlOut):HRESULT
endi

interface IEnumExtraSearch extends IUnknown
  GUID				0E700BE1-9DB6-11D1-A1CE-00C04FD75D13
  Next				stdmethod(IEnumExtraSearch *THIS, ULONG celt, EXTRASEARCH *rgelt, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumExtraSearch *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumExtraSearch *THIS):HRESULT
  Clone 			stdmethod(IEnumExtraSearch *THIS, IEnumExtraSearch **ppenum):HRESULT
endi

interface IShellFolder2 extends IShellFolder
  GUID				93F2F68C-1D1B-11D3-A30E-00C04F79ABD1
  GetDefaultSearchGUID		stdmethod(IShellFolder2 *THIS, GUID *pguid):HRESULT
  EnumSearches			stdmethod(IShellFolder2 *THIS, IEnumExtraSearch **ppenum):HRESULT
  GetDefaultColumn		stdmethod(IShellFolder2 *THIS, DWORD dwRes, ULONG *pSort, ULONG *pDisplay):HRESULT
  GetDefaultColumnState 	stdmethod(IShellFolder2 *THIS, UINT iColumn, SHCOLSTATEF *pcsFlags):HRESULT
  GetDetailsEx			stdmethod(IShellFolder2 *THIS, PCUITEMID_CHILD pidl, SHCOLUMNID *pscid, VARIANT *pv):HRESULT
  GetDetailsOf			stdmethod(IShellFolder2 *THIS, PCUITEMID_CHILD pidl, UINT iColumn, SHELLDETAILS *psd):HRESULT
  MapColumnToSCID		stdmethod(IShellFolder2 *THIS, UINT iColumn, SHCOLUMNID *pscid):HRESULT
endi

interface IShellView extends IOleWindow
  GUID				000214E3-0000-0000-C000-000000000046
  TranslateAccelerator		stdmethod(IShellView *THIS, MSG *pmsg):HRESULT
  EnableModeless		stdmethod(IShellView *THIS, BOOL fEnable):HRESULT
  UIActivate			stdmethod(IShellView *THIS, UINT uState):HRESULT
  Refresh			stdmethod(IShellView *THIS):HRESULT
  CreateViewWindow		stdmethod(IShellView *THIS, IShellView *psvPrevious, LPCFOLDERSETTINGS pfs, IShellBrowser *psb, RECT *prcView, HWND *phWnd):HRESULT
  DestroyViewWindow		stdmethod(IShellView *THIS):HRESULT
  GetCurrentInfo		stdmethod(IShellView *THIS, LPFOLDERSETTINGS pfs):HRESULT
  AddPropertySheetPages 	stdmethod(IShellView *THIS, DWORD dwReserved, LPFNSVADDPROPSHEETPAGE pfn, LPARAM lparam):HRESULT
  SaveViewState 		stdmethod(IShellView *THIS):HRESULT
  SelectItem			stdmethod(IShellView *THIS, PCUITEMID_CHILD pidlItem, SVSIF uFlags):HRESULT
  GetItemObject 		stdmethod(IShellView *THIS, UINT uItem, REFIID riid, void **ppv):HRESULT
endi

interface IShellView2 extends IShellView
  GUID				88E39E80-3578-11CF-AE69-08002B2E1262
  GetView			stdmethod(IShellView2 *THIS, SHELLVIEWID *pvid, ULONG uView):HRESULT
  CreateViewWindow2		stdmethod(IShellView2 *THIS, LPSV2CVW2_PARAMS lpParams):HRESULT
  HandleRename			stdmethod(IShellView2 *THIS, PCUITEMID_CHILD pidlNew):HRESULT
  SelectAndPositionItem 	stdmethod(IShellView2 *THIS, PCUITEMID_CHILD pidlItem, UINT uFlags, POINT *ppt):HRESULT
endi

interface IFolderView extends IUnknown
  GUID				CDE725B0-CCC9-4519-917E-325D72FAB4CE
  GetCurrentViewMode		stdmethod(IFolderView *THIS, UINT *pViewMode):HRESULT
  SetCurrentViewMode		stdmethod(IFolderView *THIS, UINT ViewMode):HRESULT
  GetFolder			stdmethod(IFolderView *THIS, REFIID riid, void **ppv):HRESULT
  Item				stdmethod(IFolderView *THIS, int iItemIndex, PITEMID_CHILD *ppidl):HRESULT
  ItemCount			stdmethod(IFolderView *THIS, UINT uFlags, int *pcItems):HRESULT
  Items 			stdmethod(IFolderView *THIS, UINT uFlags, REFIID riid, void **ppv):HRESULT
  GetSelectionMarkedItem	stdmethod(IFolderView *THIS, int *piItem):HRESULT
  GetFocusedItem		stdmethod(IFolderView *THIS, int *piItem):HRESULT
  GetItemPosition		stdmethod(IFolderView *THIS, PCUITEMID_CHILD pidl, POINT *ppt):HRESULT
  GetSpacing			stdmethod(IFolderView *THIS, POINT *ppt):HRESULT
  GetDefaultSpacing		stdmethod(IFolderView *THIS, POINT *ppt):HRESULT
  GetAutoArrange		stdmethod(IFolderView *THIS):HRESULT
  SelectItem			stdmethod(IFolderView *THIS, int iItem, DWORD dwFlags):HRESULT
  SelectAndPositionItems	stdmethod(IFolderView *THIS, UINT cidl, PCUITEMID_CHILD_ARRAY apidl, POINT *apt, DWORD dwFlags):HRESULT
endi

interface IFolderView2 extends IFolderView
  GUID				1AF3A467-214F-4298-908E-06B03E0B39F9
  SetGroupBy			stdmethod(IFolderView2 *THIS, REFPROPERTYKEY key, BOOL fAscending):HRESULT
  GetGroupBy			stdmethod(IFolderView2 *THIS, PROPERTYKEY *pkey, BOOL *pfAscending):HRESULT
  SetViewProperty		stdmethod(IFolderView2 *THIS, PCUITEMID_CHILD pidl, REFPROPERTYKEY propkey, REFPROPVARIANT propvar):HRESULT
  GetViewProperty		stdmethod(IFolderView2 *THIS, PCUITEMID_CHILD pidl, REFPROPERTYKEY propkey, PROPVARIANT *ppropvar):HRESULT
  SetTileViewProperties 	stdmethod(IFolderView2 *THIS, PCUITEMID_CHILD pidl, LPCWSTR pszPropList):HRESULT
  SetExtendedTileViewProperties stdmethod(IFolderView2 *THIS, PCUITEMID_CHILD pidl, LPCWSTR pszPropList):HRESULT
  SetText			stdmethod(IFolderView2 *THIS, FVTEXTTYPE iType, LPCWSTR pwszText):HRESULT
  SetCurrentFolderFlags 	stdmethod(IFolderView2 *THIS, DWORD dwMask, DWORD dwFlags):HRESULT
  GetCurrentFolderFlags 	stdmethod(IFolderView2 *THIS, DWORD *pdwFlags):HRESULT
  GetSortColumnCount		stdmethod(IFolderView2 *THIS, int *pcColumns):HRESULT
  SetSortColumns		stdmethod(IFolderView2 *THIS, const SORTCOLUMN *rgSortColumns, int cColumns):HRESULT
  GetSortColumns		stdmethod(IFolderView2 *THIS, SORTCOLUMN *rgSortColumns, int cColumns):HRESULT
  GetItem			stdmethod(IFolderView2 *THIS, int iItem, REFIID riid, void **ppv):HRESULT
  GetVisibleItem		stdmethod(IFolderView2 *THIS, int iStart, BOOL fPrevious, int *piItem):HRESULT
  GetSelectedItem		stdmethod(IFolderView2 *THIS, int iStart, int *piItem):HRESULT
  GetSelection			stdmethod(IFolderView2 *THIS, BOOL fNoneImpliesFolder, IShellItemArray **ppsia):HRESULT
  GetSelectionState		stdmethod(IFolderView2 *THIS, PCUITEMID_CHILD pidl, DWORD *pdwFlags):HRESULT
  InvokeVerbOnSelection 	stdmethod(IFolderView2 *THIS, LPCSTR pszVerb):HRESULT
  SetViewModeAndIconSize	stdmethod(IFolderView2 *THIS, FOLDERVIEWMODE uViewMode, int iImageSize):HRESULT
  GetViewModeAndIconSize	stdmethod(IFolderView2 *THIS, FOLDERVIEWMODE *puViewMode, int *piImageSize):HRESULT
  SetGroupSubsetCount		stdmethod(IFolderView2 *THIS, UINT cVisibleRows):HRESULT
  GetGroupSubsetCount		stdmethod(IFolderView2 *THIS, UINT *pcVisibleRows):HRESULT
  SetRedraw			stdmethod(IFolderView2 *THIS, BOOL fRedrawOn):HRESULT
  IsMoveInSameFolder		stdmethod(IFolderView2 *THIS):HRESULT
  DoRename			stdmethod(IFolderView2 *THIS):HRESULT
endi

interface IFolderViewSettings extends IUnknown
  GUID				AE8C987D-8797-4ED3-BE72-2A47DD938DB0
  GetColumnPropertyList 	stdmethod(IFolderViewSettings *THIS, REFIID riid, void **ppv):HRESULT
  GetGroupByProperty		stdmethod(IFolderViewSettings *THIS, PROPERTYKEY *pkey, BOOL *pfGroupAscending):HRESULT
  GetViewMode			stdmethod(IFolderViewSettings *THIS, FOLDERLOGICALVIEWMODE *plvm):HRESULT
  GetIconSize			stdmethod(IFolderViewSettings *THIS, UINT *puIconSize):HRESULT
  GetFolderFlags		stdmethod(IFolderViewSettings *THIS, FOLDERFLAGS *pfolderMask, FOLDERFLAGS *pfolderFlags):HRESULT
  GetSortColumns		stdmethod(IFolderViewSettings *THIS, SORTCOLUMN *rgSortColumns, UINT cColumnsIn, UINT *pcColumnsOut):HRESULT
  GetGroupSubsetCount		stdmethod(IFolderViewSettings *THIS, UINT *pcVisibleRows):HRESULT
endi

interface IPreviewHandlerVisuals extends IUnknown
  GUID				196BF9A5-B346-4EF0-AA1E-5DCDB76768B1
  SetBackgroundColor		stdmethod(IPreviewHandlerVisuals *THIS, COLORREF color):HRESULT
  SetFont			stdmethod(IPreviewHandlerVisuals *THIS, LOGFONTW *plf):HRESULT
  SetTextColor			stdmethod(IPreviewHandlerVisuals *THIS, COLORREF color):HRESULT
endi

interface ICommDlgBrowser extends IUnknown
  GUID				000214F1-0000-0000-C000-000000000046
  OnDefaultCommand		stdmethod(ICommDlgBrowser *THIS, IShellView *ppshv):HRESULT
  OnStateChange 		stdmethod(ICommDlgBrowser *THIS, IShellView *ppshv, ULONG uChange):HRESULT
  IncludeObject 		stdmethod(ICommDlgBrowser *THIS, IShellView *ppshv, PCUITEMID_CHILD pidl):HRESULT
endi

interface ICommDlgBrowser2 extends ICommDlgBrowser
  GUID				10339516-2894-11D2-9039-00C04F8EEB3E
  Notify			stdmethod(ICommDlgBrowser2 *THIS, IShellView *ppshv, DWORD dwNotifyType):HRESULT
  GetDefaultMenuText		stdmethod(ICommDlgBrowser2 *THIS, IShellView *ppshv, LPWSTR pszText, int cchMax):HRESULT
  GetViewFlags			stdmethod(ICommDlgBrowser2 *THIS, DWORD *pdwFlag):HRESULT
endi

interface IColumnManager extends IUnknown
  GUID				D8EC27BB-3F3B-4042-B10A-4ACFD924D453
  SetColumnInfo 		stdmethod(IColumnManager *THIS, REFPROPERTYKEY propkey, const CM_COLUMNINFO *pcmci):HRESULT
  GetColumnInfo 		stdmethod(IColumnManager *THIS, REFPROPERTYKEY propkey, CM_COLUMNINFO *pcmci):HRESULT
  GetColumnCount		stdmethod(IColumnManager *THIS, CM_ENUM_FLAGS dwFlags, UINT *puCount):HRESULT
  GetColumns			stdmethod(IColumnManager *THIS, CM_ENUM_FLAGS dwFlags, PROPERTYKEY *rgkeyOrder, UINT cColumns):HRESULT
  SetColumns			stdmethod(IColumnManager *THIS, const PROPERTYKEY *rgkeyOrder, UINT cVisible):HRESULT
endi

interface IFolderFilterSite extends IUnknown
  GUID				C0A651F5-B48B-11D2-B5ED-006097C686F6
  SetFilter			stdmethod(IFolderFilterSite *THIS, IUnknown *punk):HRESULT
endi

interface IFolderFilter extends IUnknown
  GUID				9CC22886-DC8E-11D2-B1D0-00C04F8EEB3E
  ShouldShow			stdmethod(IFolderFilter *THIS, IShellFolder *psf, PCIDLIST_ABSOLUTE pidlFolder, PCUITEMID_CHILD pidlItem):HRESULT
  GetEnumFlags			stdmethod(IFolderFilter *THIS, IShellFolder *psf, PCIDLIST_ABSOLUTE pidlFolder, HWND *phwnd, DWORD *pgrfFlags):HRESULT
endi

interface IInputObjectSite extends IUnknown
  GUID				F1DB8392-7331-11D0-8C99-00A0C92DBFE8
  OnFocusChangeIS		stdmethod(IInputObjectSite *THIS, IUnknown *punkObj, BOOL fSetFocus):HRESULT
endi

interface IInputObject extends IUnknown
  GUID				68284FAA-6A48-11D0-8C78-00C04FD918B4
  UIActivateIO			stdmethod(IInputObject *THIS, BOOL fActivate, MSG *pMsg):HRESULT
  HasFocusIO			stdmethod(IInputObject *THIS):HRESULT
  TranslateAcceleratorIO	stdmethod(IInputObject *THIS, MSG *pMsg):HRESULT
endi

interface IInputObject2 extends IInputObject
  GUID				6915C085-510B-44CD-94AF-28DFA56CF92B
  TranslateAcceleratorGlobal	stdmethod(IInputObject2 *THIS, MSG *pMsg):HRESULT
endi

interface IShellIcon extends IUnknown
  GUID				000214E5-0000-0000-C000-000000000046
  GetIconOf			stdmethod(IShellIcon *THIS, PCUITEMID_CHILD pidl, UINT flags, int *pIconIndex):HRESULT
endi

interface IShellBrowser extends IOleWindow
  GUID				000214E2-0000-0000-C000-000000000046
  InsertMenusSB 		stdmethod(IShellBrowser *THIS, HMENU hmenuShared, LPOLEMENUGROUPWIDTHS lpMenuWidths):HRESULT
  SetMenuSB			stdmethod(IShellBrowser *THIS, HMENU hmenuShared, HOLEMENU holemenuRes, HWND hwndActiveObject):HRESULT
  RemoveMenusSB 		stdmethod(IShellBrowser *THIS, HMENU hmenuShared):HRESULT
  SetStatusTextSB		stdmethod(IShellBrowser *THIS, LPCWSTR pszStatusText):HRESULT
  EnableModelessSB		stdmethod(IShellBrowser *THIS, BOOL fEnable):HRESULT
  TranslateAcceleratorSB	stdmethod(IShellBrowser *THIS, MSG *pmsg, WORD wID):HRESULT
  BrowseObject			stdmethod(IShellBrowser *THIS, PCUIDLIST_RELATIVE pidl, UINT wFlags):HRESULT
  GetViewStateStream		stdmethod(IShellBrowser *THIS, DWORD grfMode, IStream **ppStrm):HRESULT
  GetControlWindow		stdmethod(IShellBrowser *THIS, UINT id, HWND *phwnd):HRESULT
  SendControlMsg		stdmethod(IShellBrowser *THIS, UINT id, UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT *pret):HRESULT
  QueryActiveShellView		stdmethod(IShellBrowser *THIS, IShellView **ppshv):HRESULT
  OnViewWindowActive		stdmethod(IShellBrowser *THIS, IShellView *pshv):HRESULT
  SetToolbarItems		stdmethod(IShellBrowser *THIS, LPTBBUTTONSB lpButtons, UINT nButtons, UINT uFlags):HRESULT
endi

interface IProfferService extends IUnknown
  GUID				CB728B20-F786-11CE-92AD-00AA00A74CD0
  ProfferService		stdmethod(IProfferService *THIS, REFGUID guidService, IServiceProvider *psp, DWORD *pdwCookie):HRESULT
  RevokeService 		stdmethod(IProfferService *THIS, DWORD dwCookie):HRESULT
endi

interface IShellItem extends IUnknown
  GUID				43826D1E-E718-42EE-BC55-A1E261C37BFE
  BindToHandler 		stdmethod(IShellItem *THIS, IBindCtx *pbc, REFGUID bhid, REFIID riid, void **ppv):HRESULT
  GetParent			stdmethod(IShellItem *THIS, IShellItem **ppsi):HRESULT
  GetDisplayName		stdmethod(IShellItem *THIS, SIGDN sigdnName, LPWSTR *ppszName):HRESULT
  GetAttributes 		stdmethod(IShellItem *THIS, SFGAOF sfgaoMask, SFGAOF *psfgaoAttribs):HRESULT
  Compare			stdmethod(IShellItem *THIS, IShellItem *psi, SICHINTF hint, int *piOrde):HRESULT
endi

interface IShellItem2 extends IShellItem
  GUID				43826D1E-E718-42EE-BC55-A1E261C37BFE
  GetPropertyStore		stdmethod(IShellItem2 *THIS, GETPROPERTYSTOREFLAGS flags, REFIID riid, void **ppv):HRESULT
  GetPropertyStoreWithCreateObject stdmethod(IShellItem2 *THIS, GETPROPERTYSTOREFLAGS flags, IUnknown *punkCreateObject, REFIID riid, void **ppv):HRESULT
  GetPropertyStoreForKeys	stdmethod(IShellItem2 *THIS, const PROPERTYKEY *rgKeys, UINT cKeys, GETPROPERTYSTOREFLAGS flags, REFIID riid, void **ppv):HRESULT
  GetPropertyDescriptionList	stdmethod(IShellItem2 *THIS, REFPROPERTYKEY keyTyp, REFIID riid, void **ppv):HRESULT
  Update			stdmethod(IShellItem2 *THIS, IBindCtx *pbc):HRESULT
  GetProperty			stdmethod(IShellItem2 *THIS, REFPROPERTYKEY key, PROPVARIANT *ppropvar):HRESULT
  GetCLSID			stdmethod(IShellItem2 *THIS, REFPROPERTYKEY key, CLSID *pclsid):HRESULT
  GetFileTime			stdmethod(IShellItem2 *THIS, REFPROPERTYKEY key, FILETIME *pft):HRESULT
  GetInt32			stdmethod(IShellItem2 *THIS, REFPROPERTYKEY key, int *pi):HRESULT
  GetString			stdmethod(IShellItem2 *THIS, REFPROPERTYKEY key, LPWSTR *ppsz):HRESULT
  GetUInt32			stdmethod(IShellItem2 *THIS, REFPROPERTYKEY key, ULONG *pui):HRESULT
  GetUInt64			stdmethod(IShellItem2 *THIS, REFPROPERTYKEY key, ULONGLONG *pull):HRESULT
  GetBool			stdmethod(IShellItem2 *THIS, REFPROPERTYKEY key, BOOL *pf):HRESULT
endi

interface IShellItemImageFactory extends IUnknown
  GUID				BCC18B79-BA16-442F-80C4-8A59C30C463B
  GetImage			stdmethod(IShellItemImageFactory *THIS, SIZE size, SIIGBF flags, HBITMAP *phbm):HRESULT
endi

interface IEnumShellItems extends IUnknown
  GUID				70629033-E363-4A28-A567-0DB78006E6D7
  Next				stdmethod(IEnumShellItems *THIS, ULONG celt, IShellItem **rgelt, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumShellItems *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumShellItems *THIS):HRESULT
  Clone 			stdmethod(IEnumShellItems *THIS, IEnumShellItems **ppenum):HRESULT
endi

interface ITransferAdviseSink extends IUnknown
  GUID				D594D0D8-8DA7-457B-B3B4-CE5DBAAC0B88
  UpdateProgress		stdmethod(ITransferAdviseSink *THIS, ULONGLONG ullSizeCurrent, ULONGLONG ullSizeTotal, int nFilesCurrent, int nFilesTotal, int nFoldersCurrent, int nFoldersTotal):HRESULT
  UpdateTransferState		stdmethod(ITransferAdviseSink *THIS, TRANSFER_ADVISE_STATE ts):HRESULT
  ConfirmOverwrite		stdmethod(ITransferAdviseSink *THIS, IShellItem *psiSource, IShellItem *psiDestParent, LPCWSTR pszName):HRESULT
  ConfirmEncryptionLoss 	stdmethod(ITransferAdviseSink *THIS, IShellItem *psiSource):HRESULT
  FileFailure			stdmethod(ITransferAdviseSink *THIS, IShellItem *psi, LPCWSTR pszItem, HRESULT hrError, LPWSTR pszRename, ULONG cchRename):HRESULT
  SubStreamFailure		stdmethod(ITransferAdviseSink *THIS, IShellItem *psi, LPCWSTR pszStreamName, HRESULT hrError):HRESULT
  PropertyFailure		stdmethod(ITransferAdviseSink *THIS, IShellItem *psi, PROPERTYKEY *pkey, HRESULT hrError):HRESULT
endi

interface ITransferSource extends IUnknown
  GUID				00ADB003-BDE9-45C6-8E29-D09F9353E108
  Advise			stdmethod(ITransferSource *THIS, ITransferAdviseSink *psink, DWORD *pdwCookie):HRESULT
  Unadvise			stdmethod(ITransferSource *THIS, DWORD dwCookie):HRESULT
  SetProperties 		stdmethod(ITransferSource *THIS, IPropertyChangeArray *pproparray):HRESULT
  OpenItem			stdmethod(ITransferSource *THIS, IShellItem *psi, TRANSFER_SOURCE_FLAGS flags, REFIID riid, void **ppv):HRESULT
  MoveItem			stdmethod(ITransferSource *THIS, IShellItem *psi, IShellItem *psiParentDst, LPCWSTR pszNameDst, TRANSFER_SOURCE_FLAGS flags, IShellItem **ppsiNew):HRESULT
  RecycleItem			stdmethod(ITransferSource *THIS, IShellItem *psiSource, IShellItem *psiParentDest, TRANSFER_SOURCE_FLAGS flags, IShellItem **ppsiNewDest):HRESULT
  RemoveItem			stdmethod(ITransferSource *THIS, IShellItem *psiSource, TRANSFER_SOURCE_FLAGS flags):HRESULT
  RenameItem			stdmethod(ITransferSource *THIS, IShellItem *psiSource, LPCWSTR pszNewName, TRANSFER_SOURCE_FLAGS flags, IShellItem **ppsiNewDest):HRESULT
  LinkItem			stdmethod(ITransferSource *THIS, IShellItem *psiSource, IShellItem *psiParentDest, LPCWSTR pszNewName, TRANSFER_SOURCE_FLAGS flags, IShellItem **ppsiNewDest):HRESULT
  ApplyPropertiesToItem 	stdmethod(ITransferSource *THIS, IShellItem *psiSource, IShellItem **ppsiNew):HRESULT
  GetDefaultDestinationName	stdmethod(ITransferSource *THIS, IShellItem *psiSource, IShellItem *psiParentDest, LPWSTR *ppszDestinationName):HRESULT
  EnterFolder			stdmethod(ITransferSource *THIS, IShellItem *psiChildFolderDest):HRESULT
  LeaveFolder			stdmethod(ITransferSource *THIS, IShellItem *psiChildFolderDest):HRESULT
endi

interface IEnumResources extends IUnknown
  GUID				2DD81FE3-A83C-4DA9-A330-47249D345BA1
  Next				stdmethod(IEnumResources *THIS, ULONG celt, SHELL_ITEM_RESOURCE *psir, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumResources *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumResources *THIS):HRESULT
  Clone 			stdmethod(IEnumResources *THIS, IEnumResources **ppenumr):HRESULT
endi

interface IShellItemResources extends IUnknown
  GUID				FF5693BE-2CE0-4D48-B5C5-40817D1ACDB9
  GetAttributes 		stdmethod(IShellItemResources *THIS, DWORD *pdwAttributes):HRESULT
  GetSize			stdmethod(IShellItemResources *THIS, ULONGLONG *pullSize):HRESULT
  GetTimes			stdmethod(IShellItemResources *THIS, FILETIME *pftCreation, FILETIME *pftWrite, FILETIME *pftAccess):HRESULT
  SetTimes			stdmethod(IShellItemResources *THIS, const FILETIME *pftCreation, const FILETIME *pftWrite, const FILETIME *pftAccess):HRESULT
  GetResourceDescription	stdmethod(IShellItemResources *THIS, const SHELL_ITEM_RESOURCE *pcsir, LPWSTR *ppszDescription):HRESULT
  EnumResources 		stdmethod(IShellItemResources *THIS, IEnumResources **ppenumr):HRESULT
  SupportsResource		stdmethod(IShellItemResources *THIS, const SHELL_ITEM_RESOURCE *pcsir):HRESULT
  OpenResource			stdmethod(IShellItemResources *THIS, const SHELL_ITEM_RESOURCE *pcsir, REFIID riid, void **ppv):HRESULT
  CreateResource		stdmethod(IShellItemResources *THIS, const SHELL_ITEM_RESOURCE *pcsir, REFIID riid, void **ppv):HRESULT
  MarkForDelete 		stdmethod(IShellItemResources *THIS):HRESULT
endi

interface ITransferDestination extends IUnknown
  GUID				48ADDD32-3CA5-4124-ABE3-B5A72531B207
  Advise			stdmethod(ITransferDestination *THIS, ITransferAdviseSink *psink, DWORD *pdwCookie):HRESULT
  Unadvise			stdmethod(ITransferDestination *THIS, DWORD dwCookie):HRESULT
  CreateItem			stdmethod(ITransferDestination *THIS, LPCWSTR pszName, DWORD dwAttributes, ULONGLONG ullSize, TRANSFER_SOURCE_FLAGS flags, REFIID riidItem, void **ppvItem, REFIID riidResources, void **ppvResources):HRESULT
endi

interface IFileOperationProgressSink extends IUnknown
  GUID				04B0F1A7-9490-44BC-96E1-4296A31252E2
  StartOperations		stdmethod(IFileOperationProgressSink *THIS):HRESULT
  FinishOperations		stdmethod(IFileOperationProgressSink *THIS, HRESULT hrResult):HRESULT
  PreRenameItem 		stdmethod(IFileOperationProgressSink *THIS, DWORD dwFlags, IShellItem *psiItem, LPCWSTR pszNewName):HRESULT
  PostRenameItem		stdmethod(IFileOperationProgressSink *THIS, DWORD dwFlags, IShellItem *psiItem, LPCWSTR pszNewName, HRESULT hrRename, IShellItem *psiNewlyCreated):HRESULT
  PreMoveItem			stdmethod(IFileOperationProgressSink *THIS, DWORD dwFlags, IShellItem *psiItem, IShellItem *psiDestinationFolder, LPCWSTR pszNewName):HRESULT
  PostMoveItem			stdmethod(IFileOperationProgressSink *THIS, DWORD dwFlags, IShellItem *psiItem, IShellItem *psiDestinationFolder, LPCWSTR pszNewName, HRESULT hrMove, IShellItem *psiNewlyCreated):HRESULT
  PreCopyItem			stdmethod(IFileOperationProgressSink *THIS, DWORD dwFlags, IShellItem *psiItem, IShellItem *psiDestinationFolder, LPCWSTR pszNewName):HRESULT
  PostCopyItem			stdmethod(IFileOperationProgressSink *THIS, DWORD dwFlags, IShellItem *psiItem, IShellItem *psiDestinationFolder, LPCWSTR pszNewName, HRESULT hrCopy, IShellItem *psiNewlyCreated):HRESULT
  PreDeleteItem 		stdmethod(IFileOperationProgressSink *THIS, DWORD dwFlags, IShellItem *psiItem):HRESULT
  PostDeleteItem		stdmethod(IFileOperationProgressSink *THIS, DWORD dwFlags, IShellItem *psiItem, HRESULT hrDelete, IShellItem *psiNewlyCreated):HRESULT
  PreNewItem			stdmethod(IFileOperationProgressSink *THIS, DWORD dwFlags, IShellItem *psiDestinationFolder, LPCWSTR pszNewName):HRESULT
  PostNewItem			stdmethod(IFileOperationProgressSink *THIS, DWORD dwFlags, IShellItem *psiDestinationFolder, LPCWSTR pszNewName, LPCWSTR pszTemplateName, DWORD dwFileAttributes, HRESULT hrNew, IShellItem *psiNewItem):HRESULT
  UpdateProgress		stdmethod(IFileOperationProgressSink *THIS, UINT iWorkTotal, UINT iWorkSoFar):HRESULT
  ResetTimer			stdmethod(IFileOperationProgressSink *THIS):HRESULT
  PauseTimer			stdmethod(IFileOperationProgressSink *THIS):HRESULT
  ResumeTimers			stdmethod(IFileOperationProgressSink *THIS):HRESULT
endi

interface IShellItemArray extends IUnknown
  GUID				B63EA76D-1F85-456F-A19C-48159EFA858B
  BindToHandler 		stdmethod(IShellItemArray *THIS, IBindCtx *pbc, REFGUID bhid, REFIID riid, void **ppvOut):HRESULT
  GetPropertyStore		stdmethod(IShellItemArray *THIS, GETPROPERTYSTOREFLAGS flags, REFIID riid, void **ppv):HRESULT
  GetPropertyDescriptionList	stdmethod(IShellItemArray *THIS, REFPROPERTYKEY keyType, REFIID riid, void **ppv):HRESULT
  GetAttributes 		stdmethod(IShellItemArray *THIS, SIATTRIBFLAGS AttribFlags, SFGAOF sfgaoMask, SFGAOF *psfgaoAttribs):HRESULT
  GetCount			stdmethod(IShellItemArray *THIS, DWORD *pdwNumItems):HRESULT
  GetItemAt			stdmethod(IShellItemArray *THIS, DWORD dwIndex, IShellItem **ppsi):HRESULT
  EnumItems			stdmethod(IShellItemArray *THIS, IEnumShellItems **ppenumShellItems):HRESULT
endi

interface IInitializeWithItem extends IUnknown
  GUID				7F73BE3F-FB79-493C-A6C7-7EE14E245841
  Initialize			stdmethod(IInitializeWithItem *THIS, IShellItem *psi, DWORD grfMode):HRESULT
endi

interface IObjectWithSelection extends IUnknown
  GUID				1C9CD5BB-98E9-4491-A60F-31AACC72B83C
  SetSelection			stdmethod(IObjectWithSelection *THIS, IShellItemArray *psia):HRESULT
  GetSelection			stdmethod(IObjectWithSelection *THIS, REFIID riid, void **ppv):HRESULT
endi

interface IObjectWithBackReferences extends IUnknown
  GUID				321A6A6A-D61F-4BF3-97AE-14BE2986BB36
  RemoveBackReferences		stdmethod(IObjectWithBackReferences *THIS):HRESULT
endi

interface IPropertyUI extends IUnknown
  GUID				757A7D9F-919A-4118-99D7-DBB208C8CC66
  ParsePropertyName		stdmethod(IPropertyUI *THIS, LPCWSTR pszName, FMTID *pfmtid, PROPID *ppid, ULONG *pchEaten):HRESULT
  GetCannonicalName		stdmethod(IPropertyUI *THIS, REFFMTID fmtid, PROPID pid, LPWSTR pwszText, DWORD cchText):HRESULT
  GetDisplayName		stdmethod(IPropertyUI *THIS, REFFMTID fmtid, PROPID pid, PROPERTYUI_NAME_FLAGS flags, LPWSTR pwszText, DWORD cchText):HRESULT
  GetPropertyDescription	stdmethod(IPropertyUI *THIS, REFFMTID fmtid, PROPID pid, LPWSTR pwszText, DWORD cchText):HRESULT
  GetDefaultWidth		stdmethod(IPropertyUI *THIS, REFFMTID fmtid, PROPID pid, ULONG *pcxChars):HRESULT
  GetFlags			stdmethod(IPropertyUI *THIS, REFFMTID fmtid, PROPID pid, PROPERTYUI_NAME_FLAGS *pflags):HRESULT
  FormatForDisplay		stdmethod(IPropertyUI *THIS, REFFMTID fmtid, PROPID pid, PROPVARIANT *ppropvar, PROPERTYUI_FORMAT_FLAGS puiff, LPWSTR pwszText, DWORD cchText):HRESULT
  GetHelpInfo			stdmethod(IPropertyUI *THIS, REFFMTID fmtid, PROPID pid, LPWSTR pwszHelpFile, DWORD cch, UINT *puHelpID):HRESULT
endi

interface ICategoryProvider extends IUnknown
  GUID				9AF64809-5864-4C26-A720-C1F78C086EE3
  CanCategorizeOnSCID		stdmethod(ICategoryProvider *THIS, const SHCOLUMNID *pscid):HRESULT
  GetDefaultCategory		stdmethod(ICategoryProvider *THIS, GUID *pguid, SHCOLUMNID *pscid):HRESULT
  GetCategoryForSCID		stdmethod(ICategoryProvider *THIS, const SHCOLUMNID *pscid, GUID *pguid):HRESULT
  EnumCategories		stdmethod(ICategoryProvider *THIS, IEnumGUID **penum):HRESULT
  GetCategoryName		stdmethod(ICategoryProvider *THIS, const GUID *pguid, LPWSTR pszName, UINT cch):HRESULT
  CreateCategory		stdmethod(ICategoryProvider *THIS, const GUID *pguid, REFIID riid, void **ppv):HRESULT
endi

interface ICategorizer extends IUnknown
  GUID				A3B14589-9174-49A8-89A3-06A1AE2B9BA7
  GetDescription		stdmethod(ICategorizer *THIS, LPWSTR pszDesc, UINT cch):HRESULT
  GetCategory			stdmethod(ICategorizer *THIS, UINT cidl, PCUITEMID_CHILD_ARRAY apidl, DWORD *rgCategoryIds):HRESULT
  GetCategoryInfo		stdmethod(ICategorizer *THIS, DWORD dwCategoryId, CATEGORY_INFO *pci):HRESULT
  CompareCategory		stdmethod(ICategorizer *THIS, CATSORT_FLAGS csfFlags, DWORD dwCategoryId1, DWORD dwCategoryId2):HRESULT
endi

interface IDropTargetHelper extends IUnknown
  GUID				4657278B-411B-11D2-839A-00C04FD918D0
  DragEnter			stdmethod(IDropTargetHelper *THIS, HWND hwndTarget, IDataObject *pDataObject, POINT *ppt, DWORD dwEffect):HRESULT
  DragLeave			stdmethod(IDropTargetHelper *THIS):HRESULT
  DragOver			stdmethod(IDropTargetHelper *THIS, POINT *ppt, DWORD dwEffect):HRESULT
  Drop				stdmethod(IDropTargetHelper *THIS, IDataObject *pDataObject, POINT *ppt, DWORD dwEffect):HRESULT
  Show				stdmethod(IDropTargetHelper *THIS, BOOL fShow):HRESULT
endi

interface IDragSourceHelper extends IUnknown
  GUID				DE5BF786-477A-11D2-839D-00C04FD918D0
  InitializeFromBitmap		stdmethod(IDragSourceHelper *THIS, LPSHDRAGIMAGE pshdi, IDataObject *pDataObject):HRESULT
  InitializeFromWindow		stdmethod(IDragSourceHelper *THIS, HWND hwnd, POINT *ppt, IDataObject *pDataObject):HRESULT
endi

interface IShellLinkA extends IUnknown
  GUID				000214EE-0000-0000-C000-000000000046
  GetPath			stdmethod(IShellLinkA *THIS, LPSTR pszFile, int cch, WIN32_FIND_DATAA *pfd, DWORD fFlags):HRESULT
  GetIDList			stdmethod(IShellLinkA *THIS, PIDLIST_ABSOLUTE *ppidl):HRESULT
  SetIDList			stdmethod(IShellLinkA *THIS, PIDLIST_ABSOLUTE pidl):HRESULT
  GetDescription		stdmethod(IShellLinkA *THIS, LPSTR pszName, int cch):HRESULT
  SetDescription		stdmethod(IShellLinkA *THIS, LPCSTR pszName):HRESULT
  GetWorkingDirectory		stdmethod(IShellLinkA *THIS, LPSTR pszDir, int cch):HRESULT
  SetWorkingDirectory		stdmethod(IShellLinkA *THIS, LPCSTR pszDir):HRESULT
  GetArguments			stdmethod(IShellLinkA *THIS, LPSTR pszArgs, int cch):HRESULT
  SetArguments			stdmethod(IShellLinkA *THIS, LPCSTR pszArgs):HRESULT
  GetHotkey			stdmethod(IShellLinkA *THIS, WORD *pwHotkey):HRESULT
  SetHotkey			stdmethod(IShellLinkA *THIS, WORD wHotkey):HRESULT
  GetShowCmd			stdmethod(IShellLinkA *THIS, int *piShowCmd):HRESULT
  SetShowCmd			stdmethod(IShellLinkA *THIS, int iShowCmd):HRESULT
  GetIconLocation		stdmethod(IShellLinkA *THIS, LPSTR pszIconPath, int cch, int *piIcon):HRESULT
  SetIconLocation		stdmethod(IShellLinkA *THIS, LPCSTR pszIconPath, int iIcon):HRESULT
  SetRelativePath		stdmethod(IShellLinkA *THIS, LPCSTR pszPathRel, DWORD dwReserved):HRESULT
  Resolve			stdmethod(IShellLinkA *THIS, HWND hwnd, DWORD fFlags):HRESULT
  SetPath			stdmethod(IShellLinkA *THIS, LPCSTR pszFile):HRESULT
endi

interface IShellLinkW extends IUnknown
  GUID				000214F9-0000-0000-C000-000000000046
  GetPath			stdmethod(IShellLinkW *THIS, LPWSTR pszFile, int cch, WIN32_FIND_DATAW *pfd, DWORD fFlags):HRESULT
  GetIDList			stdmethod(IShellLinkW *THIS, PIDLIST_ABSOLUTE *ppidl):HRESULT
  SetIDList			stdmethod(IShellLinkW *THIS, PIDLIST_ABSOLUTE pidl):HRESULT
  GetDescription		stdmethod(IShellLinkW *THIS, LPWSTR pszName, int cch):HRESULT
  SetDescription		stdmethod(IShellLinkW *THIS, LPCWSTR pszName):HRESULT
  GetWorkingDirectory		stdmethod(IShellLinkW *THIS, LPWSTR pszDir, int cch):HRESULT
  SetWorkingDirectory		stdmethod(IShellLinkW *THIS, LPCWSTR pszDir):HRESULT
  GetArguments			stdmethod(IShellLinkW *THIS, LPWSTR pszArgs, int cch):HRESULT
  SetArguments			stdmethod(IShellLinkW *THIS, LPCWSTR pszArgs):HRESULT
  GetHotkey			stdmethod(IShellLinkW *THIS, WORD *pwHotkey):HRESULT
  SetHotkey			stdmethod(IShellLinkW *THIS, WORD wHotkey):HRESULT
  GetShowCmd			stdmethod(IShellLinkW *THIS, int *piShowCmd):HRESULT
  SetShowCmd			stdmethod(IShellLinkW *THIS, int iShowCmd):HRESULT
  GetIconLocation		stdmethod(IShellLinkW *THIS, LPWSTR pszIconPath, int cch, int *piIcon):HRESULT
  SetIconLocation		stdmethod(IShellLinkW *THIS, LPCWSTR pszIconPath, int iIcon):HRESULT
  SetRelativePath		stdmethod(IShellLinkW *THIS, LPCWSTR pszPathRel, DWORD dwReserved):HRESULT
  Resolve			stdmethod(IShellLinkW *THIS, HWND hwnd, DWORD fFlags):HRESULT
  SetPath			stdmethod(IShellLinkW *THIS, LPCWSTR pszFile):HRESULT
endi

interface IShellLinkDataList extends IUnknown
  GUID				45E2B4AE-B1C3-11D0-B92F-00A0C90312E1
  AddDataBlock			stdmethod(IShellLinkDataList *THIS, void *pDataBlock):HRESULT
  CopyDataBlock 		stdmethod(IShellLinkDataList *THIS, DWORD dwSig, void **ppDataBlock):HRESULT
  RemoveDataBlock		stdmethod(IShellLinkDataList *THIS, DWORD dwSig):HRESULT
  GetFlags			stdmethod(IShellLinkDataList *THIS, DWORD *pdwFlags):HRESULT
  SetFlags			stdmethod(IShellLinkDataList *THIS, DWORD dwFlags):HRESULT
endi

interface IResolveShellLink extends IUnknown
  GUID				5CD52983-9449-11D2-963A-00C04F79ADF0
  ResolveShellLink		stdmethod(IResolveShellLink *THIS, IUnknown *punkLink, HWND hwnd, DWORD fFlags):HRESULT
endi

interface IActionProgressDialog extends IUnknown
  GUID				49FF1172-EADC-446D-9285-156453A6431C
  Initialize			stdmethod(IActionProgressDialog *THIS, SPINITF flags, LPCWSTR pszTitle, LPCWSTR pszCancel):HRESULT
  Stop				stdmethod(IActionProgressDialog *THIS):HRESULT
endi

interface IActionProgress extends IUnknown
  GUID				49FF1173-EADC-446D-9285-156453A6431C
  Begin 			stdmethod(IActionProgress *THIS, SPACTION action, SPBEGINF flags):HRESULT
  UpdateProgress		stdmethod(IActionProgress *THIS, ULONGLONG ulCompleted, ULONGLONG ulTotal):HRESULT
  UpdateText			stdmethod(IActionProgress *THIS, SPTEXT sptext, LPCWSTR pszText, BOOL fMayCompact):HRESULT
  QueryCancel			stdmethod(IActionProgress *THIS, BOOL *pfCancelled):HRESULT
  ResetCancel			stdmethod(IActionProgress *THIS):HRESULT
  End				stdmethod(IActionProgress *THIS):HRESULT
endi

interface IShellExtInit extends IUnknown
  GUID				000214E8-0000-0000-C000-000000000046
  Initialize			stdmethod(IShellExtInit *THIS, PCIDLIST_ABSOLUTE pidlFolder, IDataObject *pdtobj, HKEY hkeyProgID):HRESULT
endi

interface IShellPropSheetExt extends IUnknown
  GUID				000214E9-0000-0000-C000-000000000046
  AddPages			stdmethod(IShellPropSheetExt *THIS, LPFNSVADDPROPSHEETPAGE pfnAddPage, LPARAM lParam):HRESULT
  ReplacePage			stdmethod(IShellPropSheetExt *THIS, EXPPS uPageID, LPFNSVADDPROPSHEETPAGE pfnReplaceWith, LPARAM lParam):HRESULT
endi

interface IRemoteComputer extends IUnknown
  GUID				000214FE-0000-0000-C000-000000000046
  Initialize			stdmethod(IRemoteComputer *THIS, LPCWSTR pszMachine, BOOL bEnumerating):HRESULT
endi

interface IQueryContinue extends IUnknown
  GUID				7307055C-B24A-486B-9F25-163E597A28A9
  QueryContinue 		stdmethod(IQueryContinue *THIS):HRESULT
endi

interface IObjectWithCancelEvent extends IUnknown
  GUID				F279B885-0AE9-4b85-AC06-DDECF9408941
  GetCancelEvent		stdmethod(IObjectWithCancelEvent *THIS, HANDLE *phEvent):HRESULT
endi

interface IUserNotification extends IUnknown
  GUID				BA9711BA-5893-4787-A7E1-41277151550B
  SetBalloonInfo		stdmethod(IUserNotification *THIS, LPCWSTR pszTitle, LPCWSTR pszText, DWORD dwInfoFlags):HRESULT
  SetBalloonRetry		stdmethod(IUserNotification *THIS, DWORD dwShowTime, DWORD dwInterval, UINT cRetryCount):HRESULT
  SetIconInfo			stdmethod(IUserNotification *THIS, HICON hIcon, LPCWSTR pszToolTip):HRESULT
  Show				stdmethod(IUserNotification *THIS, IQueryContinue *pqc, DWORD dwContinuePollInterval):HRESULT
  PlaySound			stdmethod(IUserNotification *THIS, LPCWSTR pszSoundName):HRESULT
endi

interface IItemNameLimits extends IUnknown
  GUID				1DF0D7F1-B267-4D28-8B10-12E23202A5C4
  GetValidCharacters		stdmethod(IItemNameLimits *THIS, LPWSTR *ppwszValidChars, LPWSTR *ppwszInvalidChars):HRESULT
  GetMaxLength			stdmethod(IItemNameLimits *THIS, LPCWSTR pszName, int *piMaxNameLen):HRESULT
endi

interface ISearchFolderItemFactory extends IUnknown
  GUID				A0FFBC28-5482-4366-BE27-3E81E78E06C2
  SetDisplayName		stdmethod(ISearchFolderItemFactory *THIS, LPCWSTR pszDisplayName):HRESULT
  SetFolderTypeID		stdmethod(ISearchFolderItemFactory *THIS, FOLDERTYPEID ftid):HRESULT
  SetFolderLogicalViewMode	stdmethod(ISearchFolderItemFactory *THIS, FOLDERLOGICALVIEWMODE flvm):HRESULT
  SetIconSize			stdmethod(ISearchFolderItemFactory *THIS, int iIconSize):HRESULT
  SetVisibleColumns		stdmethod(ISearchFolderItemFactory *THIS, UINT cVisibleColumns, const PROPERTYKEY *rgKey):HRESULT
  SetSortColumns		stdmethod(ISearchFolderItemFactory *THIS, UINT cSortColumns, SORTCOLUMN *rgSortColumns):HRESULT
  SetGroupColumn		stdmethod(ISearchFolderItemFactory *THIS, REFPROPERTYKEY keyGroup):HRESULT
  SetStacks			stdmethod(ISearchFolderItemFactory *THIS, UINT cStackKeys, PROPERTYKEY *rgStackKeys):HRESULT
  SetScope			stdmethod(ISearchFolderItemFactory *THIS, IShellItemArray *psiaScope):HRESULT
  SetCondition			stdmethod(ISearchFolderItemFactory *THIS, ICondition *pCondition):HRESULT
  GetShellItem			stdmethod(ISearchFolderItemFactory *THIS, REFIID riid, void **ppv):HRESULT
  GetIDList			stdmethod(ISearchFolderItemFactory *THIS, PIDLIST_ABSOLUTE *ppidl):HRESULT
endi

interface IExtractImage extends IUnknown
  GUID				BB2E617C-0920-11D1-9A0B-00C04FC2D6C1
  GetLocation			stdmethod(IExtractImage *THIS, LPWSTR pszPathBuffer, DWORD cch, DWORD *pdwPriority, const SIZE *prgSize, DWORD dwRecClrDepth, DWORD *pdwFlags):HRESULT
  Extract			stdmethod(IExtractImage *THIS, HBITMAP *phBmpThumbnail):HRESULT
endi

interface IExtractImage2 extends IExtractImage
  GUID				953BB1EE-93B4-11d1-98A3-00C04FB687DA
  GetDateStamp			stdmethod(IExtractImage2 *THIS, FILETIME *pDateStamp):HRESULT
endi

interface IThumbnailHandlerFactory extends IUnknown
  GUID				E35B4B2E-00DA-4BC1-9F13-38BC11F5D417
  GetThumbnailHandler		stdmethod(IThumbnailHandlerFactory *THIS, PCUITEMID_CHILD pidlChild, IBindCtx *pbc, REFIID riid, void **ppv):HRESULT
endi

interface IParentAndItem extends IUnknown
  GUID				B3A4B685-B685-4805-99D9-5DEAD2873236
  SetParentAndItem		stdmethod(IParentAndItem *THIS, PCIDLIST_ABSOLUTE pidlParent, IShellFolder *psf, PCUITEMID_CHILD pidlChild):HRESULT
  GetParentAndItem		stdmethod(IParentAndItem *THIS, PIDLIST_ABSOLUTE *ppidlParent, IShellFolder **ppsf, PITEMID_CHILD *ppidlChild):HRESULT
endi

interface IDockingWindow extends IOleWindow
  GUID				012DD920-7B26-11D0-8CA9-00A0C92DBFE8
  ShowDW			stdmethod(IDockingWindow *THIS, BOOL fShow):HRESULT
  CloseDW			stdmethod(IDockingWindow *THIS, DWORD dwReserved):HRESULT
  ResizeBorderDW		stdmethod(IDockingWindow *THIS, LPCRECT prcBorder, IUnknown *punkToolbarSite, BOOL fReserved):HRESULT
endi

interface IDeskBand extends IDockingWindow
  GUID				EB0FE172-1A3A-11D0-89B3-00A0C90A90AC
  GetBandInfo			stdmethod(IDeskBand *THIS, DWORD dwBandID, DWORD dwViewMode, DESKBANDINFO *pdbi):HRESULT
endi

interface IDeskBandInfo extends IUnknown
  GUID				77E425FC-CBF9-4307-BA6A-BB5727745661
  GetDefaultBandWidth		stdmethod(IDeskBandInfo *THIS, DWORD dwBandID, DWORD dwViewMode, int *pnWidth):HRESULT
endi

interface ITaskbarList extends IUnknown
  GUID				56FDF342-FD6D-11D0-958A-006097C9A090
  HrInit			stdmethod(ITaskbarList *THIS):HRESULT
  AddTab			stdmethod(ITaskbarList *THIS, HWND hwnd):HRESULT
  DeleteTab			stdmethod(ITaskbarList *THIS, HWND hwnd):HRESULT
  ActivateTab			stdmethod(ITaskbarList *THIS, HWND hwnd):HRESULT
  SetActiveAlt			stdmethod(ITaskbarList *THIS, HWND hwnd):HRESULT
endi

interface ITaskbarList2 extends ITaskbarList
  GUID				602D4995-B13A-429B-A66E-1935E44F4317
  MarkFullscreenWindow		stdmethod(ITaskbarList2 *THIS, HWND hwnd, BOOL fFullscreen):HRESULT
endi

interface ITaskbarList3 extends ITaskbarList2
  GUID				EA1AFB91-9E28-4B86-90E9-9E9F8A5EEFAF
  SetProgressValue		stdmethod(ITaskbarList3 *THIS, HWND hwnd, ULONGLONG ullCompleted, ULONGLONG ullTotal):HRESULT
  SetProgressState		stdmethod(ITaskbarList3 *THIS, HWND hwnd, TBPFLAG tbpFlags):HRESULT
  RegisterTab			stdmethod(ITaskbarList3 *THIS, HWND hwndTab, HWND hwndMDI):HRESULT
  UnregisterTab 		stdmethod(ITaskbarList3 *THIS, HWND hwndTab):HRESULT
  SetTabOrder			stdmethod(ITaskbarList3 *THIS, HWND hwndTab, HWND hwndInsertBefore):HRESULT
  SetTabActive			stdmethod(ITaskbarList3 *THIS, HWND hwndTab, HWND hwndMDI, DWORD dwReserved):HRESULT
  ThumbBarAddButtons		stdmethod(ITaskbarList3 *THIS, HWND hwnd, UINT cButtons, LPTHUMBBUTTON pButton):HRESULT
  ThumbBarUpdateButtons 	stdmethod(ITaskbarList3 *THIS, HWND hwnd, UINT cButtons, LPTHUMBBUTTON pButton):HRESULT
  ThumbBarSetImageList		stdmethod(ITaskbarList3 *THIS, HWND hwnd, HIMAGELIST himl):HRESULT
  SetOverlayIcon		stdmethod(ITaskbarList3 *THIS, HWND hwnd, HICON hIcon, LPCWSTR pszDescription):HRESULT
  SetThumbnailTooltip		stdmethod(ITaskbarList3 *THIS, HWND hwnd, LPCWSTR pszTip):HRESULT
  SetThumbnailClip		stdmethod(ITaskbarList3 *THIS, HWND hwnd, RECT *prcClip):HRESULT
endi

interface ITaskbarList4 extends ITaskbarList3
  GUID				C43DC798-95D1-4BEA-9030-BB99E2983A1A
  SetTabProperties		stdmethod(ITaskbarList4 *THIS, HWND hwndTab, STPFLAG stpFlags):HRESULT
endi

interface IExplorerBrowserEvents extends IUnknown
  GUID				361BBDC7-E6EE-4E13-BE58-58E2240C810F
  OnNavigationPending		stdmethod(IExplorerBrowserEvents *THIS, PCIDLIST_ABSOLUTE pidlFolder):HRESULT
  OnViewCreated 		stdmethod(IExplorerBrowserEvents *THIS, IShellView *psv):HRESULT
  OnNavigationComplete		stdmethod(IExplorerBrowserEvents *THIS, PCIDLIST_ABSOLUTE pidlFolder):HRESULT
  OnNavigationFailed		stdmethod(IExplorerBrowserEvents *THIS, PCIDLIST_ABSOLUTE pidlFolder):HRESULT
endi

interface IExplorerBrowser extends IUnknown
  GUID				DFD3B6B5-C10C-4BE9-85F6-A66969F402F6
  Initialize			stdmethod(IExplorerBrowser *THIS, HWND hwndParent, RECT *prc, const FOLDERSETTINGS *pfs):HRESULT
  Destroy			stdmethod(IExplorerBrowser *THIS):HRESULT
  SetRect			stdmethod(IExplorerBrowser *THIS, HDWP *phdwp, RECT rcBrowser):HRESULT
  SetPropertyBag		stdmethod(IExplorerBrowser *THIS, LPCWSTR pszPropertyBag):HRESULT
  SetEmptyText			stdmethod(IExplorerBrowser *THIS, LPCWSTR pszEmptyText):HRESULT
  SetFolderSettings		stdmethod(IExplorerBrowser *THIS, const FOLDERSETTINGS *pfs):HRESULT
  Advise			stdmethod(IExplorerBrowser *THIS, IExplorerBrowserEvents *psbe, DWORD *pdwCookie):HRESULT
  Unadvise			stdmethod(IExplorerBrowser *THIS, DWORD dwCookie):HRESULT
  SetOptions			stdmethod(IExplorerBrowser *THIS, EXPLORER_BROWSER_OPTIONS dwFlag):HRESULT
  GetOptions			stdmethod(IExplorerBrowser *THIS, EXPLORER_BROWSER_OPTIONS *pdwFlag):HRESULT
  BrowseToIDList		stdmethod(IExplorerBrowser *THIS, PCUIDLIST_RELATIVE pidl, UINT uFlags):HRESULT
  BrowseToObject		stdmethod(IExplorerBrowser *THIS, IUnknown *punk, UINT uFlags):HRESULT
  FillFromObject		stdmethod(IExplorerBrowser *THIS, IUnknown *punk, EXPLORER_BROWSER_FILL_FLAGS dwFlags):HRESULT
  RemoveAll			stdmethod(IExplorerBrowser *THIS):HRESULT
  GetCurrentView		stdmethod(IExplorerBrowser *THIS, REFIID riid, void **ppv):HRESULT
endi

interface IEnumObjects extends IUnknown
  GUID				2C1C7E2E-2D0E-4059-831E-1E6F82335C2E
  Next				stdmethod(IEnumObjects *THIS, ULONG celt, REFIID riid, void **rgelt, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumObjects *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumObjects *THIS):HRESULT
  Clone 			stdmethod(IEnumObjects *THIS, IEnumObjects **ppenum):HRESULT
endi

interface IOperationsProgressDialog extends IUnknown
  GUID				0C9FB851-E5C9-43EB-A370-F0677B13874C
  StartProgressDialog		stdmethod(IOperationsProgressDialog *THIS, HWND hwndOwner, OPPROGDLGF flags):HRESULT
  StopProgressDialog		stdmethod(IOperationsProgressDialog *THIS):HRESULT
  SetOperation			stdmethod(IOperationsProgressDialog *THIS, SPACTION action):HRESULT
  SetMode			stdmethod(IOperationsProgressDialog *THIS, PDMODE mode):HRESULT
  UpdateProgress		stdmethod(IOperationsProgressDialog *THIS, ULONGLONG ullPointsCurrent, ULONGLONG ullPointsTotal, ULONGLONG ullSizeCurrent, ULONGLONG ullSizeTotal, ULONGLONG ullItemsCurrent, ULONGLONG ullItemsTotal):HRESULT
  UpdateLocations		stdmethod(IOperationsProgressDialog *THIS, IShellItem *psiSource, IShellItem *psiTarget, IShellItem *psiItem):HRESULT
  ResetTimer			stdmethod(IOperationsProgressDialog *THIS):HRESULT
  PauseTimer			stdmethod(IOperationsProgressDialog *THIS):HRESULT
  ResumeTimer			stdmethod(IOperationsProgressDialog *THIS):HRESULT
  GetMilliseconds		stdmethod(IOperationsProgressDialog *THIS, ULONGLONG *pullElapsed, ULONGLONG *pullRemaining):HRESULT
  GetOperationStatus		stdmethod(IOperationsProgressDialog *THIS, PDOPSTATUS *popstatus):HRESULT
endi

interface IIOCancelInformation extends IUnknown
  GUID				F5B0BF81-8CB5-4B1B-9449-1A159E0C733C
  SetCancelInformation		stdmethod(IIOCancelInformation *THIS, DWORD dwThreadID, UINT uMsgCancel):HRESULT
  GetCancelInformation		stdmethod(IIOCancelInformation *THIS, DWORD *pdwThreadID, UINT *puMsgCancel):HRESULT
endi

interface IFileOperation extends IUnknown
  GUID				947AAB5F-0A5C-4C13-B4D6-4BF7836FC9F8
  Advise			stdmethod(IFileOperation *THIS, IFileOperationProgressSink *pfops, DWORD *pdwCookie):HRESULT
  Unadvise			stdmethod(IFileOperation *THIS, DWORD dwCookie):HRESULT
  SetOperationFlags		stdmethod(IFileOperation *THIS, DWORD dwOperationFlags):HRESULT
  SetProgressMessage		stdmethod(IFileOperation *THIS, LPCWSTR pszMessage):HRESULT
  SetProgressDialog		stdmethod(IFileOperation *THIS, IOperationsProgressDialog *popd):HRESULT
  SetProperties 		stdmethod(IFileOperation *THIS, IPropertyChangeArray *pproparray):HRESULT
  SetOwnerWindow		stdmethod(IFileOperation *THIS, HWND hwndOwner):HRESULT
  ApplyPropertiesToItem 	stdmethod(IFileOperation *THIS, IShellItem *psiItem):HRESULT
  ApplyPropertiesToItems	stdmethod(IFileOperation *THIS, IUnknown *punkItems):HRESULT
  RenameItem			stdmethod(IFileOperation *THIS, IShellItem *psiItem, LPCWSTR pszNewName, IFileOperationProgressSink *pfopsItem):HRESULT
  RenameItems			stdmethod(IFileOperation *THIS, IUnknown *pUnkItems, LPCWSTR pszNewName):HRESULT
  MoveItem			stdmethod(IFileOperation *THIS, IShellItem *psiItem, IShellItem *psiDestinationFolder, LPCWSTR pszNewName, IFileOperationProgressSink *pfopsItem):HRESULT
  MoveItems			stdmethod(IFileOperation *THIS, IUnknown *punkItems, IShellItem *psiDestinationFolder):HRESULT
  CopyItem			stdmethod(IFileOperation *THIS, IShellItem *psiItem, IShellItem *psiDestinationFolder, LPCWSTR pszCopyName, IFileOperationProgressSink *pfopsItem):HRESULT
  CopyItems			stdmethod(IFileOperation *THIS, IUnknown *punkItems, IShellItem *psiDestinationFolder):HRESULT
  DeleteItem			stdmethod(IFileOperation *THIS, IShellItem *psiItem, IFileOperationProgressSink *pfopsItem):HRESULT
  DeleteItems			stdmethod(IFileOperation *THIS, IUnknown *punkItems):HRESULT
  NewItem			stdmethod(IFileOperation *THIS, IShellItem *psiDestinationFolder, DWORD dwFileAttributes, LPCWSTR pszName, LPCWSTR pszTemplateName, IFileOperationProgressSink *pfopsItem):HRESULT
  PerformOperations		stdmethod(IFileOperation *THIS):HRESULT
  GetAnyOperationsAborted	stdmethod(IFileOperation *THIS, BOOL *pfAnyOperationsAborted):HRESULT
endi

interface IObjectProvider extends IUnknown
  GUID				A6087428-3BE3-4D73-B308-7C04A540BF1A
  QueryObject			stdmethod(IObjectProvider *THIS, REFGUID guidObject, REFIID riid, void **ppvOut):HRESULT
endi

interface INamespaceWalkCB extends IUnknown
  GUID				D92995F8-CF5E-4A76-BF59-EAD39EA2B97E
  FoundItem			stdmethod(INamespaceWalkCB *THIS, IShellFolder *psf, PCUITEMID_CHILD pidl):HRESULT
  EnterFolder			stdmethod(INamespaceWalkCB *THIS, IShellFolder *psf, PCUITEMID_CHILD pidl):HRESULT
  LeaveFolder			stdmethod(INamespaceWalkCB *THIS, IShellFolder *psf, PCUITEMID_CHILD pidl):HRESULT
  InitializeProgressDialog	stdmethod(INamespaceWalkCB *THIS, LPWSTR *ppszTitle, LPWSTR *ppszCancel):HRESULT
endi

interface INamespaceWalkCB2 extends INamespaceWalkCB
  GUID				7AC7492B-C38E-438A-87DB-68737844FF70
  WalkComplete			stdmethod(INamespaceWalkCB2 *THIS, HRESULT hr):HRESULT
endi

interface INamespaceWalk extends IUnknown
  GUID				57CED8A7-3F4A-432C-9350-30F24483F74F
  Walk				stdmethod(INamespaceWalk *THIS, IUnknown *punkToWalk, DWORD dwFlags, int cDepth, INamespaceWalkCB *pnswcb):HRESULT
  GetIDArrayResult		stdmethod(INamespaceWalk *THIS, UINT *pcItems, PIDLIST_ABSOLUTE **prgpidl):HRESULT
endi

interface IBandSite extends IUnknown
  GUID				4CF504B0-DE96-11D0-8B3F-00A0C911E8E5
  AddBand			stdmethod(IBandSite *THIS, IUnknown *punk):HRESULT
  EnumBands			stdmethod(IBandSite *THIS, UINT uBand, DWORD *pdwBandID):HRESULT
  QueryBand			stdmethod(IBandSite *THIS, DWORD dwBandID, IDeskBand **ppstb, DWORD *pdwState, LPWSTR pszName, int cchName):HRESULT
  SetBandState			stdmethod(IBandSite *THIS, DWORD dwBandID, DWORD dwMask, DWORD dwState):HRESULT
  RemoveBand			stdmethod(IBandSite *THIS, DWORD dwBandID):HRESULT
  GetBandObject 		stdmethod(IBandSite *THIS, DWORD dwBandID, REFIID riid, void **ppv):HRESULT
  SetBandSiteInfo		stdmethod(IBandSite *THIS, const BANDSITEINFO *pbsinfo):HRESULT
  GetBandSiteInfo		stdmethod(IBandSite *THIS, BANDSITEINFO *pbsinfo):HRESULT
endi

interface IModalWindow extends IUnknown
  GUID				B4DB1657-70D7-485E-8E3E-6FCB5A5C1802
  Show				stdmethod(IModalWindow *THIS, HWND hwndOwner):HRESULT
endi

interface IContextMenuSite extends IUnknown
  GUID				0811AEBE-0B87-4C54-9E72-548CF649016B
  DoContextMenuPopup		stdmethod(IContextMenuSite *THIS, IUnknown *punkContextMenu, UINT fFlags, POINT pt):HRESULT
endi

interface IMenuBand extends IUnknown
  GUID				568804CD-CBD7-11D0-9816-00C04FD91972
  IsMenuMessage 		stdmethod(IMenuBand *THIS, MSG *pmsg):HRESULT
  TranslateMenuMessage		stdmethod(IMenuBand *THIS, MSG *pmsg, LRESULT *plRet):HRESULT
endi

interface IRegTreeItem extends IUnknown
  GUID				A9521922-0812-4D44-9EC3-7FD38C726F3D
  GetCheckState 		stdmethod(IRegTreeItem *THIS, BOOL *pbCheck):HRESULT
  SetCheckState 		stdmethod(IRegTreeItem *THIS, BOOL bCheck):HRESULT
endi

interface IDeskBar extends IOleWindow
  GUID				EB0FE173-1A3A-11D0-89B3-00A0C90A90AC
  SetClient			stdmethod(IDeskBar *THIS, IUnknown *punkClient):HRESULT
  GetClient			stdmethod(IDeskBar *THIS, IUnknown **ppunkClient):HRESULT
  OnPosRectChangeDB		stdmethod(IDeskBar *THIS, RECT *prc):HRESULT
endi

interface IMenuPopup extends IDeskBar
  GUID				D1E7AFEB-6A2E-11D0-8C78-00C04FD918B4
  Popup 			stdmethod(IMenuPopup *THIS, POINTL *ppt, RECTL *prcExclude, MP_POPUPFLAGS dwFlags):HRESULT
  OnSelect			stdmethod(IMenuPopup *THIS, DWORD dwSelectType):HRESULT
  SetSubMenu			stdmethod(IMenuPopup *THIS, IMenuPopup *pmp, BOOL fSet):HRESULT
endi

interface IFileIsInUse extends IUnknown
  GUID				64A1CBf0-3A1A-4461-9158-376969693950
  GetAppName			stdmethod(IFileIsInUse *THIS, LPWSTR *ppszName):HRESULT
  GetUsage			stdmethod(IFileIsInUse *THIS, FILE_USAGE_TYPE *pfut):HRESULT
  GetCapabilities		stdmethod(IFileIsInUse *THIS, DWORD *pdwCapFlags):HRESULT
  GetSwitchToHWND		stdmethod(IFileIsInUse *THIS, HWND *phwnd):HRESULT
  CloseFile			stdmethod(IFileIsInUse *THIS):HRESULT
endi

interface IFileDialogEvents extends IUnknown
  GUID				973510DB-7D7F-452B-8975-74A85828D354
  OnFileOk			stdmethod(IFileDialogEvents *THIS, IFileDialog *pfd):HRESULT
  OnFolderChanging		stdmethod(IFileDialogEvents *THIS, IFileDialog *pfd, IShellItem *psiFolder):HRESULT
  OnFolderChange		stdmethod(IFileDialogEvents *THIS, IFileDialog *pfd):HRESULT
  OnSelectionChange		stdmethod(IFileDialogEvents *THIS, IFileDialog *pfd):HRESULT
  OnShareViolation		stdmethod(IFileDialogEvents *THIS, IFileDialog *pfd, IShellItem *psi, FDE_SHAREVIOLATION_RESPONSE *pResponse):HRESULT
  OnTypeChange			stdmethod(IFileDialogEvents *THIS, IFileDialog *pfd):HRESULT
  OnOverwrite			stdmethod(IFileDialogEvents *THIS, IFileDialog *pfd, IShellItem *psi, FDE_OVERWRITE_RESPONSE *pResponse):HRESULT
endi

interface IFileDialog extends IModalWindow
  GUID				42F85136-DB7E-439C-85F1-E4075D135FC8
  SetFileTypes			stdmethod(IFileDialog *THIS, UINT cFileTypes, const COMDLG_FILTERSPEC *rgFilterSpec):HRESULT
  SetFileTypeIndex		stdmethod(IFileDialog *THIS, UINT iFileType):HRESULT
  GetFileTypeIndex		stdmethod(IFileDialog *THIS, UINT *piFileType):HRESULT
  Advise			stdmethod(IFileDialog *THIS, IFileDialogEvents *pfde, DWORD *pdwCookie):HRESULT
  Unadvise			stdmethod(IFileDialog *THIS, DWORD dwCookie):HRESULT
  SetOptions			stdmethod(IFileDialog *THIS, FILEOPENDIALOGOPTIONS fos):HRESULT
  GetOptions			stdmethod(IFileDialog *THIS, FILEOPENDIALOGOPTIONS *pfos):HRESULT
  SetDefaultFolder		stdmethod(IFileDialog *THIS, IShellItem *psi):HRESULT
  SetFolder			stdmethod(IFileDialog *THIS, IShellItem *psi):HRESULT
  GetFolder			stdmethod(IFileDialog *THIS, IShellItem **ppsi):HRESULT
  GetCurrentSelection		stdmethod(IFileDialog *THIS, IShellItem **ppsi):HRESULT
  SetFileName			stdmethod(IFileDialog *THIS, LPCWSTR pszName):HRESULT
  GetFileName			stdmethod(IFileDialog *THIS, LPWSTR *pszName):HRESULT
  SetTitle			stdmethod(IFileDialog *THIS, LPCWSTR pszTitle):HRESULT
  SetOkButtonLabel		stdmethod(IFileDialog *THIS, LPCWSTR pszText):HRESULT
  SetFileNameLabel		stdmethod(IFileDialog *THIS, LPCWSTR pszLabel):HRESULT
  GetResult			stdmethod(IFileDialog *THIS, IShellItem **ppsi):HRESULT
  AddPlace			stdmethod(IFileDialog *THIS, IShellItem *psi, FDAP fdap):HRESULT
  SetDefaultExtension		stdmethod(IFileDialog *THIS, LPCWSTR pszDefaultExtension):HRESULT
  Close 			stdmethod(IFileDialog *THIS, HRESULT hr):HRESULT
  SetClientGuid 		stdmethod(IFileDialog *THIS, REFGUID guid):HRESULT
  ClearClientData		stdmethod(IFileDialog *THIS):HRESULT
  SetFilter			stdmethod(IFileDialog *THIS, IShellItemFilter *pFilter):HRESULT
endi

interface IFileSaveDialog extends IFileDialog
  GUID				84BCCD23-5FDE-4CDB-AEA4-AF64b83D78AB
  SetSaveAsItem 		stdmethod(IFileSaveDialog *THIS, IShellItem *psi):HRESULT
  SetProperties 		stdmethod(IFileSaveDialog *THIS, IPropertyStore *pStore):HRESULT
  SetCollectedProperties	stdmethod(IFileSaveDialog *THIS, IPropertyDescriptionList *pList, BOOL fAppendDefault):HRESULT
  GetProperties 		stdmethod(IFileSaveDialog *THIS, IPropertyStore **ppStore):HRESULT
  ApplyProperties		stdmethod(IFileSaveDialog *THIS, IShellItem *psi, IPropertyStore *pStore, HWND hwnd, IFileOperationProgressSink *pSink):HRESULT
endi

interface IFileOpenDialog extends IFileDialog
  GUID				D57C7288-D4AD-4768-BE02-9D969532D960
  GetResults			stdmethod(IFileOpenDialog *THIS, IShellItemArray **ppenum):HRESULT
  GetSelectedItems		stdmethod(IFileOpenDialog *THIS, IShellItemArray **ppsai):HRESULT
endi

interface IFileDialogCustomize extends IUnknown
  GUID				E6FDD21A-163F-4975-9C8C-A69F1BA37034
  EnableOpenDropDown		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl):HRESULT
  AddMenu			stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, LPCWSTR pszLabel):HRESULT
  AddPushButton 		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, LPCWSTR pszLabel):HRESULT
  AddComboBox			stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl):HRESULT
  AddRadioButtonList		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl):HRESULT
  AddCheckButton		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, LPCWSTR pszLabel, BOOL bChecked):HRESULT
  AddEditBox			stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, LPCWSTR pszText):HRESULT
  AddSeparator			stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl):HRESULT
  AddText			stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, LPCWSTR pszText):HRESULT
  SetControlLabel		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, LPCWSTR pszLabel):HRESULT
  GetControlState		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, CDCONTROLSTATEF *pdwState):HRESULT
  SetControlState		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, CDCONTROLSTATEF dwState):HRESULT
  GetEditBoxText		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, WCHAR **ppszText):HRESULT
  SetEditBoxText		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, LPCWSTR pszText):HRESULT
  GetCheckButtonState		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, BOOL *pbChecked):HRESULT
  SetCheckButtonState		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl):HRESULT
  AddControlItem		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, DWORD dwIDItem, LPCWSTR pszLabel):HRESULT
  RemoveControlItem		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, DWORD dwIDItem):HRESULT
  RemoveAllControlItems 	stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl):HRESULT
  GetControlItemState		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, DWORD dwIDItem, CDCONTROLSTATEF *pdwState):HRESULT
  SetControlItemState		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, DWORD dwIDItem, CDCONTROLSTATEF dwState):HRESULT
  GetSelectedControlItem	stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, DWORD *pdwIDItem):HRESULT
  SetSelectedControlItem	stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, DWORD dwIDItem):HRESULT
  StartVisualGroup		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, LPCWSTR pszLabel):HRESULT
  EndVisualGroup		stdmethod(IFileDialogCustomize *THIS):HRESULT
  MakeProminent 		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl):HRESULT
  SetControlItemText		stdmethod(IFileDialogCustomize *THIS, DWORD dwIDCtl, DWORD dwIDItem, LPCWSTR pszLabel):HRESULT
endi

interface IApplicationAssociationRegistration extends IUnknown
  GUID				4E530B0A-E611-4C77-A3AC-9031D022281B
  QueryCurrentDefault		stdmethod(IApplicationAssociationRegistration *THIS, LPCWSTR pszQuery, ASSOCIATIONTYPE atQueryType, ASSOCIATIONLEVEL alQueryLevel, LPWSTR *ppszAssociation):HRESULT
  QueryAppIsDefault		stdmethod(IApplicationAssociationRegistration *THIS, LPCWSTR pszQuery, ASSOCIATIONTYPE atQueryType, ASSOCIATIONLEVEL alQueryLevel, LPCWSTR pszAppRegistryName, BOOL *pfDefault):HRESULT
  QueryAppIsDefaultAll		stdmethod(IApplicationAssociationRegistration *THIS, ASSOCIATIONLEVEL alQueryLevel, LPCWSTR pszAppRegistryName, BOOL *pfDefault):HRESULT
  SetAppAsDefault		stdmethod(IApplicationAssociationRegistration *THIS, LPCWSTR pszAppRegistryName, LPCWSTR pszSet, ASSOCIATIONTYPE atSetType):HRESULT
  SetAppAsDefaultAll		stdmethod(IApplicationAssociationRegistration *THIS, LPCWSTR pszAppRegistryName):HRESULT
  ClearUserAssociations 	stdmethod(IApplicationAssociationRegistration *THIS):HRESULT
endi

interface IDelegateFolder extends IUnknown
  GUID				ADD8BA80-002B-11D0-8F0F-00C04FD7D062
  SetItemAlloc			stdmethod(IDelegateFolder *THIS, IMalloc *pmalloc):HRESULT
endi

interface IBrowserFrameOptions extends IUnknown
  GUID				10DF43C8-1DBE-11D3-8B34-006097DF5BD4
  GetFrameOptions		stdmethod(IBrowserFrameOptions *THIS, BROWSERFRAMEOPTIONS dwMask, BROWSERFRAMEOPTIONS *pdwOptions):HRESULT
endi

interface INewWindowManager extends IUnknown
  GUID				D2BC4C84-3F72-4A52-A604-7BCBF3982CBB
  EvaluateNewWindow		stdmethod(INewWindowManager *THIS, LPCWSTR pszUrl, LPCWSTR pszName, LPCWSTR pszUrlContext, LPCWSTR pszFeatures, BOOL fReplace, DWORD dwFlags, DWORD dwUserActionTime):HRESULT
endi

interface IAttachmentExecute extends IUnknown
  GUID				73DB1241-1E85-4581-8E4F-A81E1D0D8C57
  SetClientTitle		stdmethod(IAttachmentExecute *THIS, LPCWSTR pszTitle):HRESULT
  SetClientGuid 		stdmethod(IAttachmentExecute *THIS, REFGUID guid):HRESULT
  SetLocalPath			stdmethod(IAttachmentExecute *THIS, LPCWSTR pszLocalPath):HRESULT
  SetFileName			stdmethod(IAttachmentExecute *THIS, LPCWSTR pszFileName):HRESULT
  SetSource			stdmethod(IAttachmentExecute *THIS, LPCWSTR pszSource):HRESULT
  SetReferrer			stdmethod(IAttachmentExecute *THIS, LPCWSTR pszReferrer):HRESULT
  CheckPolicy			stdmethod(IAttachmentExecute *THIS):HRESULT
  Prompt			stdmethod(IAttachmentExecute *THIS, HWND hwnd, ATTACHMENT_PROMPT prompt, ATTACHMENT_ACTION *paction):HRESULT
  Save				stdmethod(IAttachmentExecute *THIS):HRESULT
  Execute			stdmethod(IAttachmentExecute *THIS, HWND hwnd, LPCWSTR pszVerb, HANDLE *phProcess):HRESULT
  SaveWithUI			stdmethod(IAttachmentExecute *THIS, HWND hwnd):HRESULT
  ClearClientState		stdmethod(IAttachmentExecute *THIS):HRESULT
endi

interface IShellMenuCallback extends IUnknown
  GUID				4CA300A1-9B8D-11D1-8B22-00C04FD918D0
  CallbackSM			stdmethod(IShellMenuCallback *THIS, LPSMDATA psmd, UINT uMsg, WPARAM wParam, LPARAM lParam):HRESULT
endi

interface IShellMenu extends IUnknown
  GUID				EE1F7637-E138-11D1-8379-00C04FD918D0
  Initialize			stdmethod(IShellMenu *THIS, IShellMenuCallback *psmc, UINT uId, UINT uIdAncestor, DWORD dwFlags):HRESULT
  GetMenuInfo			stdmethod(IShellMenu *THIS, IShellMenuCallback **ppsmc, UINT *puId, UINT *puIdAncestor, DWORD *pdwFlags):HRESULT
  SetShellFolder		stdmethod(IShellMenu *THIS, IShellFolder *psf, PCIDLIST_ABSOLUTE pidlFolder, HKEY hKey, DWORD dwFlags):HRESULT
  GetShellFolder		stdmethod(IShellMenu *THIS, DWORD *pdwFlags, PIDLIST_ABSOLUTE *ppidl, REFIID riid, void **ppv):HRESULT
  SetMenu			stdmethod(IShellMenu *THIS, HMENU hmenu, HWND hwnd, DWORD dwFlags):HRESULT
  GetMenu			stdmethod(IShellMenu *THIS, HMENU *phmenu, HWND *phwnd, DWORD *pdwFlags):HRESULT
  InvalidateItem		stdmethod(IShellMenu *THIS, LPSMDATA psmd, DWORD dwFlags):HRESULT
  GetState			stdmethod(IShellMenu *THIS, LPSMDATA psmd):HRESULT
  SetMenuToolbar		stdmethod(IShellMenu *THIS, IUnknown *punk, DWORD dwFlags):HRESULT
endi

interface IKnownFolder extends IUnknown
  GUID				3AA7AF7E-9B36-420C-A8E3-F77D4674A488
  GetId 			stdmethod(IKnownFolder *THIS, KNOWNFOLDERID *pkfid):HRESULT
  GetCategory			stdmethod(IKnownFolder *THIS, KF_CATEGORY *pCategory):HRESULT
  GetShellItem			stdmethod(IKnownFolder *THIS, DWORD dwFlags, REFIID riid, void **ppv):HRESULT
  GetPath			stdmethod(IKnownFolder *THIS, DWORD dwFlags, LPWSTR *ppszPath):HRESULT
  SetPath			stdmethod(IKnownFolder *THIS, DWORD dwFlags, LPCWSTR pszPath):HRESULT
  GetIDList			stdmethod(IKnownFolder *THIS, DWORD dwFlags, PIDLIST_ABSOLUTE *ppidl):HRESULT
  GetFolderType 		stdmethod(IKnownFolder *THIS, FOLDERTYPEID *pftid):HRESULT
  GetRedirectionCapabilities	stdmethod(IKnownFolder *THIS, KF_REDIRECTION_CAPABILITIES *pCapabilities):HRESULT
  GetFolderDefinition		stdmethod(IKnownFolder *THIS, KNOWNFOLDER_DEFINITION *pKFD):HRESULT
endi

interface IKnownFolderManager extends IUnknown
  GUID				8BE2D872-86AA-4D47-B776-32CCA40C7018
  FolderIdFromCsidl		stdmethod(IKnownFolderManager *THIS, int nCsidl, KNOWNFOLDERID *pfid):HRESULT
  FolderIdToCsidl		stdmethod(IKnownFolderManager *THIS, REFKNOWNFOLDERID rfid, int *pnCsidl):HRESULT
  GetFolderIds			stdmethod(IKnownFolderManager *THIS, KNOWNFOLDERID **ppKFId, UINT *pCount):HRESULT
  GetFolder			stdmethod(IKnownFolderManager *THIS, REFKNOWNFOLDERID rfid, IKnownFolder **ppkf):HRESULT
  GetFolderByName		stdmethod(IKnownFolderManager *THIS, LPCWSTR pszCanonicalName, IKnownFolder **ppkf):HRESULT
  RegisterFolder		stdmethod(IKnownFolderManager *THIS, REFKNOWNFOLDERID rfid, const KNOWNFOLDER_DEFINITION *pKFD):HRESULT
  UnregisterFolder		stdmethod(IKnownFolderManager *THIS, REFKNOWNFOLDERID rfid):HRESULT
  FindFolderFromPath		stdmethod(IKnownFolderManager *THIS, LPCWSTR pszPath, FFFP_MODE mode, IKnownFolder **ppkf):HRESULT
  FindFolderFromIDList		stdmethod(IKnownFolderManager *THIS, PCIDLIST_ABSOLUTE pidl, IKnownFolder **ppkf):HRESULT
  Redirect			stdmethod(IKnownFolderManager *THIS, REFKNOWNFOLDERID rfid, HWND hwnd, KF_REDIRECT_FLAGS flags, LPCWSTR pszTargetPath, UINT cFolders, const KNOWNFOLDERID *pExclusion, LPWSTR *ppszError):HRESULT
endi

interface ISharingConfigurationManager extends IUnknown
  GUID				B4CD448A-9C86-4466-9201-2E62105B87AE
  CreateShare			stdmethod(ISharingConfigurationManager *THIS, DEF_SHARE_ID dsid, SHARE_ROLE role):HRESULT
  DeleteShare			stdmethod(ISharingConfigurationManager *THIS, DEF_SHARE_ID dsid):HRESULT
  ShareExists			stdmethod(ISharingConfigurationManager *THIS, DEF_SHARE_ID dsid):HRESULT
  GetSharePermissions		stdmethod(ISharingConfigurationManager *THIS, DEF_SHARE_ID dsid, SHARE_ROLE *prole):HRESULT
  SharePrinters 		stdmethod(ISharingConfigurationManager *THIS):HRESULT
  StopSharingPrinters		stdmethod(ISharingConfigurationManager *THIS):HRESULT
  ArePrintersShared		stdmethod(ISharingConfigurationManager *THIS):HRESULT
endi

interface IRelatedItem extends IUnknown
  GUID				A73CE67A-8AB1-44F1-8D43-D2FCBF6B1CD0
  GetItemIDList 		stdmethod(IRelatedItem *THIS, PIDLIST_ABSOLUTE *ppidl):HRESULT
  GetItem			stdmethod(IRelatedItem *THIS, IShellItem **ppsi):HRESULT
endi

interface IIdentityName extends IRelatedItem
  GUID				7D903FCA-D6F9-4810-8332-946C0177E247
endi

interface IDelegateItem extends IRelatedItem
  GUID				3C5A1C94-C951-4CB7-BB6D-3B93F30CCE93
endi

interface ICurrentItem extends IRelatedItem
  GUID				240A7174-D653-4A1D-A6D3-D4943CFBFE3D
endi

interface ITransferMediumItem extends IRelatedItem
  GUID				77F295D5-2D6F-4E19-B8AE-322F3E721AB5
endi

interface IDisplayItem extends IRelatedItem
  GUID				C6FD5997-9F6B-4888-8703-94E80E8CDE3F
endi

interface IViewStateIdentityItem extends IRelatedItem
  GUID				9D264146-A94F-4195-9F9F-3BB12CE0C955
endi

interface IPreviewItem extends IRelatedItem
  GUID				36149969-0A8F-49C8-8B00-4AECB20222FB
endi

interface IDestinationStreamFactory extends IUnknown
  GUID				8A87781B-39A7-4A1F-AAB3-A39B9C34A7D9
  GetDestinationStream		stdmethod(IDestinationStreamFactory *THIS, IStream **ppstml):HRESULT
endi

interface ICreateProcessInputs extends IUnknown
  GUID				F6EF6140-E26F-4D82-BAC4-E9BA5FD239A8
  GetCreateFlags		stdmethod(ICreateProcessInputs *THIS, DWORD *pdwCreationFlags):HRESULT
  SetCreateFlags		stdmethod(ICreateProcessInputs *THIS, DWORD dwCreationFlags):HRESULT
  AddCreateFlags		stdmethod(ICreateProcessInputs *THIS, DWORD dwCreationFlags):HRESULT
  SetHotKey			stdmethod(ICreateProcessInputs *THIS, WORD wHotKey):HRESULT
  AddStartupFlags		stdmethod(ICreateProcessInputs *THIS, DWORD dwStartupInfoFlags):HRESULT
  SetTitle			stdmethod(ICreateProcessInputs *THIS, LPCWSTR pszTitle):HRESULT
  SetEnvironmentVariable	stdmethod(ICreateProcessInputs *THIS, LPCWSTR pszName, LPCWSTR pszValue):HRESULT
endi

interface ICreatingProcess extends IUnknown
  GUID				C2B937A9-3110-4398-8A56-F34C6342D244
  OnCreating			stdmethod(ICreatingProcess *THIS, ICreateProcessInputs *pcpi):HRESULT
endi

interface INewMenuClient extends IUnknown
  GUID				DCB07FDC-3BB5-451C-90BE-966644FED7B0
  IncludeItems			stdmethod(INewMenuClient *THIS, NMCII_FLAGS *pflags):HRESULT
  SelectAndEditItem		stdmethod(INewMenuClient *THIS, PCIDLIST_ABSOLUTE pidlItem, NMCII_FLAGS flags):HRESULT
endi

interface IInitializeWithBindCtx extends IUnknown
  GUID				71C0D2BC-726D-45CC-A6C0-2E31C1DB2159
  Initialize			stdmethod(IInitializeWithBindCtx *THIS, IBindCtx *pbc):HRESULT
endi

interface IShellItemFilter extends IUnknown
  GUID				2659B475-EEB8-48B7-8F07-B378810F48CF
  IncludeItem			stdmethod(IShellItemFilter *THIS, IShellItem *psi):HRESULT
  GetEnumFlagsForItem		stdmethod(IShellItemFilter *THIS, IShellItem *psi, SHCONTF *pgrfFlags):HRESULT
endi

interface INameSpaceTreeControl extends IUnknown
  GUID				028212A3-B627-47E9-8856-C14265554E4F
  Initialize			stdmethod(INameSpaceTreeControl *THIS, HWND hwndParent, RECT *prc, NSTCSTYLE nsctsFlags):HRESULT
  TreeAdvise			stdmethod(INameSpaceTreeControl *THIS, IUnknown *punk, DWORD *pdwCookie):HRESULT
  TreeUnadvise			stdmethod(INameSpaceTreeControl *THIS, DWORD dwCookie):HRESULT
  AppendRoot			stdmethod(INameSpaceTreeControl *THIS, IShellItem *psiRoot, SHCONTF grfEnumFlags, NSTCROOTSTYLE grfRootStyle, IShellItemFilter *pif):HRESULT
  InsertRoot			stdmethod(INameSpaceTreeControl *THIS, int iIndex, IShellItem *psiRoot, SHCONTF grfEnumFlags, NSTCROOTSTYLE grfRootStyle, IShellItemFilter *pif):HRESULT
  RemoveRoot			stdmethod(INameSpaceTreeControl *THIS, IShellItem *psiRoot):HRESULT
  RemoveAllRoots		stdmethod(INameSpaceTreeControl *THIS):HRESULT
  GetRootItems			stdmethod(INameSpaceTreeControl *THIS, IShellItemArray **ppsiaRootItems):HRESULT
  SetItemState			stdmethod(INameSpaceTreeControl *THIS, IShellItem *psi, NSTCITEMSTATE nstcisMask, NSTCITEMSTATE nstcisFlags):HRESULT
  GetItemState			stdmethod(INameSpaceTreeControl *THIS, IShellItem *psi, NSTCITEMSTATE nstcisMask, NSTCITEMSTATE *pnstcisFlags):HRESULT
  GetSelectedItems		stdmethod(INameSpaceTreeControl *THIS, IShellItemArray **psiaItems):HRESULT
  GetItemCustomState		stdmethod(INameSpaceTreeControl *THIS, IShellItem *psi, int *piStateNumber):HRESULT
  SetItemCustomState		stdmethod(INameSpaceTreeControl *THIS, IShellItem *psi, int iStateNumber):HRESULT
  EnsureItemVisible		stdmethod(INameSpaceTreeControl *THIS, IShellItem *psi):HRESULT
  SetTheme			stdmethod(INameSpaceTreeControl *THIS, LPCWSTR pszTheme):HRESULT
  GetNextItem			stdmethod(INameSpaceTreeControl *THIS, IShellItem *psi, NSTCGNI nstcgi, IShellItem **ppsiNext):HRESULT
  HitTest			stdmethod(INameSpaceTreeControl *THIS, POINT *ppt, IShellItem **ppsiOut):HRESULT
  GetItemRect			stdmethod(INameSpaceTreeControl *THIS, IShellItem *psi, RECT *prect):HRESULT
  CollapseAll			stdmethod(INameSpaceTreeControl *THIS):HRESULT
endi

interface INameSpaceTreeControlFolderCapabilities extends IUnknown
  GUID				E9701183-E6B3-4FF2-8568-813615FEC7BE
  GetFolderCapabilities 	stdmethod(INameSpaceTreeControlFolderCapabilities *THIS, NSTCFOLDERCAPABILITIES nfcMask, NSTCFOLDERCAPABILITIES *pnfcValue):HRESULT
endi

interface IPreviewHandler extends IUnknown
  GUID				8895B1C6-B41F-4C1C-A562-0D564250836F
  SetWindow			stdmethod(IPreviewHandler *THIS, HWND hwnd, const RECT *prc):HRESULT
  SetRect			stdmethod(IPreviewHandler *THIS, const RECT *prc):HRESULT
  DoPreview			stdmethod(IPreviewHandler *THIS):HRESULT
  Unload			stdmethod(IPreviewHandler *THIS):HRESULT
  SetFocus			stdmethod(IPreviewHandler *THIS):HRESULT
  QueryFocus			stdmethod(IPreviewHandler *THIS, HWND *phwnd):HRESULT
  TranslateAccelerator		stdmethod(IPreviewHandler *THIS, MSG *pmsg):HRESULT
endi

interface IPreviewHandlerFrame extends IUnknown
  GUID				FEC87AAF-35F9-447A-ADB7-20234491401A
  GetWindowContext		stdmethod(IPreviewHandlerFrame *THIS, PREVIEWHANDLERFRAMEINFO *pinfo):HRESULT
  TranslateAccelerator		stdmethod(IPreviewHandlerFrame *THIS, MSG *pmsg):HRESULT
endi

interface IExplorerPaneVisibility extends IUnknown
  GUID				E07010EC-BC17-44C0-97B0-46C7C95B9EDC
  GetPaneState			stdmethod(IExplorerPaneVisibility *THIS, REFEXPLORERPANE ep, EXPLORERPANESTATE *peps):HRESULT
endi

interface IContextMenuCB extends IUnknown
  GUID				3409E930-5A39-11D1-83FA-00A0C90DC849
  CallBack			stdmethod(IContextMenuCB *THIS, IShellFolder *psf, HWND hwndOwner, IDataObject *pdtobj, UINT uMsg, WPARAM wParam, LPARAM lParam):HRESULT
endi

interface IDefaultExtractIconInit extends IUnknown
  GUID				41DED17D-D6D3-4261-997D-88C60E4B1D58
  SetFlags			stdmethod(IDefaultExtractIconInit *THIS, UINT uFlags):HRESULT
  SetKey			stdmethod(IDefaultExtractIconInit *THIS, HKEY hkey):HRESULT
  SetNormalIcon 		stdmethod(IDefaultExtractIconInit *THIS, LPCWSTR pszFile, int iIcon):HRESULT
  SetOpenIcon			stdmethod(IDefaultExtractIconInit *THIS, LPCWSTR pszFile, int iIcon):HRESULT
  SetShortcutIcon		stdmethod(IDefaultExtractIconInit *THIS, LPCWSTR pszFile, int iIcon):HRESULT
  SetDefaultIcon		stdmethod(IDefaultExtractIconInit *THIS, LPCWSTR pszFile, int iIcon):HRESULT
endi

interface IExplorerCommand extends IUnknown
  GUID				A08CE4D0-FA25-44AB-B57C-C7B1C323E0B9
  GetTitle			stdmethod(IExplorerCommand *THIS, IShellItemArray *psiItemArray, LPWSTR *ppszName):HRESULT
  GetIcon			stdmethod(IExplorerCommand *THIS, IShellItemArray *psiItemArray, LPWSTR *ppszIcon):HRESULT
  GetToolTip			stdmethod(IExplorerCommand *THIS, IShellItemArray *psiItemArray, LPWSTR *ppszInfotip):HRESULT
  GetCanonicalName		stdmethod(IExplorerCommand *THIS, GUID *pguidCommandName):HRESULT
  GetState			stdmethod(IExplorerCommand *THIS, IShellItemArray *psiItemArray, BOOL fOkToBeSlow, EXPCMDSTATE *pCmdState):HRESULT
  Invoke			stdmethod(IExplorerCommand *THIS, IShellItemArray *psiItemArray, IBindCtx *pbc):HRESULT
  GetFlags			stdmethod(IExplorerCommand *THIS, EXPCMDFLAGS *pFlags):HRESULT
  EnumSubCommands		stdmethod(IExplorerCommand *THIS, IEnumExplorerCommand **ppEnum):HRESULT
endi

interface IExplorerCommandState extends IUnknown
  GUID				BDDACB60-7657-47AE-8445-D23E1ACF82AE
  GetState			stdmethod(IExplorerCommandState *THIS, IShellItemArray *psiItemArray, BOOL fOkToBeSlow, EXPCMDSTATE *pCmdState):HRESULT
endi

interface IInitializeCommand extends IUnknown
  GUID				85075ACF-231F-40EA-9610-D26B7B58F638
  Initialize			stdmethod(IInitializeCommand *THIS, LPCWSTR pszCommandName, IPropertyBag *ppb):HRESULT
endi

interface IEnumExplorerCommand extends IUnknown
  GUID				A88826F8-186F-4987-AADE-EA0CEF8FBFE8
  Next				stdmethod(IEnumExplorerCommand *THIS, ULONG celt, IExplorerCommand **pUICommand, ULONG *pceltFetched):HRESULT
  Skip				stdmethod(IEnumExplorerCommand *THIS, ULONG celt):HRESULT
  Reset 			stdmethod(IEnumExplorerCommand *THIS):HRESULT
  Clone 			stdmethod(IEnumExplorerCommand *THIS, IEnumExplorerCommand **ppenum):HRESULT
endi

interface IExplorerCommandProvider extends IUnknown
  GUID				64961751-0835-43C0-8FFE-D57686530E64
  GetCommands			stdmethod(IExplorerCommandProvider *THIS, IUnknown *punkSite, REFIID riid, void **ppv):HRESULT
  GetCommand			stdmethod(IExplorerCommandProvider *THIS, REFGUID rguidCommandId, REFIID riid, void **ppv):HRESULT
endi

interface IOpenControlPanel extends IUnknown
  GUID				D11AD862-66DE-4DF4-BF6C-1F5621996AF1
  Open				stdmethod(IOpenControlPanel *THIS, LPCWSTR pszName, LPCWSTR pszPage, IUnknown *punkSite):HRESULT
  GetPath			stdmethod(IOpenControlPanel *THIS, LPCWSTR pszName, LPWSTR pszPath, UINT cchPath):HRESULT
  GetCurrentView		stdmethod(IOpenControlPanel *THIS, LPCWSTR pszName, CPVIEW *pView):HRESULT
endi

interface IFileSystemBindData extends IUnknown
  GUID				01E18D10-4D8B-11D2-855D-006008059367
  SetFindData			stdmethod(IFileSystemBindData *THIS, const WIN32_FIND_DATAW *pfd):HRESULT
  GetFindData			stdmethod(IFileSystemBindData *THIS, WIN32_FIND_DATAW *pfd):HRESULT
endi

interface IFileSystemBindData2 extends IFileSystemBindData
  GUID				3ACF075F-71DB-4AFA-81F0-3FC4FDF2A5B8
  SetFileID			stdmethod(IFileSystemBindData2 *THIS, LARGE_INTEGER liFileID):HRESULT
  GetFileID			stdmethod(IFileSystemBindData2 *THIS, LARGE_INTEGER *pliFileID):HRESULT
  SetJunctionCLSID		stdmethod(IFileSystemBindData2 *THIS, REFCLSID clsid):HRESULT
  GetJunctionCLSID		stdmethod(IFileSystemBindData2 *THIS, CLSID *pclsid):HRESULT
endi

interface ICustomDestinationList extends IUnknown
  GUID				6332DEBF-87B5-4670-90C0-5E57B408A49E
  SetAppID			stdmethod(ICustomDestinationList *THIS, LPCWSTR pszAppID):HRESULT
  BeginList			stdmethod(ICustomDestinationList *THIS, UINT *pcMinSlots, REFIID riid, void **ppv):HRESULT
  AppendCategory		stdmethod(ICustomDestinationList *THIS, LPCWSTR pszCategory, IObjectArray *poa):HRESULT
  AppendKnownCategory		stdmethod(ICustomDestinationList *THIS, KNOWNDESTCATEGORY category):HRESULT
  AddUserTasks			stdmethod(ICustomDestinationList *THIS, IObjectArray *poa):HRESULT
  CommitList			stdmethod(ICustomDestinationList *THIS):HRESULT
  GetRemovedDestinations	stdmethod(ICustomDestinationList *THIS, REFIID riid, void **ppv):HRESULT
  DeleteList			stdmethod(ICustomDestinationList *THIS, LPCWSTR pszAppID):HRESULT
  AbortList			stdmethod(ICustomDestinationList *THIS):HRESULT
endi

interface IApplicationDestinations extends IUnknown
  GUID				12337D35-94C6-48A0-BCE7-6A9C69D4D600
  SetAppID			stdmethod(IApplicationDestinations *THIS, LPCWSTR pszAppID):HRESULT
  RemoveDestination		stdmethod(IApplicationDestinations *THIS, IUnknown *punk):HRESULT
  RemoveAllDestinations 	stdmethod(IApplicationDestinations *THIS):HRESULT
endi

interface IApplicationDocumentLists extends IUnknown
  GUID				01E18D10-4D8B-11D2-855D-006008059367
  SetAppID			stdmethod(IApplicationDocumentLists *THIS, LPCWSTR pszAppID):HRESULT
  GetList			stdmethod(IApplicationDocumentLists *THIS, APPDOCLISTTYPE listtype, UINT cItemsDesired, REFIID riid, void **ppv):HRESULT
endi

interface IObjectWithAppUserModelID extends IUnknown
  GUID				36DB0196-9665-46D1-9BA7-D3709EECF9ED
  SetAppID			stdmethod(IObjectWithAppUserModelID *THIS, LPCWSTR pszAppID):HRESULT
  GetAppID			stdmethod(IObjectWithAppUserModelID *THIS, LPWSTR *ppszAppID):HRESULT
endi

interface IObjectWithProgID extends IUnknown
  GUID				71E806FB-8DEE-46FC-BF8C-7748A8A1AE13
  SetProgID			stdmethod(IObjectWithProgID *THIS, LPCWSTR pszProgID):HRESULT
  GetProgID			stdmethod(IObjectWithProgID *THIS, LPWSTR *ppszProgID):HRESULT
endi

interface IUpdateIDList extends IUnknown
  GUID				6589B6D2-5F8D-4B9E-B7E0-23CDD9717D8C
  Update			stdmethod(IUpdateIDList *THIS, IBindCtx *pbc, PCUITEMID_CHILD pidlIn, PITEMID_CHILD *ppidlOut):HRESULT
endi

interface IDesktopWallpaper extends IUnknown
  GUID				B92B56A9-8B55-4E14-9A89-0199BBB6F93B
  SetWallpaper			stdmethod(IDesktopWallpaper *THIS, LPCWSTR monitorID, LPCWSTR wallpaper):HRESULT
  GetWallpaper			stdmethod(IDesktopWallpaper *THIS, LPCWSTR monitorID, LPWSTR *wallpaper):HRESULT
  GetMonitorDevicePathAt	stdmethod(IDesktopWallpaper *THIS, UINT monitorIndex, LPWSTR *monitorID):HRESULT
  GetMonitorDevicePathCount	stdmethod(IDesktopWallpaper *THIS, UINT *count):HRESULT
  GetMonitorRECT		stdmethod(IDesktopWallpaper *THIS, LPCWSTR monitorID, RECT *displayRect):HRESULT
  SetBackgroundColor		stdmethod(IDesktopWallpaper *THIS, COLORREF color):HRESULT
  GetBackgroundColor		stdmethod(IDesktopWallpaper *THIS, COLORREF *color):HRESULT
  SetPosition			stdmethod(IDesktopWallpaper *THIS, DESKTOP_WALLPAPER_POSITION position):HRESULT
  GetPosition			stdmethod(IDesktopWallpaper *THIS, DESKTOP_WALLPAPER_POSITION *position):HRESULT
  SetSlideshow			stdmethod(IDesktopWallpaper *THIS, IShellItemArray *items):HRESULT
  GetSlideshow			stdmethod(IDesktopWallpaper *THIS, IShellItemArray **items):HRESULT
  SetSlideshowOptions		stdmethod(IDesktopWallpaper *THIS, DESKTOP_SLIDESHOW_OPTIONS options, UINT slideshowTick):HRESULT
  GetSlideshowOptions		stdmethod(IDesktopWallpaper *THIS, DESKTOP_SLIDESHOW_OPTIONS *options, UINT *slideshowTick):HRESULT
  AdvanceSlideshow		stdmethod(IDesktopWallpaper *THIS, LPCWSTR monitorID, DESKTOP_SLIDESHOW_DIRECTION direction):HRESULT
  GetStatus			stdmethod(IDesktopWallpaper *THIS, DESKTOP_SLIDESHOW_STATE *state):HRESULT
  Enable			stdmethod(IDesktopWallpaper *THIS, BOOL enable):HRESULT
endi

interface IHomeGroup extends IUnknown
  GUID				7A3BD1D9-35A9-4FB3-A467-F48CAC35E2D0
  IsMember			stdmethod(IHomeGroup *THIS, BOOL *member):HRESULT
  ShowSharingWizard		stdmethod(IHomeGroup *THIS, HWND owner, HOMEGROUPSHARINGCHOICES *sharingchoices):HRESULT
endi

interface IInitializeWithPropertyStore extends IUnknown
  GUID				C3E12EB5-7D8D-44F8-B6DD-0E77B34D6DE4
  Initialize			stdmethod(IInitializeWithPropertyStore *THIS, IPropertyStore *pps):HRESULT
endi

interface IOpenSearchSource extends IUnknown
  GUID				F0EE7333-E6FC-479B-9F25-A860C234A38E
  GetResults			stdmethod(IOpenSearchSource *THIS, HWND hwnd, LPCWSTR pszQuery, DWORD dwStartIndex, DWORD dwCount, REFIID riid, void **ppv):HRESULT
endi

interface IShellLibrary extends IUnknown
  GUID				11A66EFA-382E-451A-9234-1E0E12EF3085
  LoadLibraryFromItem		stdmethod(IShellLibrary *THIS, IShellItem *psiLibrary, DWORD grfMode):HRESULT
  LoadLibraryFromKnownFolder	stdmethod(IShellLibrary *THIS, REFKNOWNFOLDERID kfidLibrary, DWORD grfMode):HRESULT
  AddFolder			stdmethod(IShellLibrary *THIS, IShellItem *psiLocation):HRESULT
  RemoveFolder			stdmethod(IShellLibrary *THIS, IShellItem *psiLocation):HRESULT
  GetFolders			stdmethod(IShellLibrary *THIS, LIBRARYFOLDERFILTER lff, REFIID riid, void **ppv):HRESULT
  ResolveFolder 		stdmethod(IShellLibrary *THIS, IShellItem *psiFolderToResolve, DWORD dwTimeout, REFIID riid, void **ppv):HRESULT
  GetDefaultSaveFolder		stdmethod(IShellLibrary *THIS, DEFAULTSAVEFOLDERTYPE dsft, REFIID riid, void **ppv):HRESULT
  SetDefaultSaveFolder		stdmethod(IShellLibrary *THIS, DEFAULTSAVEFOLDERTYPE dsft, IShellItem *psi):HRESULT
  GetOptions			stdmethod(IShellLibrary *THIS, LIBRARYOPTIONFLAGS *plofOptions):HRESULT
  SetOptions			stdmethod(IShellLibrary *THIS, LIBRARYOPTIONFLAGS lofMask, LIBRARYOPTIONFLAGS lofOptions):HRESULT
  GetFolderType 		stdmethod(IShellLibrary *THIS, FOLDERTYPEID *pftid):HRESULT
  SetFolderType 		stdmethod(IShellLibrary *THIS, REFFOLDERTYPEID ftid):HRESULT
  GetIcon			stdmethod(IShellLibrary *THIS, LPWSTR *ppszIcon):HRESULT
  SetIcon			stdmethod(IShellLibrary *THIS, LPCWSTR pszIcon):HRESULT
  Commit			stdmethod(IShellLibrary *THIS):HRESULT
  Save				stdmethod(IShellLibrary *THIS, IShellItem *psiFolderToSaveIn, LPCWSTR pszLibraryName, LIBRARYSAVEFLAGS lsf, IShellItem **ppsiSavedTo):HRESULT
  SaveInKnownFolder		stdmethod(IShellLibrary *THIS, REFKNOWNFOLDERID kfidToSaveIn, LPCWSTR pszLibraryName, LIBRARYSAVEFLAGS lsf, IShellItem **ppsiSavedTo):HRESULT
endi

interface IDefaultFolderMenuInitialize extends IUnknown
  GUID				7690AA79-F8FC-4615-A327-36F7D18F5D91
  Initialize			stdmethod(IDefaultFolderMenuInitialize *THIS, HWND hwnd, IContextMenuCB *pcmcb, PCIDLIST_ABSOLUTE pidlFolder, IShellFolder *psf, UINT cidl, PCUITEMID_CHILD_ARRAY apidl, IUnknown *punkAssociation, UINT cKeys, const HKEY *aKeys):HRESULT
  SetMenuRestrictions		stdmethod(IDefaultFolderMenuInitialize *THIS, DEFAULT_FOLDER_MENU_RESTRICTIONS dfmrValues):HRESULT
  GetMenuRestrictions		stdmethod(IDefaultFolderMenuInitialize *THIS, DEFAULT_FOLDER_MENU_RESTRICTIONS dfmrMask, DEFAULT_FOLDER_MENU_RESTRICTIONS *pdfmrValues):HRESULT
  SetHandlerClsid		stdmethod(IDefaultFolderMenuInitialize *THIS, REFCLSID rclsid):HRESULT
endi

interface IApplicationActivationManager extends IUnknown
  GUID				2E941141-7F97-4756-BA1D-9DECDE894A3D
  ActivateApplication		stdmethod(IApplicationActivationManager *THIS, LPCWSTR appUserModelId, LPCWSTR arguments, ACTIVATEOPTIONS options, DWORD *processId):HRESULT
  ActivateForFile		stdmethod(IApplicationActivationManager *THIS, LPCWSTR appUserModelId, IShellItemArray *itemArray, LPCWSTR verb, DWORD *processId):HRESULT
  ActivateForProtocol		stdmethod(IApplicationActivationManager *THIS, LPCWSTR appUserModelId, IShellItemArray *itemArray, DWORD *processId):HRESULT
endi

interface IAssocHandlerInvoker extends IUnknown
  GUID				92218CAB-ECAA-4335-8133-807FD234C2EE
  SupportsSelection		stdmethod(IAssocHandlerInvoker *THIS):HRESULT
  Invoke			stdmethod(IAssocHandlerInvoker *THIS):HRESULT
endi

interface IAssocHandler extends IUnknown
  GUID				F04061AC-1659-4A3F-A954-775AA57FC083
  GetName			stdmethod(IAssocHandler *THIS, LPWSTR *ppsz):HRESULT
  GetUIName			stdmethod(IAssocHandler *THIS, LPWSTR *ppsz):HRESULT
  GetIconLocation		stdmethod(IAssocHandler *THIS, LPWSTR *ppszPath, int *pIndex):HRESULT
  IsRecommended 		stdmethod(IAssocHandler *THIS):HRESULT
  MakeDefault			stdmethod(IAssocHandler *THIS, LPCWSTR pszDescription):HRESULT
  Invoke			stdmethod(IAssocHandler *THIS, IDataObject *pdo):HRESULT
  CreateInvoker 		stdmethod(IAssocHandler *THIS, IDataObject *pdo, IAssocHandlerInvoker **ppInvoker):HRESULT
endi

interface IEnumAssocHandlers extends IUnknown
  GUID				973810AE-9599-4B88-9E4D-6EE98C9552DA
  Next				stdmethod(IEnumAssocHandlers *THIS, ULONG celt, IAssocHandler **rgelt, ULONG *pceltFetched):HRESULT
endi

interface IDataObjectProvider extends IUnknown
  GUID				3D25F6D6-4B2A-433C-9184-7C33AD35D001
  GetDataObject 		stdmethod(IDataObjectProvider *THIS, IDataObject **dataObject):HRESULT
  SetDataObject 		stdmethod(IDataObjectProvider *THIS, IDataObject *dataObject):HRESULT
endi

interface IDataTransferManagerInterop extends IUnknown
  GUID				3A3DCD6C-3EAB-43DC-BCDE-45671CE800C8
  GetForWindow			stdmethod(IDataTransferManagerInterop *THIS, HWND appWindow, REFIID riid, void **dataTransferManager):HRESULT
  ShowShareUIForWindow		stdmethod(IDataTransferManagerInterop *THIS, HWND appWindow):HRESULT
endi

interface IFrameworkInputPaneHandler extends IUnknown
  GUID				226C537B-1E76-4D9E-A760-33DB29922F18
  Showing			stdmethod(IFrameworkInputPaneHandler *THIS, RECT *prcInputPaneScreenLocation, BOOL fEnsureFocusedElementInView):HRESULT
  Hiding			stdmethod(IFrameworkInputPaneHandler *THIS, BOOL fEnsureFocusedElementInView):HRESULT
endi

interface IFrameworkInputPane extends IUnknown
  GUID				5752238B-24F0-495A-82F1-2FD593056796
  Advise			stdmethod(IFrameworkInputPane *THIS, IUnknown *pWindow, IFrameworkInputPaneHandler *pHandler, DWORD *pdwCookie):HRESULT
  AdviseWithHWND		stdmethod(IFrameworkInputPane *THIS, HWND hwnd, IFrameworkInputPaneHandler *pHandler, DWORD *pdwCookie):HRESULT
  Unadvise			stdmethod(IFrameworkInputPane *THIS, DWORD dwCookie):HRESULT
  Location			stdmethod(IFrameworkInputPane *THIS, RECT *prcInputPaneScreenLocation):HRESULT
endi

interface IAppVisibilityEvents extends IUnknown
  GUID				6584CE6B-7D82-49C2-89C9-C6BC02BA8C38
  AppVisibilityOnMonitorChanged stdmethod(IAppVisibilityEvents *THIS, HMONITOR hMonitor, MONITOR_APP_VISIBILITY previousMode, MONITOR_APP_VISIBILITY currentMode):HRESULT
  LauncherVisibilityChange	stdmethod(IAppVisibilityEvents *THIS, BOOL currentVisibleState):HRESULT
endi

interface IAppVisibility extends IUnknown
  GUID				2246EA2D-CAEA-4444-A3C4-6DE827E44313
  GetAppVisibilityOnMonitor	stdmethod(IAppVisibility *THIS, HMONITOR hMonitor, MONITOR_APP_VISIBILITY *pMode):HRESULT
  IsLauncherVisible		stdmethod(IAppVisibility *THIS, BOOL *pfVisible):HRESULT
  Advise			stdmethod(IAppVisibility *THIS, IAppVisibilityEvents *pCallback, DWORD *pdwCookie):HRESULT
  Unadvise			stdmethod(IAppVisibility *THIS, DWORD dwCookie):HRESULT
endi

interface IPackageExecutionStateChangeNotification extends IUnknown
  GUID				1BB12A62-2AD8-432B-8CCF-0C2C52AFCD5B
  OnStateChanged		stdmethod(IPackageExecutionStateChangeNotification *THIS, LPCWSTR pszPackageFullName, PACKAGE_EXECUTION_STATE pesNewState):HRESULT
endi

interface IPackageDebugSettings extends IUnknown
  GUID				F27C3930-8029-4AD1-94E3-3DBA417810C1
  EnableDebugging		stdmethod(IPackageDebugSettings *THIS, LPCWSTR packageFullName, LPCWSTR debuggerCommandLine, PZZWSTR environment):HRESULT
  DisableDebugging		stdmethod(IPackageDebugSettings *THIS, LPCWSTR packageFullName):HRESULT
  Suspend			stdmethod(IPackageDebugSettings *THIS, LPCWSTR packageFullName):HRESULT
  Resume			stdmethod(IPackageDebugSettings *THIS, LPCWSTR packageFullName):HRESULT
  TerminateAllProcesses 	stdmethod(IPackageDebugSettings *THIS, LPCWSTR packageFullName):HRESULT
  SetTargetSessionId		stdmethod(IPackageDebugSettings *THIS, ULONG sessionId):HRESULT
  EnumerateBackgroundTasks	stdmethod(IPackageDebugSettings *THIS, LPCWSTR pszPackageFullName, ULONG *taskCount, LPCGUID *taskIds, LPCWSTR **taskNames):HRESULT
  ActivateBackgroundTask	stdmethod(IPackageDebugSettings *THIS, LPCGUID taskId):HRESULT
  StartServicing		stdmethod(IPackageDebugSettings *THIS, LPCWSTR packageFullName):HRESULT
  StopServicing 		stdmethod(IPackageDebugSettings *THIS, LPCWSTR packageFullName):HRESULT
  StartSessionRedirection	stdmethod(IPackageDebugSettings *THIS, LPCWSTR packageFullName, ULONG sessionId):HRESULT
  StopSessionRedirection	stdmethod(IPackageDebugSettings *THIS, LPCWSTR packageFullName):HRESULT
  GetPackageExecutionState	stdmethod(IPackageDebugSettings *THIS, LPCWSTR packageFullName, PACKAGE_EXECUTION_STATE *packageExecutionState):HRESULT
  RegisterForPackageStateChanges stdmethod(IPackageDebugSettings *THIS, LPCWSTR packageFullName, IPackageExecutionStateChangeNotification *pPackageExecutionStateChangeNotification, DWORD *pdwCookie):HRESULT
  UnregisterForPackageStateChanges stdmethod(IPackageDebugSettings *THIS, DWORD dwCookie):HRESULT
endi

interface IPackageDebugSettings2 extends IPackageDebugSettings
  GUID				6E3194BB-AB82-4D22-93F5-FABDA40E7B16
  EnumerateApps 		stdmethod(IPackageDebugSettings2 *THIS, LPCWSTR packageFullName, ULONG *appCount, LPWSTR **appUserModelIds, LPWSTR **appDisplayNames):HRESULT
endi

interface ISuspensionDependencyManager extends IUnknown
  GUID				52B83A42-2543-416A-81D9-C0DE7969C8B3
  RegisterAsChild		stdmethod(ISuspensionDependencyManager *THIS, HANDLE processHandle):HRESULT
  GroupChildWithParent		stdmethod(ISuspensionDependencyManager *THIS, HANDLE childProcessHandle):HRESULT
  UngroupChildFromParent	stdmethod(ISuspensionDependencyManager *THIS, HANDLE childProcessHandle):HRESULT
endi

interface IExecuteCommandApplicationHostEnvironment extends IUnknown
  GUID				18B21AA9-E184-4FF0-9F5E-F882D03771B3
  GetValue			stdmethod(IExecuteCommandApplicationHostEnvironment *THIS, AHE_TYPE *pahe):HRESULT
endi

interface IExecuteCommandHost extends IUnknown
  GUID				4B6832A2-5F04-4C9D-B89D-727A15D103E7
  GetUIMode			stdmethod(IExecuteCommandHost *THIS, EC_HOST_UI_MODE *pUIMode):HRESULT
endi

interface IApplicationDesignModeSettings extends IUnknown
  GUID				2A3DEE9A-E31D-46D6-8508-BCC597DB3557
  SetNativeDisplaySize		stdmethod(IApplicationDesignModeSettings *THIS, SIZE nativeDisplaySizePixels):HRESULT
  SetScaleFactor		stdmethod(IApplicationDesignModeSettings *THIS, DEVICE_SCALE_FACTOR scaleFactor):HRESULT
  SetApplicationViewState	stdmethod(IApplicationDesignModeSettings *THIS, APPLICATION_VIEW_STATE viewState):HRESULT
  ComputeApplicationSize	stdmethod(IApplicationDesignModeSettings *THIS, SIZE *applicationSizePixels):HRESULT
  IsApplicationViewStateSupported stdmethod(IApplicationDesignModeSettings *THIS, APPLICATION_VIEW_STATE viewState, SIZE nativeDisplaySizePixels, DEVICE_SCALE_FACTOR scaleFactor, BOOL *supported):HRESULT
  TriggerEdgeGesture		stdmethod(IApplicationDesignModeSettings *THIS, EDGE_GESTURE_KIND edgeGestureKind):HRESULT
endi

interface IApplicationDesignModeSettings2 extends IApplicationDesignModeSettings
  GUID				490514E1-675A-4D6E-A58D-E54901B4CA2F
  SetNativeDisplayOrientation	stdmethod(IApplicationDesignModeSettings2 *THIS, NATIVE_DISPLAY_ORIENTATION nativeDisplayOrientation):HRESULT
  SetApplicationViewOrientation stdmethod(IApplicationDesignModeSettings2 *THIS, APPLICATION_VIEW_ORIENTATION viewOrientation):HRESULT
  SetAdjacentDisplayEdges	stdmethod(IApplicationDesignModeSettings2 *THIS, ADJACENT_DISPLAY_EDGES adjacentDisplayEdges):HRESULT
  SetIsOnLockScreen		stdmethod(IApplicationDesignModeSettings2 *THIS, BOOL isOnLockScreen):HRESULT
  SetApplicationViewMinWidth	stdmethod(IApplicationDesignModeSettings2 *THIS, APPLICATION_VIEW_MIN_WIDTH viewMinWidth):HRESULT
  GetApplicationSizeBounds	stdmethod(IApplicationDesignModeSettings2 *THIS, SIZE *minApplicationSizePixels, SIZE *maxApplicationSizePixels):HRESULT
  GetApplicationViewOrientation stdmethod(IApplicationDesignModeSettings2 *THIS, SIZE applicationSizePixels, APPLICATION_VIEW_ORIENTATION *viewOrientation):HRESULT
endi

interface ILaunchTargetMonitor extends IUnknown
  GUID				266FBC7E-490D-46ED-A96B-2274DB252003
  GetMonitor			stdmethod(ILaunchTargetMonitor *THIS, HMONITOR *monitor):HRESULT
endi

interface ILaunchSourceViewSizePreference extends IUnknown
  GUID				E5AA01F7-1FB8-4830-8720-4E6734CBD5F3
  GetSourceViewToPosition	stdmethod(ILaunchSourceViewSizePreference *THIS, HWND *hwnd):HRESULT
  GetSourceViewSizePreference	stdmethod(ILaunchSourceViewSizePreference *THIS, APPLICATION_VIEW_SIZE_PREFERENCE *sourceSizeAfterLaunch):HRESULT
endi

interface ILaunchTargetViewSizePreference extends IUnknown
  GUID				2F0666C6-12F7-4360-B511-A394A0553725
  GetTargetViewSizePreference	stdmethod(ILaunchTargetViewSizePreference *THIS, APPLICATION_VIEW_SIZE_PREFERENCE *targetSizeOnLaunch):HRESULT
endi

interface ILaunchSourceAppUserModelId extends IUnknown
  GUID				989191AC-28FF-4CF0-9584-E0D078BC2396
  GetAppUserModelId		stdmethod(ILaunchSourceAppUserModelId *THIS, LPWSTR *launchingApp):HRESULT
endi

interface IInitializeWithWindow extends IUnknown
  GUID				3E68D4BD-7135-4D10-8018-9FB6D9F33FA1
  Initialize			stdmethod(IInitializeWithWindow *THIS, HWND hwnd):HRESULT
endi

interface IHandlerInfo extends IUnknown
  GUID				997706EF-F880-453B-8118-39E1A2D2655A
  GetApplicationDisplayName	stdmethod(IHandlerInfo *THIS, LPWSTR *value):HRESULT
  GetApplicationPublisher	stdmethod(IHandlerInfo *THIS, LPWSTR *value):HRESULT
  GetApplicationIconReference	stdmethod(IHandlerInfo *THIS, LPWSTR *value):HRESULT
endi

interface IHandlerActivationHost extends IUnknown
  GUID				35094A87-8BB1-4237-96C6-C417EEBDB078
  BeforeCoCreateInstance	stdmethod(IHandlerActivationHost *THIS, REFCLSID clsidHandler, IShellItemArray *itemsBeingActivated, IHandlerInfo *handlerInfo):HRESULT
  BeforeCreateProcess		stdmethod(IHandlerActivationHost *THIS, LPCWSTR applicationPath, LPCWSTR commandLine, IHandlerInfo *handlerInfo):HRESULT
endi

interface IAppActivationUIInfo extends IUnknown
  GUID				ABAD189D-9FA3-4278-B3CA-8CA448A88DCB
  GetMonitor			stdmethod(IAppActivationUIInfo *THIS, HMONITOR *value):HRESULT
  GetInvokePoint		stdmethod(IAppActivationUIInfo *THIS, POINT *value):HRESULT
  GetShowCommand		stdmethod(IAppActivationUIInfo *THIS, int *value):HRESULT
  GetShowUI			stdmethod(IAppActivationUIInfo *THIS, BOOL *value):HRESULT
  GetKeyState			stdmethod(IAppActivationUIInfo *THIS, DWORD *value):HRESULT
endi

interface IContactManagerInterop extends IUnknown
  GUID				99EACBA7-E073-43B6-A896-55AFE48A0833
  ShowContactCardForWindow	stdmethod(IContactManagerInterop *THIS, HWND appWindow, IUnknown *contact, RECT *selection, FLYOUT_PLACEMENT preferredPlacement):HRESULT
endi

comobject DesktopWallpaper
  CLSID 			C2CF3110-460E-4fC1-B9D0-8A1C0C9CC4BD
endo

comobject ShellDesktop
  CLSID 			00021400-0000-0000-C000-000000000046
endo

comobject ShellFSFolder
  CLSID 			F3364BA0-65B9-11CE-A9BA-00AA004AE837
endo

comobject NetworkPlaces
  CLSID 			208D2C60-3AEA-1069-A2D7-08002B30309D
endo

comobject ShellLink
  CLSID 			00021401-0000-0000-C000-000000000046
endo

comobject DriveSizeCategorizer
  CLSID 			94357B53-CA29-4B78-83AE-E8FE7409134F
endo

comobject DriveTypeCategorizer
  CLSID 			B0A8F3CF-4333-4BAB-8873-1CCB1CADA48B
endo

comobject FreeSpaceCategorizer
  CLSID 			B5607793-24AC-44C7-82E2-831726AA6CB7
endo

comobject SizeCategorizer
  CLSID 			55D7B852-F6D1-42F2-AA75-8728A1B2D264
endo

comobject PropertiesUI
  CLSID 			D912F8CF-0396-4915-884E-FB425D32943B
endo

comobject UserNotification
  CLSID 			0010890E-8789-413C-ADBC-48F5B511B3AF
endo

comobject TaskbarList
  CLSID 			56FDF344-FD6D-11D0-958A-006097C9A090
endo

comobject ShellItem
  CLSID 			9AC9FBE1-E0A2-4AD6-B4EE-E212013EA917
endo

comobject NamespaceWalker
  CLSID 			72EB61E0-8672-4303-9175-F2E4C68B2E7C
endo

comobject FileOperation
  CLSID 			3AD05575-8857-4850-9277-11B85BDB8E09
endo

comobject FileOpenDialog
  CLSID 			DC1C5A9C-E88A-4dDE-A5A1-60F82A20AEF7
endo

comobject FileSaveDialog
  CLSID 			C0B4E2F3-BA21-4773-8DBA-335EC946EB8B
endo

comobject KnownFolderManager
  CLSID 			4DF0C730-DF9D-4AE3-9153-AA6B82E9795A
endo

comobject SharingConfigurationManager
  CLSID 			49F371E1-8C5C-4D9C-9A3B-54A6827F513C
endo

comobject NetworkConnections
  CLSID 			7007ACC7-3202-11D1-AAD2-00805FC1270E
endo

comobject ScheduledTasks
  CLSID 			D6277990-4C6A-11CF-8D87-00AA0060F5BF
endo

comobject ApplicationAssociationRegistration
  CLSID 			591209C7-767B-42B2-9FBA-44EE4615F2C7
endo

comobject SearchFolderItemFactory
  CLSID 			14010E02-BBBD-41F0-88E3-EDA371216584
endo

comobject OpenControlPanel
  CLSID 			06622D85-6856-4460-8DE1-A81921B41C4B
endo

comobject MailRecipient
  CLSID 			9E56BE60-C50F-11CF-9A2C-00A0C90A90CE
endo

comobject NetworkExplorerFolder
  CLSID 			F02C1A0D-BE21-4350-88B0-7367FC96EF3C
endo

comobject DestinationList
  CLSID 			77F10CF0-3DB5-4966-B520-B7C54FD35ED6
endo

comobject ApplicationDestinations
  CLSID 			86C14003-4D6B-4EF3-A7B4-0506663B2E68
endo

comobject ApplicationDocumentLists
  CLSID 			86BEC222-30F2-47E0-9F25-60D11CD75C28
endo

comobject HomeGroup
  CLSID 			DE77BA04-3C92-4D11-A1A5-42352A53E0E3
endo

comobject ShellLibrary
  CLSID 			D9B3211D-E57F-4426-AAEF-30A806ADD397
endo

comobject AppStartupLink
  CLSID 			273EB5E7-88B0-4843-BFEF-E2C81D43AAE5
endo

comobject EnumerableObjectCollection
  CLSID 			2D3468C1-36A7-43B6-AC24-D3F02FD9607A
endo

comobject FrameworkInputPane
  CLSID 			D5120AA3-46BA-44C5-822D-CA8092C1FC72
endo

comobject DefFolderMenu
  CLSID 			C63382BE-7933-48D0-9AC8-85FB46BE2FDD
endo

comobject AppVisibility
  CLSID 			7E5FE3D9-985F-4908-91F9-EE19F9FD1514
endo

comobject AppShellVerbHandler
  CLSID 			4ED3A719-CEA8-4BD9-910D-E252F997AFC2
endo

comobject ExecuteUnknown
  CLSID 			E44E9428-BDBC-4987-A099-40DC8FD255E7
endo

comobject PackageDebugSettings
  CLSID 			B1AEC16F-2383-4852-B0E9-8F0B1DC66B4D
endo

comobject SuspensionDependencyManager
  CLSID 			6B273FC5-61FD-4918-95A2-C3B5E9D7F581
endo

comobject ApplicationActivationManager
  CLSID 			45BA127D-10A8-46EA-8AB7-56EA9078943C
endo

comobject ApplicationDesignModeSettings
  CLSID 			958A6FB5-DCB2-4FAF-AAFD-7FB054AD1A3B
endo