
; Win64 programming headers (WideChar)

datadef@directives equ db,dw,du,dd,dp,dq,dt
datarsv@directives equ rb,rw,rd,rp,rq,rt
algnmnt@directives equ
def.rb equ db
def.rw equ dw
def.rd equ dd
def.rp equ dp
def.rq equ dq
def.rt equ dt
db.align = 1
dw.align = 2
du.align = 2
dd.align = 4
dq.align = 8

sizeof.PTR =8
struc PTR [value:?] { common . dq value }
macro PTR [value:?] { common dq value }

;====== fundamental macros ======================
include 'generic/macro/struct.inc'
include 'generic/macro/interface.inc'
include 'generic/macro/guid.inc'
;====== OS specific macros ======================
include 'os specific/windows/macro/x86/proc64.inc'
include 'os specific/windows/macro/x86/com64.inc'
;====== file format specific macros =============
include 'file formats/pe coff/macro/import64.inc'
include 'file formats/pe coff/macro/export.inc'
include 'file formats/pe coff/macro/resource.inc'
include 'file formats/pe coff/equates/resource.inc'

struc TCHAR [val:?] { common . du val }
sizeof.TCHAR = 2
struc ACHAR [val:?] { common . db val }
sizeof.ACHAR = 1
struc WCHAR [val:?] { common . du val }
sizeof.WCHAR = 2

;====== fundamental equates =====================
include 'generic/equates/fundamental.inc'
;====== OS specific equates =====================
include 'os specific/windows/equates/windef.inc'
include 'os specific/windows/equates/winver.inc'
include 'os specific/windows/equates/winbase.inc'
include 'os specific/windows/equates/wingdi.inc'
include 'os specific/windows/equates/winuser.inc' ; winuser - next level of abstraction after wingdi
include 'os specific/windows/equates/comctl.inc'    
include 'os specific/windows/equates/comdlg.inc'    
include 'os specific/windows/equates/shell.inc'
include 'os specific/windows/equates/winsock2.inc'
;====== Internet technology equates =============
include 'technologies/internet/equates/socket.inc'
include 'technologies/internet/equates/ipproto.inc'
;====== COM technology equates ==================
include 'os specific/windows/equates/com.inc'
include 'os specific/windows/equates/shobjidl_core.inc'

;====== fundamental structures ==================
include 'generic/structures/coordinates.inc'
;====== OS specific structures ==================
include 'os specific/windows/structures/windef.inc'
include 'os specific/windows/structures/x64/sysinfo.inc'
include 'os specific/windows/structures/x64/processthreads.inc'
include 'os specific/windows/structures/x64/synch.inc'
include 'os specific/windows/structures/x64/winbase.inc'
include 'os specific/windows/structures/x64/wingdi.inc'
include 'os specific/windows/structures/x64/winuser.inc'
include 'os specific/windows/structures/x64/comctl.inc'
include 'os specific/windows/structures/x64/comdlg.inc'
include 'os specific/windows/structures/x64/shell.inc'
include 'os specific/windows/structures/x64/winsock2.inc'
;====== COM technology structures ===============
include 'os specific/windows/structures/x64/objidl.inc'
include 'os specific/windows/structures/x64/shobjidl_core.inc'

;====== COM technology interfaces ===============
include 'os specific/windows/interfaces/iunknwn.inc'
include 'os specific/windows/interfaces/objidl.inc'
include 'os specific/windows/interfaces/shobjidl_core.inc'

macro api [name] { if used name
		    label name qword at name#W
		   end if }