
; WinCE programming headers (WideChar)

datadef@directives equ db,dh,du,dw,dd
datarsv@directives equ rb,rh,rw,rd
def.rb equ db
def.rh equ dh
def.rw equ dw
def.rd equ dd
db.align = 1
dh.align = 2
du.align = 2
dw.align = 4
dd.align = 8

sizeof.PTR =4
struc PTR [value:?] { common . dw value }
macro PTR [value:?] { common dw value }

;====== fundamental macros ======================
include 'generic/macro/struct.inc'
include 'generic/fix/x86ddefonarm/begin.inc'
	include 'generic/macro/x32/interface.inc'
	include 'generic/macro/guid.inc'
include 'generic/fix/x86ddefonarm/end.inc'
;====== OS specific macros ======================
include 'os specific/windows/macro/arm/procaps.inc'
;====== file format specific macros =============
include 'generic/fix/x86ddefonarm/begin.inc'
	include 'file formats/pe coff/macro/import32.inc'
	include 'file formats/pe coff/macro/export.inc'
	include 'file formats/pe coff/macro/resource.inc'
	include 'file formats/pe coff/equates/resource.inc'
;================================================
include 'generic/fix/x86ddefonarm/end.inc'

struc TCHAR [val:?] { common . du val }
sizeof.TCHAR = 2
struc ACHAR [val:?] { common . db val }
sizeof.ACHAR = 1
struc WCHAR [val:?] { common . du val }
sizeof.WCHAR = 2

;====== fundamental equates =====================
include 'generic/equates/fundamental.inc'
;====== OS specific equates =====================
include 'os specific/windows/equates/windef.inc'
include 'os specific/windows/equates/winver.inc'
include 'os specific/windows/equates/winbase.inc'
include 'os specific/windows/equates/wingdi.inc'
include 'os specific/windows/equates/winuser.inc' ; winuser - next level of abstraction after wingdi
include 'os specific/windows/equates/comctl.inc'
include 'os specific/windows/equates/comdlg.inc'
include 'os specific/windows/equates/shell.inc'
include 'os specific/windows/equates/winsock2.inc'
;====== Internet technology equates =============
include 'technologies/internet/equates/socket.inc'
include 'technologies/internet/equates/ipproto.inc'

include 'generic/fix/x86ddefonarm/begin.inc'
;====== fundamental structures ==================
	include 'generic/structures/coordinates.inc'
;====== OS specific structures ==================
	include 'os specific/windows/structures/windef.inc'
	include 'os specific/windows/structures/x32/sysinfo.inc'
	include 'os specific/windows/structures/x32/processthreads.inc'
	include 'os specific/windows/structures/x32/synch.inc'
	include 'os specific/windows/structures/x32/winbase.inc'
	include 'os specific/windows/structures/x32/wingdi.inc'
	include 'os specific/windows/structures/x32/winuser.inc'
	include 'os specific/windows/structures/x32/comctl.inc'
	include 'os specific/windows/structures/x32/comdlg.inc'
	include 'os specific/windows/structures/x32/shell.inc'
	include 'os specific/windows/structures/x32/winsock2.inc'
;====== COM technology structures ===============
	include 'os specific/windows/structures/x32/objidl.inc'
	include 'os specific/windows/structures/x32/shobjidl_core.inc'
;================================================
include 'generic/fix/x86ddefonarm/end.inc'

;====== COM technology interfaces ===============
include 'os specific/windows/interfaces/iunknwn.inc'
include 'os specific/windows/interfaces/objidl.inc'
include 'os specific/windows/interfaces/shobjidl_core.inc'

macro api [name] { if used name
		    label name dword at name#W
		   end if }
